<%@ page import="com.jetbrains.teamcity.ring.auth.build.RingAuthBuildFeature"%>
<%@ page import="com.jetbrains.teamcity.ring.auth.build.RingAuthBuildParameters" %>
<%@ include file="/include.jsp"%>
<%@ taglib prefix="props" tagdir="/WEB-INF/tags/props" %>
<jsp:useBean id="propertiesBean" scope="request" type="jetbrains.buildServer.controllers.BasePropertiesBean"/>
<c:set var="typeKey" value="<%=RingAuthBuildFeature.PARAM_TYPE%>"/>
<c:set var="userType" value="<%=RingAuthBuildFeature.TYPE_USER%>"/>
<c:set var="serviceType" value="<%=RingAuthBuildFeature.TYPE_SERVICE%>"/>
<c:set var="authIdKey" value="<%=RingAuthBuildFeature.PARAM_AUTH_ID%>"/>
<c:set var="pwdKey" value="<%=RingAuthBuildFeature.PARAM_PWD%>"/>
<c:set var="scopeKey" value="<%=RingAuthBuildFeature.PARAM_SCOPE%>"/>

<style type="text/css">
  tr.ringAuthBuildFeatureRow th {
    padding-right: 0;
    width: 11em;
  }

  tr.ringAuthBuildFeatureRow td {
    padding-right: 0;
    vertical-align: top;
  }
</style>

<tr class="ringAuthBuildFeatureRow">
  <th><label for="${typeKey}">Authenticate build as:</label></th>
  <td>
    <props:selectProperty name="${typeKey}" onchange="BS.RingAuthBuildFeature.updateLabels(); return false;">
      <props:option value="${userType}">user</props:option>
      <props:option value="${serviceType}">service</props:option>
    </props:selectProperty>
    <span id="error_${typeKey}" class="error"></span>
  </td>
</tr>
<tr class="ringAuthBuildFeatureRow">
  <th><label for="${authIdKey}" id="authIdLabel"><c:choose><c:when test="${propertiesBean.properties[typeKey] eq userType}">Username</c:when><c:otherwise>Service ID</c:otherwise></c:choose>:</label><l:star/></th>
  <td>
    <props:textProperty name="${authIdKey}" className="longField"/>
    <span id="error_${authIdKey}" class="error"></span>
  </td>
</tr>
<tr class="ringAuthBuildFeatureRow">
  <th><label for="${pwdKey}" id="pwdLabel"><c:choose><c:when test="${propertiesBean.properties[typeKey] eq userType}">Password</c:when><c:otherwise>Service secret</c:otherwise></c:choose>:</label><l:star/></th>
  <td>
    <props:passwordProperty name="${pwdKey}" className="longField"/>
    <span id="error_${pwdKey}" class="error"></span>
  </td>
</tr>
<tr class="ringAuthBuildFeatureRow">
  <th><label for="${scopeKey}">Scope:</label><l:star/></th>
  <td>
    <props:multilineProperty name="${scopeKey}" linkTitle="Specify one service ID or application name per line" cols="50" rows="5" expanded="${true}" className="longField"/>
  </td>
</tr>
<tr class="ringAuthBuildFeatureRow">
  <td colspan="2" class="grayNote">
    <span>Hub authentication token will be available in build via the following parameters:</span>
    <ul style="margin: 1em 0 0 0;">
      <c:forEach items="<%=RingAuthBuildParameters.ALL_PARAMS%>" var="paramName">
        <li><strong><c:out value="${paramName}"/></strong></li>
      </c:forEach>
    </ul>
  </td>
</tr>

<script type="text/javascript">
  BS.RingAuthBuildFeature = {
    updateLabels: function() {
      if ($j("#${typeKey}")[0].value == "${userType}") {
        $j("#authIdLabel")[0].innerHTML = "Username:";
        $j("#pwdLabel")[0].innerHTML = "Password:";
      }
      else {
        $j("#authIdLabel")[0].innerHTML = "Service ID:";
        $j("#pwdLabel")[0].innerHTML = "Service secret:";
      }
    }
  };
</script>
