BS.RingExportDialog = OO.extend(BS.AbstractWebForm, OO.extend(BS.AbstractModalDialog, {
  formElement: function () {
    return $('ringExportForm');
  },

  getContainer: function () {
    return $('ringExportFormDialog');
  },

  savingIndicator: function() {
    return $('ringExportProgress');
  },

  showExportDialog: function () {
    if ($("ringExportDialogProgressRing") != null) {
      BS.ajaxUpdater($("ringExportDialog"), window["base_uri"] + '/hubPlugin/export.html', {
        method: "GET",
        evalScripts: true,
        onComplete: function () {
          $("ringExportButton").disabled = false;
          BS.RingExportDialog.showCentered();
        }
      });
    }

    this.showCentered();

    this.bindCtrlEnterHandler(this.submit.bind(this));

    return false;
  },

  submit: function () {
    BS.FormSaver.save(this, window['base_uri'] + '/hubPlugin/export.html', OO.extend(BS.ErrorsAwareListener, {
      onCompleteSave: function (form, responseXML, err) {
        BS.RingExportDialog.setSaving(false);
        if (!err) {
          err = BS.XMLResponse.processErrors(responseXML, {}, BS.PluginPropertiesForm.propertiesErrorsHandler);
          if (!err) {
            window.location.reload();
            return false;
          }
        }
        BS.RingExportDialog.enable();
        BS.RingExportDialog.showCentered();
        BS.RingExportDialog.focusFirstErrorField();
      }
    }));

    return false;
  },

  _disableElement: function(element) {
    element._disabledLevel = (element._disabledLevel || (BS.Util.isDisabled(element) ? 1 : 0)) + 1;
    element.disabled = true;
  },

  _disableElements: function(form) {
    if (form.__disabled) return;
    var elements = form.getElementsByTagName("input");
    for (var i = 0; i < elements.length; i++) {
      BS.RingExportDialog._disableElement(elements[i]);
    }
    form.__disabled = true;
  },

  _enableElement: function(element) {
    element._disabledLevel = Math.max((element._disabledLevel || 1) - 1, 0);
    if (element._disabledLevel == 0) {
      element.disabled = false;
    }
  },

  _enableElements: function(form) {
    if (!form.__disabled) return;
    var elements = form.getElementsByTagName("input");
    for (var i = 0; i < elements.length; i++) {
      BS.RingExportDialog._enableElement(elements[i]);
    }
    form.__disabled = false;
  },

  _updateExportSettingsForm: function(formId, enable) {
    var form = $(formId);
    if (form == null) return;

    if (enable) {
      BS.RingExportDialog._enableElements(form);
    }
    else {
      BS.RingExportDialog._disableElements(form);
    }
  },

  _userToExportCount: {},
  _groupToExportCount: {},

  _updateExportRoot: function() {
    var groupKey = $("exportUserGroupKey").value;
    var userCount = BS.RingExportDialog._userToExportCount[groupKey] || 0;
    var groupCount = BS.RingExportDialog._groupToExportCount[groupKey] || 0;

    var hasUsers = userCount != 0, hasGroups = groupCount != 0;

    var text = "";
    if (!hasUsers && !hasGroups) {
      text += "No users or user groups";
    }
    if (hasUsers) {
      text += userCount + " user" + (userCount == 1 ? "" : "s");
    }
    if (hasUsers && hasGroups) {
      text += " and ";
    }
    if (hasGroups) {
      text += groupCount + " user group" + (groupCount == 1 ? "" : "s");
    }
    text += (userCount + groupCount == 1 ? " is" : " are") + " to be exported";

    $("itemsToExportDescription").innerHTML = text;

    var exportUsersCheckBox = $("exportUsers");
    var exportGroupsCheckBox = $("exportUserGroups");

    exportUsersCheckBox.checked = hasUsers;
    exportGroupsCheckBox.checked = hasGroups;

    exportUsersCheckBox.disabled = exportGroupsCheckBox.disabled = !hasUsers || !hasGroups;

    BS.RingExportDialog._updateExportSettingsForm('userDetailsExportSettingsForm', hasUsers);
  }
}));
