package com.intellij.hub.auth;

/*Generated by MPS */

import org.jetbrains.annotations.NotNull;
import com.intellij.hub.core.Error;
import com.intellij.hub.auth.oauth2.error.OAuthErrorCode;
import org.jetbrains.annotations.Nullable;
import java.net.URI;

public abstract class OAuthValidationException extends Exception {
  @NotNull
  private final Error error;

  private OAuthValidationException(@NotNull final Error error) {
    super(error.toString());
    this.error = error;
  }

  protected OAuthValidationException(@NotNull OAuthErrorCode code, @Nullable String description, @NotNull String docPrefix) {
    this(code.createError(description, URI.create(Error.OAUTH2_ERROR_PAGE + "#" + docPrefix + "." + code.getASCIICode())));
  }

  public final Error getError() {
    return error;
  }
}
