package com.intellij.hub.auth;

/*Generated by MPS */

import java.util.Date;
import com.intellij.hub.core.Error;
import com.intellij.hub.auth.oauth2.error.OAuthTokenErrorCode;

public class TokenExpiredException extends InvalidTokenException {
  private final Date grantedTill;
  private final Date checkedAt;

  public TokenExpiredException(Date checkedAt, Date grantedTill) {
    super("Token expired. It was granted till " + grantedTill + " and was checked at " + checkedAt);
    this.grantedTill = grantedTill;
    this.checkedAt = checkedAt;
  }

  public Date getGratedTill() {
    return grantedTill;
  }

  public Date getCheckedAt() {
    return checkedAt;
  }

  @Override
  public Error getOAuthError() {
    return OAuthTokenErrorCode.INVALID_GRANT.createError(getMessage());
  }
}
