package com.intellij.hub.auth.oauth2.consumer;

/*Generated by MPS */

import com.intellij.hub.auth.OAuthException;
import com.intellij.hub.core.Error;
import org.jetbrains.annotations.Nullable;
import java.net.URI;

public class OAuth2TokenLoadException extends OAuthException implements Error {
  private final String error;
  private final String description;
  private final String url;
  private final int statusCode;

  public OAuth2TokenLoadException(String error, int statusCode, String description, String url) {
    this(error, statusCode, description, url, null);
  }

  public OAuth2TokenLoadException(String error, int statusCode, String description, String url, Throwable cause) {
    super("Can't load token: " + error + (((description != null && description.length() > 0) ?
      " (" + description + ")" :
      ""
    )), cause);
    this.error = error;
    this.description = description;
    this.url = url;
    this.statusCode = statusCode;
  }

  public OAuth2TokenLoadException(Error error) {
    this(error.getError(), error.getStatusCode(), error.getMessage(), (error.getURI() != null ?
      error.getURI().toASCIIString() :
      null
    ));
  }

  public String getError() {
    return error;
  }

  public String getDescription() {
    return description;
  }

  @Nullable
  public URI getURI() {
    return (url != null ?
      URI.create(url) :
      null
    );
  }

  @Nullable
  public String getDeveloperMessage() {
    return null;
  }

  public int getStatusCode() {
    return statusCode;
  }

  public Error getOAuthError() {
    return this;
  }

  public String getUrl() {
    return url;
  }

  @Nullable
  public String getField() {
    return null;
  }
}
