package com.intellij.hub.auth.oauth2.consumer;

/*Generated by MPS */

import org.jetbrains.annotations.NotNull;
import com.intellij.hub.auth.basic.BasicAuthToken;
import com.intellij.hub.auth.oauth2.token.AccessToken;

public interface TokenLoader {
  @NotNull
  public TokenLoader.TokenData loadAccessToken(@NotNull final BasicAuthToken auth) throws OAuth2TokenLoadException;
  public static final class TokenData {
    private static final int EXPIRATION_GAP = 60 * 1000;

    private volatile AccessToken accessToken;
    private final String rawAccessToken;
    private final String refreshToken;
    private final long expirationTime;

    public TokenData(String accessToken, String refreshToken, long expirationTime) {

      // Some paranoid stuff from Danila Ponomarenko 
      if (accessToken == null) {
        throw new IllegalStateException("Hub returned empty response instead of auth token");
      }

      this.rawAccessToken = accessToken;
      this.refreshToken = refreshToken;
      this.expirationTime = expirationTime;
    }

    public AccessToken getAccessToken() {
      if (accessToken == null) {
        this.accessToken = AccessToken.decode(rawAccessToken);
      }
      return accessToken;
    }

    public String getRawAccessToken() {
      return rawAccessToken;
    }

    public String getRefreshToken() {
      return refreshToken;
    }

    public boolean isExpired() {
      // FIX: we are in troble if expiration is less than EXPIRATION_GAP =( 
      return expirationTime < System.currentTimeMillis() + EXPIRATION_GAP;
    }
  }

}
