package com.intellij.hub.auth.oauth2.error;

/*Generated by MPS */

import org.jetbrains.annotations.NotNull;
import com.intellij.hub.core.Error;
import org.jetbrains.annotations.Nullable;
import java.net.URI;

public enum OAuthAuthErrorCode implements OAuthErrorCode {
  INVALID_REQUEST(400, "invalid_request"),
  UNAUTHORIZED_CLIENT(400, "unauthorized_client", "The client is not authorized to request an authorization entity using this method"),
  ACCESS_DENIED(403, "access_denied", "The resource owner or authorization server denied the request"),
  UNSUPPORTED_RESPONSE_TYPE(400, "unsupported_response_type", "The authorization server does not support obtaining an authorization entity using this method"),
  INVALID_SCOPE(400, "invalid_scope"),
  SERVER_ERROR(500, "server_error", "Internal server error"),
  TEMPORARILY_UNAVAILABLE(503, "temporarily_unavailable");

  private String asciiCode;
  private String description;
  private int statusCode;

  OAuthAuthErrorCode(int statusCode, String asciiCode) {
    this(statusCode, asciiCode, null);
  }

  OAuthAuthErrorCode(int statusCode, String asciiCode, String description) {
    this.asciiCode = asciiCode;
    this.description = description;
    this.statusCode = statusCode;
  }

  public String getASCIICode() {
    return asciiCode;
  }

  public String getDescription() {
    return description;
  }

  public int getStatusCode() {
    return statusCode;
  }

  @NotNull
  public Error createError() {
    return createError(null, null, null);
  }

  @NotNull
  public Error createError(@Nullable String description) {
    return createError(description, null, null);
  }

  @NotNull
  public Error createError(@Nullable String description, @Nullable URI errorUri) {
    return createError(description, null, errorUri);
  }

  @NotNull
  public Error createError(@Nullable String description, @Nullable String devDescription, @Nullable URI errorUri) {
    return new OAuthError(this, description, devDescription, errorUri);
  }
}
