package com.intellij.hub.auth.oauth2.error;

/*Generated by MPS */

import com.intellij.hub.core.Error;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;
import java.net.URI;

public class OAuthError implements Error {
  private final int statusCode;
  @NotNull
  private final String errorCode;
  @Nullable
  private final URI uri;
  @Nullable
  private final String description;
  @Nullable
  private final String devDescription;

  private OAuthError(String errorCode, int statusCode, String description, String devDescription, URI uri) {
    this.errorCode = errorCode;
    this.statusCode = statusCode;
    this.description = description;
    this.devDescription = devDescription;
    this.uri = uri;
  }

  public OAuthError(OAuthErrorCode code, String description, String devDescription, URI uri) {
    this(code.getASCIICode(), code.getStatusCode(), ((description == null || description.length() == 0) ?
      code.getDescription() :
      description
    ), ((devDescription == null || devDescription.length() == 0) ?
      code.getDescription() :
      devDescription
    ), uri);
  }

  public OAuthError(OAuthErrorCode code, String description, URI uri) {
    this(code, description, null, uri);
  }

  @NotNull
  public String getError() {
    return errorCode;
  }

  public int getStatusCode() {
    return statusCode;
  }

  @NotNull
  public String getMessage() {
    return description;
  }

  @Nullable
  public String getDeveloperMessage() {
    return devDescription;
  }

  @Nullable
  public URI getURI() {
    return uri;
  }

  @Nullable
  public String getField() {
    return null;
  }

  @Override
  public String toString() {
    StringBuilder res = new StringBuilder(getError());
    if (description != null) {
      res.append(":").append(description);
    }
    return res.toString();
  }
}
