package com.intellij.hub.auth.oauth2.error;

/*Generated by MPS */

import org.jetbrains.annotations.NotNull;
import com.intellij.hub.core.Error;
import org.jetbrains.annotations.Nullable;
import java.net.URI;

public enum OAuthTokenErrorCode implements OAuthErrorCode {
  INVALID_REQUEST(400, "invalid_request"),
  INVALID_CLIENT(401, "invalid_client"),
  INVALID_GRANT(403, "invalid_grant", "Token is invalid, expired, revoked or was issued to another client"),
  UNAUTHORIZED_CLIENT(403, "unauthorized_client", "The authenticated client is not authorized to use this authorization grant type"),
  UNSUPPORTED_GRANT_TYPE(400, "unsupported_grant_type", "The authorization grant type is not supported by the authorization server"),
  INVALID_SCOPE(400, "invalid_scope");

  private int statusCode;
  private String code;
  private String description;

  OAuthTokenErrorCode(int statusCode, String code) {
    this.code = code;
    this.statusCode = statusCode;
  }

  OAuthTokenErrorCode(int statusCode, String code, String description) {
    this(statusCode, code);
    this.description = description;
  }

  public int getStatusCode() {
    return statusCode;
  }

  public String getASCIICode() {
    return code;
  }

  public String getDescription() {
    return description;
  }

  @NotNull
  public Error createError() {
    return createError(null, null, null);
  }

  @NotNull
  public Error createError(@Nullable String description) {
    return createError(description, null, null);
  }

  @NotNull
  public Error createError(@Nullable String description, @Nullable URI errorUri) {
    return createError(description, null, errorUri);
  }

  @NotNull
  public Error createError(@Nullable String description, @Nullable String devDescription, @Nullable URI errorUri) {
    return new OAuthError(this, description, devDescription, errorUri);
  }
}
