package com.intellij.hub.auth.oauth2.provider;

/*Generated by MPS */

import com.intellij.hub.auth.oauth2.provider.verifier.CompositeVerifier;
import org.jetbrains.annotations.NotNull;
import com.intellij.hub.auth.oauth2.provider.source.DSAPublicKeySource;
import java.util.Arrays;
import com.intellij.hub.auth.oauth2.provider.verifier.TokenVerifier;
import com.intellij.hub.auth.oauth2.provider.verifier.ScopeVerifier;
import com.intellij.hub.auth.oauth2.provider.verifier.ExpirationVerifier;
import com.intellij.hub.auth.oauth2.provider.verifier.SHA1withDSAVerifier;


/**
 * * @author Danila Ponomarenko
 */
public class AccessTokenVerifier extends CompositeVerifier {
  public AccessTokenVerifier(@NotNull String target, @NotNull DSAPublicKeySource publicKeySource) {
    super(Arrays.<TokenVerifier>asList(new ScopeVerifier(target), new ExpirationVerifier(), new SHA1withDSAVerifier(publicKeySource)));
  }
}
