package com.intellij.hub.auth.oauth2.provider.source;

/*Generated by MPS */

import org.jetbrains.annotations.NotNull;
import java.security.interfaces.DSAPublicKey;

public abstract class BaseDSAPublicKeySource implements DSAPublicKeySource {
  public static final String KEY_URL = "/oauth2/key";

  private KeyAndVersion cached;

  public BaseDSAPublicKeySource() {
  }

  @Override
  @NotNull
  public DSAPublicKey getKey() {
    return getKeyAndVersion().getKey();
  }

  @Override
  public int getVersion() {
    return getKeyAndVersion().getVersion();
  }

  @NotNull
  private synchronized KeyAndVersion getKeyAndVersion() {
    if (cached == null) {
      forceUpdate();
    }
    return cached;
  }

  @Override
  public synchronized boolean forceUpdate() {
    final KeyAndVersion oldKey = cached;
    final KeyAndVersion newKey = loadKey();
    cached = newKey;
    return !(newKey.equals(oldKey));
  }

  @NotNull
  protected abstract KeyAndVersion loadKey() throws KeyLoadException;
}
