package com.intellij.hub.auth.oauth2.provider.source;

/*Generated by MPS */

import java.security.interfaces.DSAPublicKey;
import org.jetbrains.annotations.NotNull;
import java.security.KeyFactory;
import java.security.spec.X509EncodedKeySpec;
import javax.xml.bind.DatatypeConverter;
import java.security.spec.InvalidKeySpecException;
import java.security.NoSuchAlgorithmException;


/**
 * * @author Danila Ponomarenko
 */
public final class KeyAndVersion {
  private final DSAPublicKey key;
  private final int version;

  public KeyAndVersion(@NotNull DSAPublicKey key, int version) {
    this.key = key;
    this.version = version;
  }

  @NotNull
  public DSAPublicKey getKey() {
    return key;
  }

  public int getVersion() {
    return version;
  }

  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    KeyAndVersion that = (KeyAndVersion) o;
    return version == that.version && key.equals(that.key);
  }

  @Override
  public int hashCode() {
    int result = key.hashCode();
    result = 31 * result + version;
    return result;
  }

  @NotNull
  public static KeyAndVersion parse(@NotNull String string) {
    final int delimiter = string.indexOf(".");
    final String version = string.substring(0, delimiter);
    final String key = string.substring(delimiter + 1, string.length());
    try {
      final KeyFactory kf = KeyFactory.getInstance(DSAPublicKeySource.DSA_KEY_ALGORITHM);
      final X509EncodedKeySpec keySpec = new X509EncodedKeySpec(DatatypeConverter.parseBase64Binary(key));
      return new KeyAndVersion((DSAPublicKey) kf.generatePublic(keySpec), Integer.valueOf(version));
    } catch (InvalidKeySpecException e) {
      throw new RuntimeException(e);
    } catch (NoSuchAlgorithmException e) {
      throw new RuntimeException(e);
    }
  }
}
