package com.intellij.hub.auth.oauth2.provider.source;

/*Generated by MPS */

import com.intellij.hub.core.Error;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;
import java.net.URI;

public class KeyLoadError implements Error {
  private final int statusCode;
  private final String message;
  private final String devMessage;

  public KeyLoadError(int statusCode, String message, String devMessage) {
    this.statusCode = statusCode;
    this.message = message;
    this.devMessage = devMessage;
  }

  public KeyLoadError(Throwable ex) {
    this(500, ex.getMessage(), (ex.getCause() != null ?
      ex.getCause().getMessage() :
      null
    ));
  }

  @NotNull
  public String getError() {
    return "key_load_error";
  }

  public int getStatusCode() {
    return statusCode;
  }

  @NotNull
  public String getMessage() {
    return message;
  }

  @Nullable
  public String getDeveloperMessage() {
    return devMessage;
  }

  @Nullable
  public URI getURI() {
    return null;
  }

  @Nullable
  public String getField() {
    return null;
  }
}
