package com.intellij.hub.auth.oauth2.provider.verifier;

/*Generated by MPS */

import org.jetbrains.annotations.NotNull;
import java.util.List;
import com.intellij.hub.auth.oauth2.token.AccessToken;
import com.intellij.hub.auth.InvalidTokenException;


/**
 * * @author Danila Ponomarenko
 */
public class CompositeVerifier implements TokenVerifier {
  @NotNull
  private final List<TokenVerifier> verifiers;

  public CompositeVerifier(@NotNull List<TokenVerifier> verifiers) {
    this.verifiers = verifiers;
  }

  @Override
  public void verify(@NotNull AccessToken token) throws InvalidTokenException {
    for (TokenVerifier verifier : verifiers) {
      verifier.verify(token);
    }
  }
}
