package com.intellij.hub.auth.oauth2.provider.verifier;

/*Generated by MPS */

import org.jetbrains.annotations.NotNull;
import com.intellij.hub.auth.oauth2.token.AccessToken;
import com.intellij.hub.auth.TokenExpiredException;
import java.util.Date;


/**
 * * @author Danila Ponomarenko
 */
public class ExpirationVerifier implements TokenVerifier {
  public ExpirationVerifier() {
  }

  @Override
  public void verify(@NotNull AccessToken token) throws TokenExpiredException {
    Date checkedAt = new Date();
    Date grantedTill = token.getExpirationDate();
    if (grantedTill.before(checkedAt)) {
      throw new TokenExpiredException(checkedAt, grantedTill);
    }
  }
}
