package com.intellij.hub.auth.oauth2.provider.verifier;

/*Generated by MPS */

import org.jetbrains.annotations.NotNull;
import com.intellij.hub.auth.oauth2.token.AccessToken;
import com.intellij.hub.auth.InvalidTokenScopeException;


/**
 * * @author Danila Ponomarenko
 */
public class ScopeVerifier implements TokenVerifier {
  private final String scope;

  public ScopeVerifier(String scope) {
    this.scope = scope;
  }

  public ScopeVerifier() {
    this(null);
  }

  public String getScope() {
    return scope;
  }

  @Override
  public void verify(@NotNull AccessToken token) throws InvalidTokenScopeException {
    String requiredScope = getScope();
    String[] allowedScopes = token.getScope();
    for (int i = 0; i < allowedScopes.length; i++) {
      if (allowedScopes[i].equals(requiredScope)) {
        return;
      }
    }
    throw new InvalidTokenScopeException(requiredScope, allowedScopes);
  }
}
