package com.intellij.hub.auth.oauth2.token;

/*Generated by MPS */

import org.jetbrains.annotations.NotNull;
import java.util.regex.Pattern;
import com.intellij.hub.auth.InvalidTokenScopeException;
import java.net.URLEncoder;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;

public class ScopeUtil {
  public static final String SCOPE_DELIMITER = " ";

  @NotNull
  public static String encodeScope(@NotNull String[] scope) {
    if (scope.length <= 0) {
      throw new IllegalArgumentException("Scope can't be empty array");
    }
    StringBuilder builder = new StringBuilder();
    boolean isEmpty = true;
    for (int i = 0; i < scope.length; i++) {
      if (!(isEmpty)) {
        builder.append(SCOPE_DELIMITER);
      }
      builder.append(encode(scope[i]));
      isEmpty = false;
    }
    return builder.toString();
  }

  @NotNull
  public static String[] decodeScope(@NotNull String scope) {
    final String[] parts = scope.split(Pattern.quote(SCOPE_DELIMITER));
    if (parts.length <= 0) {
      throw new InvalidTokenScopeException("Invalid scope data");
    }
    for (int i = 0; i < parts.length; i++) {
      parts[i] = decode(parts[i]);
    }
    return parts;
  }

  public static String encode(String scopeItem) {
    try {
      return URLEncoder.encode(scopeItem, "UTF-8");
    } catch (UnsupportedEncodingException ex) {
      throw new RuntimeException(ex);
    }
  }

  public static String decode(String scopeItem) {
    try {
      return URLDecoder.decode(scopeItem, "UTF-8");
    } catch (UnsupportedEncodingException ex) {
      throw new RuntimeException(ex);
    }
  }
}
