package com.intellij.hub.auth.request;

/*Generated by MPS */


public class AuthRequestParameter {
  public static final String RESPONSE_TYPE = "response_type";
  public static final String CLIENT_ID = "client_id";
  public static final String REDIRECT_URI = "redirect_uri";
  public static final String SCOPE = "scope";
  public static final String STATE = "state";
  public static final String APPROVAL_PROMPT = "approval_prompt";
  public static final String REQUEST_CREDENTIALS = "request_credentials";
  public static final String ACCESS_TYPE = "access_type";
  public static final String MESSAGE = "message";

  public 
  /**
   * SILENT - same as SKIP, but will return back anyway
   * SKIP - if logged in - return, otherwise - force log in as guest, if guest is banned login form shown
   * REQUIRED - force show login form and log out user everywhere
   * DEFAULT - if logged - return, otherwise - show login form
   */
static   enum RequestCredentials {
    SILENT(),
    SKIP(),
    REQUIRED(),
    DEFAULT();

    RequestCredentials() {
    }

    public static AuthRequestParameter.RequestCredentials fromString(String value) {
      if ((value == null || value.length() == 0)) {
        return AuthRequestParameter.RequestCredentials.DEFAULT;
      }
      for (AuthRequestParameter.RequestCredentials credentials : AuthRequestParameter.RequestCredentials.values()) {
        if (eq_l42e3l_a0a0b0a0(credentials.name().toLowerCase(), value.toLowerCase())) {
          return credentials;
        }
      }
      return null;
    }

    private static boolean eq_l42e3l_a0a0b0a0(Object a, Object b) {
      return (a != null ?
        a.equals(b) :
        a == b
      );
    }
  }

  public 
  /**
   * Access types: Online - allows to get token when user online, offline - allows to get refresh tokento request access token when user is not online
   * ONLINE - (default) no refresh token is issued
   * OFFLINE - allows to obtain refresh token
   */
static   enum AccessType {
    ONLINE(),
    OFFLINE();

    AccessType() {
    }

    public static AuthRequestParameter.AccessType fromString(String value) {
      if ((value == null || value.length() == 0)) {
        return AuthRequestParameter.AccessType.ONLINE;
      }
      for (AuthRequestParameter.AccessType type : AuthRequestParameter.AccessType.values()) {
        if (eq_l42e3l_a0a0b0a1(type.name().toLowerCase(), value.toLowerCase())) {
          return type;
        }
      }
      return null;
    }

    private static boolean eq_l42e3l_a0a0b0a1(Object a, Object b) {
      return (a != null ?
        a.equals(b) :
        a == b
      );
    }
  }
}
