package com.intellij.hub.auth.request;

/*Generated by MPS */

import java.util.Map;
import java.util.List;
import java.util.HashMap;
import java.util.Arrays;

public class TokenFormParameter {
  public static final String GRANT_TYPE = "grant_type";
  public static final String SCOPE = "scope";
  public static final String USERNAME = "username";
  public static final String PASSWORD = "password";
  public static final String CODE = "code";
  public static final String REDIRECT_URI = "redirect_uri";
  public static final String REFRESH_TOKEN = "refresh_token";
  public static final String CLIENT_ID = "client_id";
  public static final String CLIENT_SECRET = "client_secret";

  public static TokenFormParameter.ParameterBuilder type(String grantType) {
    return new TokenFormParameter.ParameterBuilder().append(GRANT_TYPE, grantType);
  }

  public static class ParameterBuilder {
    private Map<String, List<String>> params = new HashMap<String, List<String>>(2);

    private ParameterBuilder() {
      // This stuff is not working in JerSey! 
    }

    private TokenFormParameter.ParameterBuilder append(String key, String value) {
      params.put(key, Arrays.asList(value));
      return this;
    }

    public TokenFormParameter.ParameterBuilder scope(String value) {
      List<String> scope = params.get(SCOPE);
      if (scope != null) {
        scope.add(value);
        return this;
      } else {
        return append(SCOPE, value);
      }
    }

    public Map<String, List<String>> build() {
      Map<String, List<String>> map = params;
      params = new HashMap<String, List<String>>(2);
      return map;

    }
  }
}
