package com.intellij.hub.core;

/*Generated by MPS */

import org.jetbrains.annotations.NotNull;
import java.net.URI;
import java.net.URISyntaxException;


/**
 * This helper fixes incorrect urls which doesn't use /api in path path
 */
public class URIHelper {
  private static final String API_PATH = "api";
  private static final String SLASH = "/";

  @NotNull
  public static URI toApiUri(@NotNull URI given) {
    URI result = given;

    String path = given.getPath();
    path = (path == null ?
      "" :
      path
    );

    String[] splitted = path.split(SLASH);
    String lastPart = (splitted.length > 0 ?
      splitted[splitted.length - 1] :
      ""
    );

    if ((lastPart == null || lastPart.length() == 0) || !(lastPart.equalsIgnoreCase(API_PATH))) {
      StringBuilder builder = new StringBuilder(SLASH);
      for (int i = 1; i < splitted.length; i++) {
        builder.append(splitted[i]).append(SLASH);
      }
      try {
        result = new URI(given.getScheme(), given.getAuthority(), builder.toString() + API_PATH, given.getQuery(), given.getFragment());
      } catch (URISyntaxException ex) {
        throw new RuntimeException(ex);
      }
    }
    return result;
  }
}
