package jetbrains.jetpass.api;

/*Generated by MPS */

import jetbrains.jetpass.api.authority.AuthorityHolder;
import jetbrains.jetpass.api.security.Resource;
import jetbrains.jetpass.api.security.Permission;
import jetbrains.jetpass.api.security.Role;
import jetbrains.jetpass.api.authority.UserGroup;
import org.jetbrains.annotations.Nullable;
import jetbrains.jetpass.api.settings.LicenseSettings;

public 
/**
 * * Describes jetPass web application instance
 */
interface Service extends AuthorityHolder, KeyItem {
  public static final String ID_REPLACEMENT_PATTERN = ":id";
  public static final String LOGIN_REPLACEMENT_PATTERN = ":login";
  public static final String NAME_REPLACEMENT_PATTERN = ":name";

  public String getVersion();
  public String getVendor();
  public String getHomeUrl();
  public String getUserUriPattern();
  public String getGroupUriPattern();
  public Iterable<String> getRedirectUris();
  public String getSecret();
  public String getApplicationName();
  public String getIconUrl();
  public Iterable<? extends Resource> getResources();
  public Iterable<? extends Permission> getPermissions();
  public Iterable<? extends Role> getDefaultRoles();
  public Iterable<? extends UserGroup> getHeaderVisibleGroups();
  /**
   * Returns LicenseSettings associated with given service if any
   * 
   * @return service license or null if license is not required
   */
  @Nullable
  public LicenseSettings getLicenseSettings();
  @Deprecated
  public Iterable<? extends ServiceAPI> getApis();
  @Deprecated
  public Boolean isVerified();
  public Boolean isTrusted();
}
