package jetbrains.jetpass.api.authority;

/*Generated by MPS */

import org.jetbrains.annotations.NotNull;
import jetbrains.jetpass.api.authority.profile.Avatar;
import jetbrains.jetpass.api.authority.profile.Contact;
import jetbrains.jetpass.api.authority.details.UserDetails;
import java.util.Calendar;

public 
/**
 * * Represent all available user fields
 */
interface User extends AuthorityHolder {
  /**
   * Returns unique user login.
   * 
   * @return unique user login
   */
  public String getLogin();
  /**
   * * Returns currently selected user avatar
   * * @return avatar - image or reference to userpic
   * * @deprecated use getProfile().getAvatar() instead
   */
  @NotNull
  @Deprecated
  public Avatar getAvatar();
  /**
   * Returns current user profile
   * 
   * @return profile - collection of primary avatar, email, etc.
   */
  public Profile getProfile();
  /**
   * * Returns all contacts that user allowed to use
   * * @return contact which you can contact him or notify
   * * @deprecated use getProfile().getEmail() / getProfile().getJabber() instead
   */
  @Deprecated
  public Iterable<? extends Contact> getContacts();
  public Iterable<? extends UserGroup> getGroups();
  public Iterable<? extends UserDetails> getDetails();
  public Iterable<? extends VCSUserName> getVCSUserNames();
  public Iterable<? extends SshPublicKey> getSshPublicKeys();
  public Boolean isBanned();
  /**
   * If this user is guest or was merged to guest - returns true
   * 
   * @return true if user is guest or aliased to guest
   */
  public Boolean isGuest();
  /**
   * User creation date
   * 
   * @return user creation date
   */
  @NotNull
  public Calendar getCreationTime();
}
