package jetbrains.jetpass.api.authority;

/*Generated by MPS */

import org.jetbrains.annotations.Nullable;
import jetbrains.jetpass.api.security.Space;
import jetbrains.jetpass.api.security.Project;

public 
/**
 * *
 */
interface UserGroup extends AuthorityHolder {
  public String getDescription();
  public String getIconUrl();
  public Boolean isAutoJoin();
  public Boolean isAllUsers();
  public UserGroup getParent();
  public Iterable<? extends UserGroup> getSubgroups();
  /**
   * Returns users which owned by this group only.
   * 'All Users' group doesn't have any own users and will alaways return empty sequence
   * 
   * @return users owned by this particular group, without subgroups
   */
  @Nullable
  public Iterable<? extends User> getOwnUsers();
  /**
   * Returns all users, including sub-groups
   * 
   * @return users of this group and all subgroups
   */
  @Nullable
  public Iterable<? extends User> getUsers();
  public Integer getUserCount();
  @Deprecated
  public Space getSpace();
  public Project getProject();
}
