package jetbrains.jetpass.api.settings;

/*Generated by MPS */

import org.jetbrains.annotations.Nullable;
import java.util.Calendar;

public interface BackupSettings extends Settings {
  @Nullable
  public String getNamePrefix();
  @Nullable
  public String getBackupFolder();
  @Nullable
  public String getArchiveType();
  @Nullable
  public BackupSettings.Status getStatus();
  public Boolean isDatabaseReadonly();
  public static interface Status {
    @Nullable
    public Boolean isInProgress();
    @Nullable
    public Iterable<? extends BackupSettings.Data> getSavedData();
  }

  public static interface Data {
    @Nullable
    public String getName();
    @Nullable
    public Calendar getTimestamp();
  }

  public static   enum ArchiveType {
    ZIP("zip"),
    TAR_GZ("tar.gz");

    private String typeName;

    ArchiveType(String typeName) {
      this.typeName = typeName;
    }

    public String getName() {
      return typeName;
    }

    public static boolean isZipArchive(String type) {
      BackupSettings.ArchiveType t = fromName(type);
      return (t == null ?
        false :
        BackupSettings.ArchiveType.ZIP == t
      );
    }

    public static BackupSettings.ArchiveType getType(String type, BackupSettings.ArchiveType defaultType) {
      BackupSettings.ArchiveType t = fromName(type);
      return (t == null ?
        defaultType :
        t
      );
    }

    public static BackupSettings.ArchiveType fromName(String name) {
      if (name == null) {
        return null;
      }
      for (BackupSettings.ArchiveType t : BackupSettings.ArchiveType.values()) {
        if (t.getName().toLowerCase().equals(name.toLowerCase())) {
          return t;
        }
      }
      return null;
    }

    public static BackupSettings.ArchiveType getType(String type) {
      return getType(type, BackupSettings.ArchiveType.TAR_GZ);
    }
  }

}
