package jetbrains.jetpass.api.settings;

/*Generated by MPS */

import jetbrains.jetpass.api.ssl.SecuredProvider;
import java.util.Properties;

public interface SMTPSettings extends Settings, SecuredProvider {
  public Boolean isEnabled();
  public String getHost();
  public Integer getPort();
  public String getProtocol();
  public String getFrom();
  public String getLogin();
  public String getPassword();
  public static   enum Protocol {
    SMTP("SMTP", "smtp"),
    SMTPS("SMTP+SSL", "smtps"),
    SMTP_TLS("SMTP+TLS", "smtp");

    private String name;
    private String value;

    Protocol(String name, String value) {
      this.name = name;
      this.value = value;
    }

    public void processProps(Properties properties) {
      if (this == SMTPSettings.Protocol.SMTP_TLS) {
        properties.put("mail.smtp.starttls.enable", true);
      }
    }

    public String getName() {
      return name;
    }

    public String getValue() {
      return value;
    }

    public static SMTPSettings.Protocol fromName(String name) {
      if ((name != null && name.length() > 0)) {
        for (SMTPSettings.Protocol protocol : SMTPSettings.Protocol.values()) {
          if (protocol.name.equalsIgnoreCase(name)) {
            return protocol;
          }
        }
      }
      return null;
    }
  }

}
