package jetbrains.jetpass.auth.module.core.rest.client.json;

/*Generated by MPS */

import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAccessType;
import jetbrains.jetpass.rest.dto.AuthmoduleJSON;
import jetbrains.jetpass.auth.module.core.rest.client.api.CoreAuthModule;
import javax.xml.bind.annotation.XmlElement;
import org.jetbrains.annotations.NotNull;
import java.util.List;
import jetbrains.jetpass.rest.dto.UserGroupJSON;
import java.util.ArrayList;
import jetbrains.jetpass.api.authority.UserGroup;
import org.jetbrains.annotations.Nullable;
import javax.xml.bind.annotation.XmlTransient;

@XmlRootElement(name = "coreauthmodule")
@XmlAccessorType(value = XmlAccessType.FIELD)
public class CoreauthmoduleJSON extends AuthmoduleJSON implements CoreAuthModule {
  @XmlElement(name = "registrationEnabled")
  private Boolean registrationEnabled;
  @XmlElement(name = "passwordRestoreEnabled")
  private Boolean passwordRestoreEnabled;
  @XmlElement(name = "captchaEnabled")
  private Boolean captchaEnabled;
  @XmlElement(name = "captchaPublicKey")
  private String captchaPublicKey;
  @XmlElement(name = "captchaPrivateKey")
  private String captchaPrivateKey;

  public CoreauthmoduleJSON() {
  }

  public CoreauthmoduleJSON(@NotNull CoreAuthModule that) {
    this.setId(that.getId());
    this.setAliasIds(that.getAliasIds());
    this.setName(that.getName());
    this.setOrdinal(that.getOrdinal());
    this.setAccountsSize(that.getAccountsSize());
    this.setDisabled(that.isDisabled());
    if (that.getAutoJoinGroups() != null) {
      List<UserGroupJSON> references = new ArrayList<UserGroupJSON>();
      for (UserGroup it : that.getAutoJoinGroups()) {
        UserGroupJSON ref = new UserGroupJSON();
        ref.setId(it.getId());
        references.add(ref);
      }
      this.setAutoJoinGroups(references);
    }
    this.setRegistrationEnabled(that.isRegistrationEnabled());
    this.setPasswordRestoreEnabled(that.isPasswordRestoreEnabled());
    this.setCaptchaEnabled(that.isCaptchaEnabled());
    this.setCaptchaPublicKey(that.getCaptchaPublicKey());
    this.setCaptchaPrivateKey(that.getCaptchaPrivateKey());
  }

  @Nullable
  public Boolean isRegistrationEnabled() {
    return this.registrationEnabled;
  }

  @Nullable
  public Boolean isPasswordRestoreEnabled() {
    return this.passwordRestoreEnabled;
  }

  @Nullable
  public Boolean isCaptchaEnabled() {
    return this.captchaEnabled;
  }

  @Nullable
  public String getCaptchaPublicKey() {
    return this.captchaPublicKey;
  }

  @Nullable
  public String getCaptchaPrivateKey() {
    return this.captchaPrivateKey;
  }

  @XmlTransient
  public void setRegistrationEnabled(@Nullable Boolean registrationEnabled) {
    this.registrationEnabled = registrationEnabled;
  }

  @XmlTransient
  public void setPasswordRestoreEnabled(@Nullable Boolean passwordRestoreEnabled) {
    this.passwordRestoreEnabled = passwordRestoreEnabled;
  }

  @XmlTransient
  public void setCaptchaEnabled(@Nullable Boolean captchaEnabled) {
    this.captchaEnabled = captchaEnabled;
  }

  @XmlTransient
  public void setCaptchaPublicKey(@Nullable String captchaPublicKey) {
    this.captchaPublicKey = captchaPublicKey;
  }

  @XmlTransient
  public void setCaptchaPrivateKey(@Nullable String captchaPrivateKey) {
    this.captchaPrivateKey = captchaPrivateKey;
  }

  @Override
  public String toString() {
    return append(new StringBuilder()).toString();
  }

  public StringBuilder append(StringBuilder builder) {
    builder.append('{');
    appendFields(builder, true);
    builder.append('}');
    return builder;
  }

  protected boolean appendFields(StringBuilder builder, boolean firstProperty) {
    firstProperty = super.appendFields(builder, firstProperty);
    if (this.registrationEnabled != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("registrationEnabled").append("\": ");
      builder.append(this.registrationEnabled);
    }
    if (this.passwordRestoreEnabled != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("passwordRestoreEnabled").append("\": ");
      builder.append(this.passwordRestoreEnabled);
    }
    if (this.captchaEnabled != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("captchaEnabled").append("\": ");
      builder.append(this.captchaEnabled);
    }
    if (this.captchaPublicKey != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("captchaPublicKey").append("\": ");
      builder.append(this.captchaPublicKey);
    }
    if (this.captchaPrivateKey != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("captchaPrivateKey").append("\": ");
      builder.append(this.captchaPrivateKey);
    }
    return firstProperty;
  }
}
