package jetbrains.jetpass.client;

/*Generated by MPS */

import javax.ws.rs.client.WebTarget;
import org.jetbrains.annotations.Nullable;
import com.intellij.hub.auth.oauth2.consumer.TokenHolder;
import org.jetbrains.annotations.NotNull;
import javax.ws.rs.client.Invocation;
import javax.ws.rs.core.MediaType;
import com.intellij.hub.auth.request.Header;
import org.glassfish.jersey.uri.UriComponent;

public abstract class BaseClient {
  protected final WebTarget resource;
  @Nullable
  protected final TokenHolder container;

  protected BaseClient(@NotNull WebTarget resource) {
    this(resource, null);
  }

  protected BaseClient(@NotNull WebTarget resource, @Nullable TokenHolder container) {
    this.resource = resource;
    this.container = container;
  }

  protected WebTarget path(@NotNull String id) {
    return resource.path(id);
  }

  protected WebTarget apply(@Nullable FieldPartial partial, @Nullable BaseFilter filter) {
    WebTarget resource = this.resource;
    if (filter != null) {
      resource = filter.apply(resource);
    }
    if (partial != null) {
      resource = FieldPartial.apply(resource, partial);
    }
    return resource;
  }

  protected WebTarget apply(@Nullable FieldPartial partial) {
    return apply(partial, null);
  }

  protected Invocation.Builder prepare(@NotNull WebTarget resource) {
    Invocation.Builder builder = resource.request(MediaType.APPLICATION_JSON_TYPE);
    if (container != null) {
      Header auth = container.getHeader();
      builder.header(auth.getName(), auth.getValue());
    }
    return builder;
  }

  public static String wrapObject(Object object) {
    return UriComponent.encodeTemplateNames(String.valueOf(object));
  }
}
