package jetbrains.jetpass.client;

/*Generated by MPS */

import java.util.List;
import java.util.Map;
import java.util.LinkedHashMap;
import java.util.ArrayList;

public class BaseField {
  private String name;
  private List<BaseField> subFields;

  public BaseField(String name) {
    this.name = name;
  }

  public String getName() {
    return name;
  }

  protected BaseField copy() {
    return new BaseField(this.getName());
  }

  public BaseField union(BaseField that) {
    if (this.subFields == null || this.subFields.isEmpty()) {
      return that;
    } else if (that.subFields == null || that.subFields.isEmpty()) {
      return this;
    } else {
      BaseField newField = copy();
      Map<String, BaseField> thatSubFields = new LinkedHashMap<String, BaseField>();
      List<BaseField> newSubFields = new ArrayList<BaseField>();
      for (BaseField thatSubField : that.subFields) {
        thatSubFields.put(thatSubField.getName(), thatSubField);
      }
      for (BaseField thisSubField : subFields) {
        BaseField thatSubField = thatSubFields.remove(thisSubField.getName());
        if (thatSubField != null) {
          newSubFields.add(thisSubField.union(thatSubField));
        } else {
          newSubFields.add(thisSubField);
        }
      }
      for (BaseField thatSubField : thatSubFields.values()) {
        newSubFields.add(thatSubField);
      }
      return newField;
    }
  }

  public void append(StringBuilder builder) {
    builder.append(name);
    if (subFields != null && !(subFields.isEmpty())) {
      if (subFields.size() == 1) {
        builder.append('/');
        subFields.get(0).append(builder);
      } else {
        builder.append('(');
        for (int i = 0; i < subFields.size(); i++) {
          if (i > 0) {
            builder.append(',');
          }
          subFields.get(i).append(builder);
        }
        builder.append(')');
      }
    }
  }

  @Override
  public String toString() {
    StringBuilder builder = new StringBuilder(name.length());
    append(builder);
    return builder.toString();
  }

  protected <S extends BaseField> void setSubFields(S... fields) {
    List<BaseField> subFields = null;
    if (fields != null && fields.length > 0) {
      subFields = new ArrayList<BaseField>(fields.length);
      for (BaseField subField : fields) {
        subFields.add(subField);
      }
    }
    this.subFields = subFields;
  }
}
