package jetbrains.jetpass.client;

/*Generated by MPS */

import java.util.List;
import jetbrains.mps.webr.rpc.rest.json.common.runtime.OrderBy;
import java.util.ArrayList;
import javax.ws.rs.core.MultivaluedMap;
import org.glassfish.jersey.internal.util.collection.StringKeyIgnoreCaseMultivaluedMap;
import org.jetbrains.annotations.NotNull;
import jetbrains.mps.webr.rpc.rest.json.common.runtime.SortOrder;
import javax.ws.rs.client.WebTarget;
import java.util.Map;

public abstract class BaseFilter<T extends BaseFilter> {
  private static final String SKIP_KEYWORD = "$skip";
  private static final String TOP_KEYWORD = "$top";
  private static final String QUERY_KEYWORD = "query";
  private static final String ORDER_BY_KEYWORD = "orderBy";

  private Integer skip;
  private Integer top;
  private String query;
  private List<OrderBy> orderBy = new ArrayList<OrderBy>(3);
  private MultivaluedMap<String, String> queryParameters = new StringKeyIgnoreCaseMultivaluedMap<String>();

  public BaseFilter() {
  }

  public T skip(int amount) {
    skip = amount;
    return (T) this;
  }

  public T top(int amount) {
    top = amount;
    return (T) this;
  }

  public T topAll() {
    top = -1;
    return (T) this;
  }

  public T query(String value) {
    query = value;
    return (T) this;
  }

  public T orderBy(@NotNull String value) {
    return orderBy(new OrderBy(value, SortOrder.DEFAULT));
  }

  public T orderBy(@NotNull OrderBy order) {
    orderBy.add(order);
    return (T) this;
  }

  protected void add(final String paramName, Iterable<Object> values) {
    if (values != null) {
      for (Object value : values) {
        queryParameters.add(paramName, BaseClient.wrapObject(value));
      }
    }
  }

  protected void add(final String paramName, Object value) {
    if (paramName != null) {
      queryParameters.add(paramName, BaseClient.wrapObject(value));
    }
  }

  public WebTarget apply(WebTarget resource) {
    resource = queryParam(resource, SKIP_KEYWORD, skip);
    resource = queryParam(resource, TOP_KEYWORD, top);
    if ((query != null && query.length() > 0)) {
      resource = resource.queryParam(QUERY_KEYWORD, BaseClient.wrapObject(query));
    }
    if (!(orderBy.isEmpty())) {
      StringBuilder o = new StringBuilder();
      for (OrderBy order : orderBy) {
        if (o.length() > 0) {
          o.append(",");
        }
        o.append(order);
      }
      resource = resource.queryParam(ORDER_BY_KEYWORD, BaseClient.wrapObject(o));
    }
    for (final Map.Entry<String, List<String>> entry : queryParameters.entrySet()) {
      resource = resource.queryParam(entry.getKey(), entry.getValue().toArray());
    }
    return resource;
  }

  private WebTarget queryParam(WebTarget resource, String queryParameterName, Integer value) {
    if (value != null) {
      resource = resource.queryParam(queryParameterName, BaseClient.wrapObject(value));
    }
    return resource;
  }
}
