package jetbrains.jetpass.client.accounts;

/*Generated by MPS */

import jetbrains.jetpass.client.BaseClient;
import org.jetbrains.annotations.NotNull;
import javax.ws.rs.client.WebTarget;
import com.intellij.hub.auth.oauth2.consumer.TokenHolder;
import org.jetbrains.annotations.Nullable;
import jetbrains.jetpass.client.BaseFilter;
import jetbrains.jetpass.client.FieldPartial;
import jetbrains.jetpass.rest.dto.AuthmoduleJSON;
import javax.ws.rs.client.Entity;
import org.glassfish.jersey.uri.UriComponent;
import javax.ws.rs.WebApplicationException;
import javax.ws.rs.core.Response;
import jetbrains.jetpass.rest.dto.QueryAssistJSON;
import javax.ws.rs.core.GenericType;
import jetbrains.jetpass.rest.dto.DetailsJSON;
import jetbrains.jetpass.rest.dto.CredentialsJSON;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlSeeAlso;
import jetbrains.mps.webr.rpc.rest.json.common.runtime.BasePage;
import javax.xml.bind.annotation.XmlElement;
import java.util.List;
import java.util.ArrayList;
import jetbrains.jetpass.rest.dto.UserGroupJSON;

public class AuthModuleClient extends BaseClient {
  public AuthModuleClient(@NotNull WebTarget rootResource) {
    this(rootResource, null);
  }

  public AuthModuleClient(@NotNull WebTarget rootResource, TokenHolder container) {
    super(rootResource.path("authmodules"), container);
  }

  @NotNull
  public AuthModuleClient.Page getAuthModulePage(@Nullable BaseFilter filter, @Nullable FieldPartial<Partial.Authmodule> partial) {
    return this.prepare(apply(partial, filter)).get(AuthModuleClient.Page.class);
  }

  @NotNull
  public AuthmoduleJSON createAuthModule(@NotNull AuthmoduleJSON entity, @Nullable FieldPartial<Partial.Authmodule> partial) {
    return this.prepare(apply(partial)).post(Entity.json(entity), AuthmoduleJSON.class);
  }

  @Nullable
  public AuthmoduleJSON getAuthModule(@NotNull String authModuleId, @Nullable FieldPartial<Partial.Authmodule> partial) {
    return get(null, authModuleId, partial);
  }

  @Nullable
  public AuthmoduleJSON getAuthModuleByName(@NotNull String name, @Nullable FieldPartial<Partial.Authmodule> partial) {
    return get("byname", name, partial);
  }

  @Nullable
  public AuthmoduleJSON getAuthModuleByUrl(@NotNull String url, @Nullable FieldPartial<Partial.Authmodule> partial) {
    return get("byurl", url, partial);
  }

  private AuthmoduleJSON get(String byproperty, String key, @Nullable FieldPartial<Partial.Authmodule> partial) {
    WebTarget resource = apply(partial);
    if (byproperty != null) {
      resource = resource.path(byproperty);
    }
    resource = resource.path(UriComponent.encode(key, UriComponent.Type.PATH_SEGMENT));
    try {
      return this.prepare(resource).get(AuthmoduleJSON.class);
    } catch (WebApplicationException ex) {
      // Let's do it like in documentation 
      // https://jersey.java.net/nonav/documentation/latest/client-api.html 
      if (ex.getResponse().getStatus() == Response.Status.NOT_FOUND.getStatusCode()) {
        return null;
      }
      // rethrow 
      throw ex;
    }
  }

  public void deleteAuthModule(@NotNull String authModuleId) {
    WebTarget path = path(authModuleId);
    this.prepare(path).delete(AuthmoduleJSON.class);
  }

  public void updateAuthModule(@NotNull String authModuleId, @NotNull AuthmoduleJSON entity) {
    this.prepare(path(authModuleId)).post(Entity.json(entity), AuthmoduleJSON.class);
  }

  public QueryAssistJSON queryAssist(@Nullable String query, @Nullable Integer caret, @Nullable FieldPartial<Partial.QueryAssist> partial) {
    WebTarget resource = this.apply(partial);
    WebTarget r = resource;
    if (query != null) {
      r = r.queryParam("query", BaseClient.wrapObject(query));
    }
    if (caret != null) {
      r = r.queryParam("caret", BaseClient.wrapObject(caret));
    }
    return this.prepare(r.path("queryAssist")).method("GET", new GenericType<QueryAssistJSON>() {
      {
        // Do nothing 
      }
    });
  }

  public DetailsJSON resolve(@NotNull String authModuleId, @NotNull CredentialsJSON entity, @Nullable FieldPartial<Partial.Details> partial) {
    WebTarget resource = this.apply(partial);
    WebTarget r = resource.path(authModuleId);
    return this.prepare(r.path("resolve")).method("POST", Entity.json(entity), new GenericType<DetailsJSON>() {
      {
        // Do nothing 
      }
    });
  }

  @NotNull
  public AuthModuleClient.AutoJoinGroupClient getAutojoingroupsClient(@NotNull String authModuleId) {
    return new AuthModuleClient.AutoJoinGroupClient(path(authModuleId), container);
  }

  @NotNull
  public static AuthModuleClient.Filter filter() {
    return new AuthModuleClient.Filter();
  }

  @XmlRootElement(name = "page")
  @XmlAccessorType(value = XmlAccessType.FIELD)
  @XmlSeeAlso(value = BasePage.class)
  public static class Page extends BasePage<AuthmoduleJSON> {
    @XmlElement(name = "authmodules")
    private List<AuthmoduleJSON> authmodules;

    public Page() {
    }

    @NotNull
    public List<AuthmoduleJSON> getAuthmodules() {
      return getItems();
    }

    @NotNull
    public List<AuthmoduleJSON> getItems() {
      return (authmodules != null ?
        authmodules :
        new ArrayList<AuthmoduleJSON>(0)
      );
    }
  }

  public static class Filter extends BaseFilter<AuthModuleClient.Filter> {
    private Filter() {
    }
  }

  public static class AutoJoinGroupClient extends BaseClient {
    private AutoJoinGroupClient(WebTarget idResource, TokenHolder container) {
      super(idResource.path("autojoingroups"), container);
    }

    @NotNull
    public AuthModuleClient.AutoJoinGroupClient.Page getAutoJoinGroupPage(@Nullable AuthModuleClient.AutoJoinGroupClient.Filter filter, @Nullable FieldPartial<Partial.UserGroup> partial) {
      return this.prepare(apply(partial, filter)).get(AuthModuleClient.AutoJoinGroupClient.Page.class);
    }

    @NotNull
    public UserGroupJSON addAutoJoinGroup(@NotNull UserGroupJSON entity, @Nullable FieldPartial<Partial.UserGroup> partial) {
      return this.prepare(apply(partial)).post(Entity.json(entity), UserGroupJSON.class);
    }

    @NotNull
    public UserGroupJSON getAutoJoinGroup(@NotNull String id, @Nullable FieldPartial<Partial.UserGroup> partial) {
      return this.prepare(apply(partial).path(id)).get(UserGroupJSON.class);
    }

    public void removeAutoJoinGroup(@NotNull String id) {
      this.prepare(path(id)).delete(UserGroupJSON.class);
    }

    @NotNull
    public static AuthModuleClient.AutoJoinGroupClient.Filter filter() {
      return new AuthModuleClient.AutoJoinGroupClient.Filter();
    }

    @XmlRootElement(name = "page")
    @XmlAccessorType(value = XmlAccessType.FIELD)
    @XmlSeeAlso(value = BasePage.class)
    public static class Page extends BasePage<UserGroupJSON> {
      @XmlElement(name = "autojoingroups")
      private List<UserGroupJSON> autojoingroups;

      public Page() {
      }

      @NotNull
      public List<UserGroupJSON> getAutojoingroups() {
        return getItems();
      }

      @NotNull
      public List<UserGroupJSON> getItems() {
        return (autojoingroups != null ?
          autojoingroups :
          new ArrayList<UserGroupJSON>(0)
        );
      }
    }

    public static class Filter extends BaseFilter<AuthModuleClient.AutoJoinGroupClient.Filter> {
      private Filter() {
      }
    }
  }
}
