package jetbrains.jetpass.client.accounts;

/*Generated by MPS */

import jetbrains.jetpass.client.BaseClient;
import org.jetbrains.annotations.NotNull;
import javax.ws.rs.client.WebTarget;
import com.intellij.hub.auth.oauth2.consumer.TokenHolder;
import org.jetbrains.annotations.Nullable;
import jetbrains.jetpass.client.BaseFilter;
import jetbrains.jetpass.client.FieldPartial;
import jetbrains.jetpass.rest.dto.CertificateJSON;
import javax.ws.rs.client.Entity;
import org.glassfish.jersey.uri.UriComponent;
import javax.ws.rs.WebApplicationException;
import javax.ws.rs.core.Response;
import jetbrains.jetpass.rest.dto.QueryAssistJSON;
import javax.ws.rs.core.GenericType;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlSeeAlso;
import jetbrains.mps.webr.rpc.rest.json.common.runtime.BasePage;
import javax.xml.bind.annotation.XmlElement;
import java.util.List;
import java.util.ArrayList;

public class CertificateClient extends BaseClient {
  public CertificateClient(@NotNull WebTarget rootResource) {
    this(rootResource, null);
  }

  public CertificateClient(@NotNull WebTarget rootResource, TokenHolder container) {
    super(rootResource.path("certificates"), container);
  }

  @NotNull
  public CertificateClient.Page getCertificatePage(@Nullable BaseFilter filter, @Nullable FieldPartial<Partial.Certificate> partial) {
    return this.prepare(apply(partial, filter)).get(CertificateClient.Page.class);
  }

  @NotNull
  public CertificateJSON createCertificate(@NotNull CertificateJSON entity, @Nullable FieldPartial<Partial.Certificate> partial) {
    return this.prepare(apply(partial)).post(Entity.json(entity), CertificateJSON.class);
  }

  @Nullable
  public CertificateJSON getCertificate(@NotNull String certificateId, @Nullable FieldPartial<Partial.Certificate> partial) {
    return get(null, certificateId, partial);
  }

  private CertificateJSON get(String byproperty, String key, @Nullable FieldPartial<Partial.Certificate> partial) {
    WebTarget resource = apply(partial);
    if (byproperty != null) {
      resource = resource.path(byproperty);
    }
    resource = resource.path(UriComponent.encode(key, UriComponent.Type.PATH_SEGMENT));
    try {
      return this.prepare(resource).get(CertificateJSON.class);
    } catch (WebApplicationException ex) {
      // Let's do it like in documentation 
      // https://jersey.java.net/nonav/documentation/latest/client-api.html 
      if (ex.getResponse().getStatus() == Response.Status.NOT_FOUND.getStatusCode()) {
        return null;
      }
      // rethrow 
      throw ex;
    }
  }

  public void deleteCertificate(@NotNull String certificateId) {
    WebTarget path = path(certificateId);
    this.prepare(path).delete(CertificateJSON.class);
  }

  public void updateCertificate(@NotNull String certificateId, @NotNull CertificateJSON entity) {
    this.prepare(path(certificateId)).post(Entity.json(entity), CertificateJSON.class);
  }

  public QueryAssistJSON queryAssist(@Nullable String query, @Nullable Integer caret, @Nullable FieldPartial<Partial.QueryAssist> partial) {
    WebTarget resource = this.apply(partial);
    WebTarget r = resource;
    if (query != null) {
      r = r.queryParam("query", BaseClient.wrapObject(query));
    }
    if (caret != null) {
      r = r.queryParam("caret", BaseClient.wrapObject(caret));
    }
    return this.prepare(r.path("queryAssist")).method("GET", new GenericType<QueryAssistJSON>() {
      {
        // Do nothing 
      }
    });
  }

  @NotNull
  public static CertificateClient.Filter filter() {
    return new CertificateClient.Filter();
  }

  @XmlRootElement(name = "page")
  @XmlAccessorType(value = XmlAccessType.FIELD)
  @XmlSeeAlso(value = BasePage.class)
  public static class Page extends BasePage<CertificateJSON> {
    @XmlElement(name = "certificates")
    private List<CertificateJSON> certificates;

    public Page() {
    }

    @NotNull
    public List<CertificateJSON> getCertificates() {
      return getItems();
    }

    @NotNull
    public List<CertificateJSON> getItems() {
      return (certificates != null ?
        certificates :
        new ArrayList<CertificateJSON>(0)
      );
    }
  }

  public static class Filter extends BaseFilter<CertificateClient.Filter> {
    private Filter() {
    }
  }
}
