package jetbrains.jetpass.client.accounts;

/*Generated by MPS */

import jetbrains.jetpass.client.BaseClient;
import org.jetbrains.annotations.NotNull;
import javax.ws.rs.client.WebTarget;
import com.intellij.hub.auth.oauth2.consumer.TokenHolder;
import org.jetbrains.annotations.Nullable;
import jetbrains.jetpass.client.BaseFilter;
import jetbrains.jetpass.client.FieldPartial;
import jetbrains.jetpass.rest.dto.EventJSON;
import org.glassfish.jersey.uri.UriComponent;
import javax.ws.rs.WebApplicationException;
import javax.ws.rs.core.Response;
import jetbrains.jetpass.rest.dto.QueryAssistJSON;
import javax.ws.rs.core.GenericType;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlSeeAlso;
import jetbrains.mps.webr.rpc.rest.json.common.runtime.BasePage;
import javax.xml.bind.annotation.XmlElement;
import java.util.List;
import java.util.ArrayList;

public class EventClient extends BaseClient {
  public EventClient(@NotNull WebTarget rootResource) {
    this(rootResource, null);
  }

  public EventClient(@NotNull WebTarget rootResource, TokenHolder container) {
    super(rootResource.path("events"), container);
  }

  @NotNull
  public EventClient.Page getEventPage(@Nullable BaseFilter filter, @Nullable FieldPartial<Partial.Event> partial) {
    return this.prepare(apply(partial, filter)).get(EventClient.Page.class);
  }

  @Nullable
  public EventJSON getEvent(@NotNull String eventId, @Nullable FieldPartial<Partial.Event> partial) {
    return get(null, eventId, partial);
  }

  private EventJSON get(String byproperty, String key, @Nullable FieldPartial<Partial.Event> partial) {
    WebTarget resource = apply(partial);
    if (byproperty != null) {
      resource = resource.path(byproperty);
    }
    resource = resource.path(UriComponent.encode(key, UriComponent.Type.PATH_SEGMENT));
    try {
      return this.prepare(resource).get(EventJSON.class);
    } catch (WebApplicationException ex) {
      // Let's do it like in documentation 
      // https://jersey.java.net/nonav/documentation/latest/client-api.html 
      if (ex.getResponse().getStatus() == Response.Status.NOT_FOUND.getStatusCode()) {
        return null;
      }
      // rethrow 
      throw ex;
    }
  }

  public void deleteEvent(@NotNull String eventId) {
    WebTarget path = path(eventId);
    this.prepare(path).delete(EventJSON.class);
  }

  public QueryAssistJSON queryAssist(@Nullable String query, @Nullable Integer caret, @Nullable FieldPartial<Partial.QueryAssist> partial) {
    WebTarget resource = this.apply(partial);
    WebTarget r = resource;
    if (query != null) {
      r = r.queryParam("query", BaseClient.wrapObject(query));
    }
    if (caret != null) {
      r = r.queryParam("caret", BaseClient.wrapObject(caret));
    }
    return this.prepare(r.path("queryAssist")).method("GET", new GenericType<QueryAssistJSON>() {
      {
        // Do nothing 
      }
    });
  }

  @NotNull
  public static EventClient.Filter filter() {
    return new EventClient.Filter();
  }

  @XmlRootElement(name = "page")
  @XmlAccessorType(value = XmlAccessType.FIELD)
  @XmlSeeAlso(value = BasePage.class)
  public static class Page extends BasePage<EventJSON> {
    @XmlElement(name = "events")
    private List<EventJSON> events;

    public Page() {
    }

    @NotNull
    public List<EventJSON> getEvents() {
      return getItems();
    }

    @NotNull
    public List<EventJSON> getItems() {
      return (events != null ?
        events :
        new ArrayList<EventJSON>(0)
      );
    }
  }

  public static class Filter extends BaseFilter<EventClient.Filter> {
    private Filter() {
    }
  }
}
