package jetbrains.jetpass.client.accounts;

/*Generated by MPS */

import jetbrains.jetpass.client.BaseClient;
import org.jetbrains.annotations.NotNull;
import javax.ws.rs.client.WebTarget;
import com.intellij.hub.auth.oauth2.consumer.TokenHolder;
import org.jetbrains.annotations.Nullable;
import jetbrains.jetpass.client.BaseFilter;
import jetbrains.jetpass.client.FieldPartial;
import jetbrains.jetpass.data.importing.dto.ImportJSON;
import org.glassfish.jersey.uri.UriComponent;
import javax.ws.rs.WebApplicationException;
import javax.ws.rs.core.Response;
import java.io.InputStream;
import javax.ws.rs.client.Entity;
import javax.ws.rs.core.GenericType;
import jetbrains.jetpass.data.importing.dto.CountersJSON;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlSeeAlso;
import jetbrains.mps.webr.rpc.rest.json.common.runtime.BasePage;
import javax.xml.bind.annotation.XmlElement;
import java.util.List;
import java.util.ArrayList;
import jetbrains.jetpass.data.importing.dto.ConflictJSON;
import jetbrains.jetpass.data.importing.dto.ResolutionJSON;

public class ImportClient extends BaseClient {
  public ImportClient(@NotNull WebTarget rootResource) {
    this(rootResource, null);
  }

  public ImportClient(@NotNull WebTarget rootResource, TokenHolder container) {
    super(rootResource.path("imports"), container);
  }

  @NotNull
  public ImportClient.Page getImportPage(@Nullable BaseFilter filter, @Nullable FieldPartial<Partial.Import> partial) {
    return this.prepare(apply(partial, filter)).get(ImportClient.Page.class);
  }

  @Nullable
  public ImportJSON getImport(@NotNull String importId, @Nullable FieldPartial<Partial.Import> partial) {
    return get(null, importId, partial);
  }

  private ImportJSON get(String byproperty, String key, @Nullable FieldPartial<Partial.Import> partial) {
    WebTarget resource = apply(partial);
    if (byproperty != null) {
      resource = resource.path(byproperty);
    }
    resource = resource.path(UriComponent.encode(key, UriComponent.Type.PATH_SEGMENT));
    try {
      return this.prepare(resource).get(ImportJSON.class);
    } catch (WebApplicationException ex) {
      // Let's do it like in documentation 
      // https://jersey.java.net/nonav/documentation/latest/client-api.html 
      if (ex.getResponse().getStatus() == Response.Status.NOT_FOUND.getStatusCode()) {
        return null;
      }
      // rethrow 
      throw ex;
    }
  }

  public void deleteImport(@NotNull String importId) {
    WebTarget path = path(importId);
    this.prepare(path).delete(ImportJSON.class);
  }

  public ImportJSON createImport(@Nullable String remoteUrl, @Nullable String adminConsoleUrl, @NotNull InputStream entity, @Nullable FieldPartial<Partial.Import> partial) {
    WebTarget resource = this.apply(partial);
    WebTarget r = resource;
    if (remoteUrl != null) {
      r = r.queryParam("remoteUrl", BaseClient.wrapObject(remoteUrl));
    }
    if (adminConsoleUrl != null) {
      r = r.queryParam("adminConsoleUrl", BaseClient.wrapObject(adminConsoleUrl));
    }
    return this.prepare(r.path("")).method("POST", Entity.json(entity), new GenericType<ImportJSON>() {
      {
        // Do nothing 
      }
    });
  }

  public CountersJSON counters(@NotNull String importId, @Nullable FieldPartial<Partial.Counters> partial) {
    WebTarget resource = this.apply(partial);
    WebTarget r = resource.path(importId);
    return this.prepare(r.path("counters")).method("GET", new GenericType<CountersJSON>() {
      {
        // Do nothing 
      }
    });
  }

  public void merge(@NotNull String importId) {
    WebTarget resource = this.apply(null);
    WebTarget r = resource.path(importId);
    this.prepare(r.path("merge")).method("POST");
  }

  @NotNull
  public ImportClient.conflictClient getConflictsClient(@NotNull String importId) {
    return new ImportClient.conflictClient(path(importId), container);
  }

  @NotNull
  public static ImportClient.Filter filter() {
    return new ImportClient.Filter();
  }

  @XmlRootElement(name = "page")
  @XmlAccessorType(value = XmlAccessType.FIELD)
  @XmlSeeAlso(value = BasePage.class)
  public static class Page extends BasePage<ImportJSON> {
    @XmlElement(name = "imports")
    private List<ImportJSON> imports;

    public Page() {
    }

    @NotNull
    public List<ImportJSON> getImports() {
      return getItems();
    }

    @NotNull
    public List<ImportJSON> getItems() {
      return (imports != null ?
        imports :
        new ArrayList<ImportJSON>(0)
      );
    }
  }

  public static class Filter extends BaseFilter<ImportClient.Filter> {
    private Filter() {
    }
  }

  public static class conflictClient extends BaseClient {
    private conflictClient(WebTarget idResource, TokenHolder container) {
      super(idResource.path("conflicts"), container);
    }

    @NotNull
    public ImportClient.conflictClient.Page getconflictPage(@Nullable ImportClient.conflictClient.Filter filter, @Nullable FieldPartial<Partial.Conflict> partial) {
      return this.prepare(apply(partial, filter)).get(ImportClient.conflictClient.Page.class);
    }

    @NotNull
    public ConflictJSON getconflict(@NotNull String id, @Nullable FieldPartial<Partial.Conflict> partial) {
      return this.prepare(apply(partial).path(id)).get(ConflictJSON.class);
    }

    public Response update(@NotNull String conflictId, @NotNull ResolutionJSON entity) {
      WebTarget resource = this.apply(null);
      WebTarget r = resource.path(conflictId);
      return this.prepare(r.path("update")).method("POST", Entity.json(entity), new GenericType<Response>() {
        {
          // Do nothing 
        }
      });
    }

    @NotNull
    public static ImportClient.conflictClient.Filter filter() {
      return new ImportClient.conflictClient.Filter();
    }

    @XmlRootElement(name = "page")
    @XmlAccessorType(value = XmlAccessType.FIELD)
    @XmlSeeAlso(value = BasePage.class)
    public static class Page extends BasePage<ConflictJSON> {
      @XmlElement(name = "conflicts")
      private List<ConflictJSON> conflicts;

      public Page() {
      }

      @NotNull
      public List<ConflictJSON> getConflicts() {
        return getItems();
      }

      @NotNull
      public List<ConflictJSON> getItems() {
        return (conflicts != null ?
          conflicts :
          new ArrayList<ConflictJSON>(0)
        );
      }
    }

    public static class Filter extends BaseFilter<ImportClient.conflictClient.Filter> {
      private Filter() {
      }
    }
  }
}
