package jetbrains.jetpass.client.accounts;

/*Generated by MPS */

import jetbrains.jetpass.client.BaseClient;
import org.jetbrains.annotations.NotNull;
import javax.ws.rs.client.WebTarget;
import com.intellij.hub.auth.oauth2.consumer.TokenHolder;
import org.jetbrains.annotations.Nullable;
import jetbrains.jetpass.client.BaseFilter;
import jetbrains.jetpass.client.FieldPartial;
import jetbrains.jetpass.rest.dto.MetricsJSON;
import org.glassfish.jersey.uri.UriComponent;
import javax.ws.rs.WebApplicationException;
import javax.ws.rs.core.Response;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlSeeAlso;
import jetbrains.mps.webr.rpc.rest.json.common.runtime.BasePage;
import javax.xml.bind.annotation.XmlElement;
import java.util.List;
import java.util.ArrayList;

public class MetricClient extends BaseClient {
  public MetricClient(@NotNull WebTarget rootResource) {
    this(rootResource, null);
  }

  public MetricClient(@NotNull WebTarget rootResource, TokenHolder container) {
    super(rootResource.path("metrics"), container);
  }

  @NotNull
  public MetricClient.Page getMetricPage(@Nullable BaseFilter filter, @Nullable FieldPartial<Partial.Metrics> partial) {
    return this.prepare(apply(partial, filter)).get(MetricClient.Page.class);
  }

  @Nullable
  public MetricsJSON getMetric(@NotNull String metricId, @Nullable FieldPartial<Partial.Metrics> partial) {
    return get(null, metricId, partial);
  }

  private MetricsJSON get(String byproperty, String key, @Nullable FieldPartial<Partial.Metrics> partial) {
    WebTarget resource = apply(partial);
    if (byproperty != null) {
      resource = resource.path(byproperty);
    }
    resource = resource.path(UriComponent.encode(key, UriComponent.Type.PATH_SEGMENT));
    try {
      return this.prepare(resource).get(MetricsJSON.class);
    } catch (WebApplicationException ex) {
      // Let's do it like in documentation 
      // https://jersey.java.net/nonav/documentation/latest/client-api.html 
      if (ex.getResponse().getStatus() == Response.Status.NOT_FOUND.getStatusCode()) {
        return null;
      }
      // rethrow 
      throw ex;
    }
  }

  @NotNull
  public static MetricClient.Filter filter() {
    return new MetricClient.Filter();
  }

  @XmlRootElement(name = "page")
  @XmlAccessorType(value = XmlAccessType.FIELD)
  @XmlSeeAlso(value = BasePage.class)
  public static class Page extends BasePage<MetricsJSON> {
    @XmlElement(name = "metrics")
    private List<MetricsJSON> metrics;

    public Page() {
    }

    @NotNull
    public List<MetricsJSON> getMetrics() {
      return getItems();
    }

    @NotNull
    public List<MetricsJSON> getItems() {
      return (metrics != null ?
        metrics :
        new ArrayList<MetricsJSON>(0)
      );
    }
  }

  public static class Filter extends BaseFilter<MetricClient.Filter> {
    private Filter() {
    }
  }
}
