package jetbrains.jetpass.client.accounts;

/*Generated by MPS */

import jetbrains.jetpass.client.BaseClient;
import org.jetbrains.annotations.NotNull;
import javax.ws.rs.client.WebTarget;
import com.intellij.hub.auth.oauth2.consumer.TokenHolder;
import org.jetbrains.annotations.Nullable;
import jetbrains.jetpass.client.BaseFilter;
import jetbrains.jetpass.client.FieldPartial;
import jetbrains.jetpass.rest.dto.PermissionJSON;
import javax.ws.rs.client.Entity;
import org.glassfish.jersey.uri.UriComponent;
import javax.ws.rs.WebApplicationException;
import javax.ws.rs.core.Response;
import jetbrains.jetpass.rest.dto.QueryAssistJSON;
import javax.ws.rs.core.GenericType;
import java.util.List;
import jetbrains.jetpass.rest.dto.CachedPermissionJSON;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlSeeAlso;
import jetbrains.mps.webr.rpc.rest.json.common.runtime.BasePage;
import javax.xml.bind.annotation.XmlElement;
import java.util.ArrayList;

public class PermissionClient extends BaseClient {
  public PermissionClient(@NotNull WebTarget rootResource) {
    this(rootResource, null);
  }

  public PermissionClient(@NotNull WebTarget rootResource, TokenHolder container) {
    super(rootResource.path("permissions"), container);
  }

  @NotNull
  public PermissionClient.Page getPermissionPage(@Nullable BaseFilter filter, @Nullable FieldPartial<Partial.Permission> partial) {
    return this.prepare(apply(partial, filter)).get(PermissionClient.Page.class);
  }

  @NotNull
  public PermissionJSON createPermission(@NotNull PermissionJSON entity, @Nullable FieldPartial<Partial.Permission> partial) {
    return this.prepare(apply(partial)).post(Entity.json(entity), PermissionJSON.class);
  }

  @Nullable
  public PermissionJSON getPermission(@NotNull String permissionId, @Nullable FieldPartial<Partial.Permission> partial) {
    return get(null, permissionId, partial);
  }

  @Nullable
  public PermissionJSON getPermissionByName(@NotNull String name, @Nullable FieldPartial<Partial.Permission> partial) {
    return get("byname", name, partial);
  }

  private PermissionJSON get(String byproperty, String key, @Nullable FieldPartial<Partial.Permission> partial) {
    WebTarget resource = apply(partial);
    if (byproperty != null) {
      resource = resource.path(byproperty);
    }
    resource = resource.path(UriComponent.encode(key, UriComponent.Type.PATH_SEGMENT));
    try {
      return this.prepare(resource).get(PermissionJSON.class);
    } catch (WebApplicationException ex) {
      // Let's do it like in documentation 
      // https://jersey.java.net/nonav/documentation/latest/client-api.html 
      if (ex.getResponse().getStatus() == Response.Status.NOT_FOUND.getStatusCode()) {
        return null;
      }
      // rethrow 
      throw ex;
    }
  }

  public void deletePermission(@NotNull String permissionId) {
    WebTarget path = path(permissionId);
    this.prepare(path).delete(PermissionJSON.class);
  }

  public void updatePermission(@NotNull String permissionId, @NotNull PermissionJSON entity) {
    this.prepare(path(permissionId)).post(Entity.json(entity), PermissionJSON.class);
  }

  public QueryAssistJSON queryAssist(@Nullable String query, @Nullable Integer caret, @Nullable FieldPartial<Partial.QueryAssist> partial) {
    WebTarget resource = this.apply(partial);
    WebTarget r = resource;
    if (query != null) {
      r = r.queryParam("query", BaseClient.wrapObject(query));
    }
    if (caret != null) {
      r = r.queryParam("caret", BaseClient.wrapObject(caret));
    }
    return this.prepare(r.path("queryAssist")).method("GET", new GenericType<QueryAssistJSON>() {
      {
        // Do nothing 
      }
    });
  }

  public List<CachedPermissionJSON> cache(@Nullable String query, @Nullable String principal, @Nullable FieldPartial<Partial.CachedPermission> partial) {
    WebTarget resource = this.apply(partial);
    WebTarget r = resource;
    if (query != null) {
      r = r.queryParam("query", BaseClient.wrapObject(query));
    }
    if (principal != null) {
      r = r.queryParam("principal", BaseClient.wrapObject(principal));
    }
    return this.prepare(r.path("cache")).method("GET", new GenericType<List<CachedPermissionJSON>>() {
      {
        // Do nothing 
      }
    });
  }

  @NotNull
  public static PermissionClient.Filter filter() {
    return new PermissionClient.Filter();
  }

  @XmlRootElement(name = "page")
  @XmlAccessorType(value = XmlAccessType.FIELD)
  @XmlSeeAlso(value = BasePage.class)
  public static class Page extends BasePage<PermissionJSON> {
    @XmlElement(name = "permissions")
    private List<PermissionJSON> permissions;

    public Page() {
    }

    @NotNull
    public List<PermissionJSON> getPermissions() {
      return getItems();
    }

    @NotNull
    public List<PermissionJSON> getItems() {
      return (permissions != null ?
        permissions :
        new ArrayList<PermissionJSON>(0)
      );
    }
  }

  public static class Filter extends BaseFilter<PermissionClient.Filter> {
    private Filter() {
    }
  }
}
