package jetbrains.jetpass.client.accounts;

/*Generated by MPS */

import jetbrains.jetpass.client.BaseClient;
import org.jetbrains.annotations.NotNull;
import javax.ws.rs.client.WebTarget;
import com.intellij.hub.auth.oauth2.consumer.TokenHolder;
import org.jetbrains.annotations.Nullable;
import jetbrains.jetpass.client.BaseFilter;
import jetbrains.jetpass.client.FieldPartial;
import jetbrains.jetpass.rest.dto.ProjectJSON;
import javax.ws.rs.client.Entity;
import org.glassfish.jersey.uri.UriComponent;
import javax.ws.rs.WebApplicationException;
import javax.ws.rs.core.Response;
import jetbrains.jetpass.rest.dto.QueryAssistJSON;
import javax.ws.rs.core.GenericType;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlSeeAlso;
import jetbrains.mps.webr.rpc.rest.json.common.runtime.BasePage;
import javax.xml.bind.annotation.XmlElement;
import java.util.List;
import java.util.ArrayList;
import jetbrains.jetpass.rest.dto.ResourceJSON;
import jetbrains.jetpass.rest.dto.TeamJSON;

public class ProjectClient extends BaseClient {
  public ProjectClient(@NotNull WebTarget rootResource) {
    this(rootResource, null);
  }

  public ProjectClient(@NotNull WebTarget rootResource, TokenHolder container) {
    super(rootResource.path("projects"), container);
  }

  @NotNull
  public ProjectClient.Page getProjectPage(@Nullable BaseFilter filter, @Nullable FieldPartial<Partial.Project> partial) {
    return this.prepare(apply(partial, filter)).get(ProjectClient.Page.class);
  }

  @NotNull
  public ProjectJSON createProject(@NotNull ProjectJSON entity, @Nullable FieldPartial<Partial.Project> partial) {
    return this.prepare(apply(partial)).post(Entity.json(entity), ProjectJSON.class);
  }

  @Nullable
  public ProjectJSON getProject(@NotNull String projectId, @Nullable FieldPartial<Partial.Project> partial) {
    return get(null, projectId, partial);
  }

  private ProjectJSON get(String byproperty, String key, @Nullable FieldPartial<Partial.Project> partial) {
    WebTarget resource = apply(partial);
    if (byproperty != null) {
      resource = resource.path(byproperty);
    }
    resource = resource.path(UriComponent.encode(key, UriComponent.Type.PATH_SEGMENT));
    try {
      return this.prepare(resource).get(ProjectJSON.class);
    } catch (WebApplicationException ex) {
      // Let's do it like in documentation 
      // https://jersey.java.net/nonav/documentation/latest/client-api.html 
      if (ex.getResponse().getStatus() == Response.Status.NOT_FOUND.getStatusCode()) {
        return null;
      }
      // rethrow 
      throw ex;
    }
  }

  public void deleteProject(@NotNull String projectId, @Nullable String successor) {
    WebTarget path = path(projectId);
    if (successor != null) {
      path = path.queryParam("successor", BaseClient.wrapObject(successor));
    }
    this.prepare(path).delete(ProjectJSON.class);
  }

  public void updateProject(@NotNull String projectId, @NotNull ProjectJSON entity) {
    this.prepare(path(projectId)).post(Entity.json(entity), ProjectJSON.class);
  }

  public QueryAssistJSON queryAssist(@Nullable String query, @Nullable Integer caret, @Nullable FieldPartial<Partial.QueryAssist> partial) {
    WebTarget resource = this.apply(partial);
    WebTarget r = resource;
    if (query != null) {
      r = r.queryParam("query", BaseClient.wrapObject(query));
    }
    if (caret != null) {
      r = r.queryParam("caret", BaseClient.wrapObject(caret));
    }
    return this.prepare(r.path("queryAssist")).method("GET", new GenericType<QueryAssistJSON>() {
      {
        // Do nothing 
      }
    });
  }

  public ProjectJSON global(@Nullable FieldPartial<Partial.Project> partial) {
    WebTarget resource = this.apply(partial);
    WebTarget r = resource;
    return this.prepare(r.path("global")).method("GET", new GenericType<ProjectJSON>() {
      {
        // Do nothing 
      }
    });
  }

  public ProjectJSON merge(@Nullable String key, @Nullable String name, @Nullable String description, @Nullable Boolean archived, @NotNull ProjectJSON[] entity, @Nullable FieldPartial<Partial.Project> partial) {
    WebTarget resource = this.apply(partial);
    WebTarget r = resource;
    if (key != null) {
      r = r.queryParam("key", BaseClient.wrapObject(key));
    }
    if (name != null) {
      r = r.queryParam("name", BaseClient.wrapObject(name));
    }
    if (description != null) {
      r = r.queryParam("description", BaseClient.wrapObject(description));
    }
    if (archived != null) {
      r = r.queryParam("archived", BaseClient.wrapObject(archived));
    }
    return this.prepare(r.path("merge")).method("POST", Entity.json(entity), new GenericType<ProjectJSON>() {
      {
        // Do nothing 
      }
    });
  }

  @NotNull
  public ProjectClient.ResourceClient getResourcesClient(@NotNull String projectId) {
    return new ProjectClient.ResourceClient(path(projectId), container);
  }

  @NotNull
  public ProjectClient.TeamClient getTeamsClient(@NotNull String projectId) {
    return new ProjectClient.TeamClient(path(projectId), container);
  }

  @NotNull
  public static ProjectClient.Filter filter() {
    return new ProjectClient.Filter();
  }

  @XmlRootElement(name = "page")
  @XmlAccessorType(value = XmlAccessType.FIELD)
  @XmlSeeAlso(value = BasePage.class)
  public static class Page extends BasePage<ProjectJSON> {
    @XmlElement(name = "projects")
    private List<ProjectJSON> projects;

    public Page() {
    }

    @NotNull
    public List<ProjectJSON> getProjects() {
      return getItems();
    }

    @NotNull
    public List<ProjectJSON> getItems() {
      return (projects != null ?
        projects :
        new ArrayList<ProjectJSON>(0)
      );
    }
  }

  public static class Filter extends BaseFilter<ProjectClient.Filter> {
    private Filter() {
    }

    public ProjectClient.Filter archived(Boolean archived) {
      add("archived", archived);
      return this;
    }
  }

  public static class ResourceClient extends BaseClient {
    private ResourceClient(WebTarget idResource, TokenHolder container) {
      super(idResource.path("resources"), container);
    }

    @NotNull
    public ProjectClient.ResourceClient.Page getResourcePage(@Nullable ProjectClient.ResourceClient.Filter filter, @Nullable FieldPartial<Partial.Resource> partial) {
      return this.prepare(apply(partial, filter)).get(ProjectClient.ResourceClient.Page.class);
    }

    @NotNull
    public ResourceJSON addResource(@NotNull ResourceJSON entity, @Nullable FieldPartial<Partial.Resource> partial) {
      return this.prepare(apply(partial)).post(Entity.json(entity), ResourceJSON.class);
    }

    @NotNull
    public ResourceJSON getResource(@NotNull String id, @Nullable FieldPartial<Partial.Resource> partial) {
      return this.prepare(apply(partial).path(id)).get(ResourceJSON.class);
    }

    public void removeResource(@NotNull String id) {
      this.prepare(path(id)).delete(ResourceJSON.class);
    }

    @NotNull
    public static ProjectClient.ResourceClient.Filter filter() {
      return new ProjectClient.ResourceClient.Filter();
    }

    @XmlRootElement(name = "page")
    @XmlAccessorType(value = XmlAccessType.FIELD)
    @XmlSeeAlso(value = BasePage.class)
    public static class Page extends BasePage<ResourceJSON> {
      @XmlElement(name = "resources")
      private List<ResourceJSON> resources;

      public Page() {
      }

      @NotNull
      public List<ResourceJSON> getResources() {
        return getItems();
      }

      @NotNull
      public List<ResourceJSON> getItems() {
        return (resources != null ?
          resources :
          new ArrayList<ResourceJSON>(0)
        );
      }
    }

    public static class Filter extends BaseFilter<ProjectClient.ResourceClient.Filter> {
      private Filter() {
      }
    }
  }

  public static class TeamClient extends BaseClient {
    private TeamClient(WebTarget idResource, TokenHolder container) {
      super(idResource.path("teams"), container);
    }

    @NotNull
    public ProjectClient.TeamClient.Page getTeamPage(@Nullable ProjectClient.TeamClient.Filter filter, @Nullable FieldPartial<Partial.Team> partial) {
      return this.prepare(apply(partial, filter)).get(ProjectClient.TeamClient.Page.class);
    }

    @NotNull
    public TeamJSON addTeam(@NotNull TeamJSON entity, @Nullable FieldPartial<Partial.Team> partial) {
      return this.prepare(apply(partial)).post(Entity.json(entity), TeamJSON.class);
    }

    @NotNull
    public TeamJSON getTeam(@NotNull String id, @Nullable FieldPartial<Partial.Team> partial) {
      return this.prepare(apply(partial).path(id)).get(TeamJSON.class);
    }

    public void removeTeam(@NotNull String id) {
      this.prepare(path(id)).delete(TeamJSON.class);
    }

    public TeamJSON whole(@Nullable FieldPartial<Partial.Team> partial) {
      WebTarget resource = this.apply(partial);
      WebTarget r = resource;
      return this.prepare(r.path("whole")).method("GET", new GenericType<TeamJSON>() {
        {
          // Do nothing 
        }
      });
    }

    @NotNull
    public static ProjectClient.TeamClient.Filter filter() {
      return new ProjectClient.TeamClient.Filter();
    }

    @XmlRootElement(name = "page")
    @XmlAccessorType(value = XmlAccessType.FIELD)
    @XmlSeeAlso(value = BasePage.class)
    public static class Page extends BasePage<TeamJSON> {
      @XmlElement(name = "teams")
      private List<TeamJSON> teams;

      public Page() {
      }

      @NotNull
      public List<TeamJSON> getTeams() {
        return getItems();
      }

      @NotNull
      public List<TeamJSON> getItems() {
        return (teams != null ?
          teams :
          new ArrayList<TeamJSON>(0)
        );
      }
    }

    public static class Filter extends BaseFilter<ProjectClient.TeamClient.Filter> {
      private Filter() {
      }
    }
  }
}
