package jetbrains.jetpass.client.accounts;

/*Generated by MPS */

import jetbrains.jetpass.client.BaseClient;
import org.jetbrains.annotations.NotNull;
import javax.ws.rs.client.WebTarget;
import com.intellij.hub.auth.oauth2.consumer.TokenHolder;
import org.jetbrains.annotations.Nullable;
import jetbrains.jetpass.client.BaseFilter;
import jetbrains.jetpass.client.FieldPartial;
import jetbrains.jetpass.rest.dto.ProjectRoleJSON;
import org.glassfish.jersey.uri.UriComponent;
import javax.ws.rs.WebApplicationException;
import javax.ws.rs.core.Response;
import jetbrains.jetpass.rest.dto.QueryAssistJSON;
import javax.ws.rs.core.GenericType;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlSeeAlso;
import jetbrains.mps.webr.rpc.rest.json.common.runtime.BasePage;
import javax.xml.bind.annotation.XmlElement;
import java.util.List;
import java.util.ArrayList;

public class ProjectRoleClient extends BaseClient {
  public ProjectRoleClient(@NotNull WebTarget rootResource) {
    this(rootResource, null);
  }

  public ProjectRoleClient(@NotNull WebTarget rootResource, TokenHolder container) {
    super(rootResource.path("projectroles"), container);
  }

  @NotNull
  public ProjectRoleClient.Page getProjectRolePage(@Nullable BaseFilter filter, @Nullable FieldPartial<Partial.ProjectRole> partial) {
    return this.prepare(apply(partial, filter)).get(ProjectRoleClient.Page.class);
  }

  @Nullable
  public ProjectRoleJSON getProjectRole(@NotNull String projectRoleId, @Nullable FieldPartial<Partial.ProjectRole> partial) {
    return get(null, projectRoleId, partial);
  }

  private ProjectRoleJSON get(String byproperty, String key, @Nullable FieldPartial<Partial.ProjectRole> partial) {
    WebTarget resource = apply(partial);
    if (byproperty != null) {
      resource = resource.path(byproperty);
    }
    resource = resource.path(UriComponent.encode(key, UriComponent.Type.PATH_SEGMENT));
    try {
      return this.prepare(resource).get(ProjectRoleJSON.class);
    } catch (WebApplicationException ex) {
      // Let's do it like in documentation 
      // https://jersey.java.net/nonav/documentation/latest/client-api.html 
      if (ex.getResponse().getStatus() == Response.Status.NOT_FOUND.getStatusCode()) {
        return null;
      }
      // rethrow 
      throw ex;
    }
  }

  public QueryAssistJSON queryAssist(@Nullable String query, @Nullable Integer caret, @Nullable FieldPartial<Partial.QueryAssist> partial) {
    WebTarget resource = this.apply(partial);
    WebTarget r = resource;
    if (query != null) {
      r = r.queryParam("query", BaseClient.wrapObject(query));
    }
    if (caret != null) {
      r = r.queryParam("caret", BaseClient.wrapObject(caret));
    }
    return this.prepare(r.path("queryAssist")).method("GET", new GenericType<QueryAssistJSON>() {
      {
        // Do nothing 
      }
    });
  }

  @NotNull
  public static ProjectRoleClient.Filter filter() {
    return new ProjectRoleClient.Filter();
  }

  @XmlRootElement(name = "page")
  @XmlAccessorType(value = XmlAccessType.FIELD)
  @XmlSeeAlso(value = BasePage.class)
  public static class Page extends BasePage<ProjectRoleJSON> {
    @XmlElement(name = "projectroles")
    private List<ProjectRoleJSON> projectroles;

    public Page() {
    }

    @NotNull
    public List<ProjectRoleJSON> getProjectroles() {
      return getItems();
    }

    @NotNull
    public List<ProjectRoleJSON> getItems() {
      return (projectroles != null ?
        projectroles :
        new ArrayList<ProjectRoleJSON>(0)
      );
    }
  }

  public static class Filter extends BaseFilter<ProjectRoleClient.Filter> {
    private Filter() {
    }
  }
}
