package jetbrains.jetpass.client.accounts;

/*Generated by MPS */

import jetbrains.jetpass.client.BaseClient;
import org.jetbrains.annotations.NotNull;
import javax.ws.rs.client.WebTarget;
import com.intellij.hub.auth.oauth2.consumer.TokenHolder;
import org.jetbrains.annotations.Nullable;
import jetbrains.jetpass.client.BaseFilter;
import jetbrains.jetpass.client.FieldPartial;
import jetbrains.jetpass.rest.dto.ResourceJSON;
import javax.ws.rs.client.Entity;
import org.glassfish.jersey.uri.UriComponent;
import javax.ws.rs.WebApplicationException;
import javax.ws.rs.core.Response;
import jetbrains.jetpass.rest.dto.QueryAssistJSON;
import javax.ws.rs.core.GenericType;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlSeeAlso;
import jetbrains.mps.webr.rpc.rest.json.common.runtime.BasePage;
import javax.xml.bind.annotation.XmlElement;
import java.util.List;
import java.util.ArrayList;

public class ResourceClient extends BaseClient {
  public ResourceClient(@NotNull WebTarget rootResource) {
    this(rootResource, null);
  }

  public ResourceClient(@NotNull WebTarget rootResource, TokenHolder container) {
    super(rootResource.path("resources"), container);
  }

  @NotNull
  public ResourceClient.Page getResourcePage(@Nullable BaseFilter filter, @Nullable FieldPartial<Partial.Resource> partial) {
    return this.prepare(apply(partial, filter)).get(ResourceClient.Page.class);
  }

  @NotNull
  public ResourceJSON createResource(@NotNull ResourceJSON entity, @Nullable FieldPartial<Partial.Resource> partial) {
    return this.prepare(apply(partial)).post(Entity.json(entity), ResourceJSON.class);
  }

  @Nullable
  public ResourceJSON getResource(@NotNull String resourceId, @Nullable FieldPartial<Partial.Resource> partial) {
    return get(null, resourceId, partial);
  }

  @Nullable
  public ResourceJSON getResourceByName(@NotNull String name, @Nullable FieldPartial<Partial.Resource> partial) {
    return get("byname", name, partial);
  }

  private ResourceJSON get(String byproperty, String key, @Nullable FieldPartial<Partial.Resource> partial) {
    WebTarget resource = apply(partial);
    if (byproperty != null) {
      resource = resource.path(byproperty);
    }
    resource = resource.path(UriComponent.encode(key, UriComponent.Type.PATH_SEGMENT));
    try {
      return this.prepare(resource).get(ResourceJSON.class);
    } catch (WebApplicationException ex) {
      // Let's do it like in documentation 
      // https://jersey.java.net/nonav/documentation/latest/client-api.html 
      if (ex.getResponse().getStatus() == Response.Status.NOT_FOUND.getStatusCode()) {
        return null;
      }
      // rethrow 
      throw ex;
    }
  }

  public void deleteResource(@NotNull String resourceId) {
    WebTarget path = path(resourceId);
    this.prepare(path).delete(ResourceJSON.class);
  }

  public void updateResource(@NotNull String resourceId, @NotNull ResourceJSON entity) {
    this.prepare(path(resourceId)).post(Entity.json(entity), ResourceJSON.class);
  }

  public QueryAssistJSON queryAssist(@Nullable String query, @Nullable Integer caret, @Nullable FieldPartial<Partial.QueryAssist> partial) {
    WebTarget resource = this.apply(partial);
    WebTarget r = resource;
    if (query != null) {
      r = r.queryParam("query", BaseClient.wrapObject(query));
    }
    if (caret != null) {
      r = r.queryParam("caret", BaseClient.wrapObject(caret));
    }
    return this.prepare(r.path("queryAssist")).method("GET", new GenericType<QueryAssistJSON>() {
      {
        // Do nothing 
      }
    });
  }

  @NotNull
  public static ResourceClient.Filter filter() {
    return new ResourceClient.Filter();
  }

  @XmlRootElement(name = "page")
  @XmlAccessorType(value = XmlAccessType.FIELD)
  @XmlSeeAlso(value = BasePage.class)
  public static class Page extends BasePage<ResourceJSON> {
    @XmlElement(name = "resources")
    private List<ResourceJSON> resources;

    public Page() {
    }

    @NotNull
    public List<ResourceJSON> getResources() {
      return getItems();
    }

    @NotNull
    public List<ResourceJSON> getItems() {
      return (resources != null ?
        resources :
        new ArrayList<ResourceJSON>(0)
      );
    }
  }

  public static class Filter extends BaseFilter<ResourceClient.Filter> {
    private Filter() {
    }
  }
}
