package jetbrains.jetpass.client.accounts;

/*Generated by MPS */

import jetbrains.jetpass.client.BaseClient;
import org.jetbrains.annotations.NotNull;
import javax.ws.rs.client.WebTarget;
import com.intellij.hub.auth.oauth2.consumer.TokenHolder;
import org.jetbrains.annotations.Nullable;
import jetbrains.jetpass.client.BaseFilter;
import jetbrains.jetpass.client.FieldPartial;
import jetbrains.jetpass.rest.dto.RoleJSON;
import javax.ws.rs.client.Entity;
import org.glassfish.jersey.uri.UriComponent;
import javax.ws.rs.WebApplicationException;
import javax.ws.rs.core.Response;
import jetbrains.jetpass.rest.dto.ServiceJSON;
import javax.ws.rs.core.GenericType;
import jetbrains.jetpass.rest.dto.QueryAssistJSON;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlSeeAlso;
import jetbrains.mps.webr.rpc.rest.json.common.runtime.BasePage;
import javax.xml.bind.annotation.XmlElement;
import java.util.List;
import java.util.ArrayList;
import jetbrains.jetpass.rest.dto.PermissionJSON;

public class RoleClient extends BaseClient {
  public RoleClient(@NotNull WebTarget rootResource) {
    this(rootResource, null);
  }

  public RoleClient(@NotNull WebTarget rootResource, TokenHolder container) {
    super(rootResource.path("roles"), container);
  }

  @NotNull
  public RoleClient.Page getRolePage(@Nullable BaseFilter filter, @Nullable FieldPartial<Partial.Role> partial) {
    return this.prepare(apply(partial, filter)).get(RoleClient.Page.class);
  }

  @NotNull
  public RoleJSON createRole(@NotNull RoleJSON entity, @Nullable FieldPartial<Partial.Role> partial) {
    return this.prepare(apply(partial)).post(Entity.json(entity), RoleJSON.class);
  }

  @Nullable
  public RoleJSON getRole(@NotNull String roleId, @Nullable FieldPartial<Partial.Role> partial) {
    return get(null, roleId, partial);
  }

  @Nullable
  public RoleJSON getRoleByName(@NotNull String name, @Nullable FieldPartial<Partial.Role> partial) {
    return get("byname", name, partial);
  }

  private RoleJSON get(String byproperty, String key, @Nullable FieldPartial<Partial.Role> partial) {
    WebTarget resource = apply(partial);
    if (byproperty != null) {
      resource = resource.path(byproperty);
    }
    resource = resource.path(UriComponent.encode(key, UriComponent.Type.PATH_SEGMENT));
    try {
      return this.prepare(resource).get(RoleJSON.class);
    } catch (WebApplicationException ex) {
      // Let's do it like in documentation 
      // https://jersey.java.net/nonav/documentation/latest/client-api.html 
      if (ex.getResponse().getStatus() == Response.Status.NOT_FOUND.getStatusCode()) {
        return null;
      }
      // rethrow 
      throw ex;
    }
  }

  public void deleteRole(@NotNull String roleId, @Nullable String successor) {
    WebTarget path = path(roleId);
    if (successor != null) {
      path = path.queryParam("successor", BaseClient.wrapObject(successor));
    }
    this.prepare(path).delete(RoleJSON.class);
  }

  public void updateRole(@NotNull String roleId, @NotNull RoleJSON entity) {
    this.prepare(path(roleId)).post(Entity.json(entity), RoleJSON.class);
  }

  public RoleJSON reset(@NotNull String roleId, @NotNull ServiceJSON entity, @Nullable FieldPartial<Partial.Role> partial) {
    WebTarget resource = this.apply(partial);
    WebTarget r = resource.path(roleId);
    return this.prepare(r.path("reset")).method("POST", Entity.json(entity), new GenericType<RoleJSON>() {
      {
        // Do nothing 
      }
    });
  }

  public RoleJSON servicepermissions(@NotNull String roleId, @Nullable Boolean add, @Nullable Boolean remove, @NotNull ServiceJSON entity, @Nullable FieldPartial<Partial.Role> partial) {
    WebTarget resource = this.apply(partial);
    WebTarget r = resource.path(roleId);
    if (add != null) {
      r = r.queryParam("add", BaseClient.wrapObject(add));
    }
    if (remove != null) {
      r = r.queryParam("remove", BaseClient.wrapObject(remove));
    }
    return this.prepare(r.path("servicepermissions")).method("POST", Entity.json(entity), new GenericType<RoleJSON>() {
      {
        // Do nothing 
      }
    });
  }

  public QueryAssistJSON queryAssist(@Nullable String query, @Nullable Integer caret, @Nullable FieldPartial<Partial.QueryAssist> partial) {
    WebTarget resource = this.apply(partial);
    WebTarget r = resource;
    if (query != null) {
      r = r.queryParam("query", BaseClient.wrapObject(query));
    }
    if (caret != null) {
      r = r.queryParam("caret", BaseClient.wrapObject(caret));
    }
    return this.prepare(r.path("queryAssist")).method("GET", new GenericType<QueryAssistJSON>() {
      {
        // Do nothing 
      }
    });
  }

  public RoleJSON merge(@Nullable String key, @Nullable String name, @Nullable String description, @NotNull RoleJSON[] entity, @Nullable FieldPartial<Partial.Role> partial) {
    WebTarget resource = this.apply(partial);
    WebTarget r = resource;
    if (key != null) {
      r = r.queryParam("key", BaseClient.wrapObject(key));
    }
    if (name != null) {
      r = r.queryParam("name", BaseClient.wrapObject(name));
    }
    if (description != null) {
      r = r.queryParam("description", BaseClient.wrapObject(description));
    }
    return this.prepare(r.path("merge")).method("POST", Entity.json(entity), new GenericType<RoleJSON>() {
      {
        // Do nothing 
      }
    });
  }

  @NotNull
  public RoleClient.PermissionClient getPermissionsClient(@NotNull String roleId) {
    return new RoleClient.PermissionClient(path(roleId), container);
  }

  @NotNull
  public static RoleClient.Filter filter() {
    return new RoleClient.Filter();
  }

  @XmlRootElement(name = "page")
  @XmlAccessorType(value = XmlAccessType.FIELD)
  @XmlSeeAlso(value = BasePage.class)
  public static class Page extends BasePage<RoleJSON> {
    @XmlElement(name = "roles")
    private List<RoleJSON> roles;

    public Page() {
    }

    @NotNull
    public List<RoleJSON> getRoles() {
      return getItems();
    }

    @NotNull
    public List<RoleJSON> getItems() {
      return (roles != null ?
        roles :
        new ArrayList<RoleJSON>(0)
      );
    }
  }

  public static class Filter extends BaseFilter<RoleClient.Filter> {
    private Filter() {
    }
  }

  public static class PermissionClient extends BaseClient {
    private PermissionClient(WebTarget idResource, TokenHolder container) {
      super(idResource.path("permissions"), container);
    }

    @NotNull
    public RoleClient.PermissionClient.Page getPermissionPage(@Nullable RoleClient.PermissionClient.Filter filter, @Nullable FieldPartial<Partial.Permission> partial) {
      return this.prepare(apply(partial, filter)).get(RoleClient.PermissionClient.Page.class);
    }

    @NotNull
    public PermissionJSON addPermission(@NotNull PermissionJSON entity, @Nullable FieldPartial<Partial.Permission> partial) {
      return this.prepare(apply(partial)).post(Entity.json(entity), PermissionJSON.class);
    }

    @NotNull
    public PermissionJSON getPermission(@NotNull String id, @Nullable FieldPartial<Partial.Permission> partial) {
      return this.prepare(apply(partial).path(id)).get(PermissionJSON.class);
    }

    public void removePermission(@NotNull String id) {
      this.prepare(path(id)).delete(PermissionJSON.class);
    }

    @NotNull
    public static RoleClient.PermissionClient.Filter filter() {
      return new RoleClient.PermissionClient.Filter();
    }

    @XmlRootElement(name = "page")
    @XmlAccessorType(value = XmlAccessType.FIELD)
    @XmlSeeAlso(value = BasePage.class)
    public static class Page extends BasePage<PermissionJSON> {
      @XmlElement(name = "permissions")
      private List<PermissionJSON> permissions;

      public Page() {
      }

      @NotNull
      public List<PermissionJSON> getPermissions() {
        return getItems();
      }

      @NotNull
      public List<PermissionJSON> getItems() {
        return (permissions != null ?
          permissions :
          new ArrayList<PermissionJSON>(0)
        );
      }
    }

    public static class Filter extends BaseFilter<RoleClient.PermissionClient.Filter> {
      private Filter() {
      }
    }
  }
}
