package jetbrains.jetpass.client.accounts;

/*Generated by MPS */

import jetbrains.jetpass.client.BaseClient;
import org.jetbrains.annotations.NotNull;
import javax.ws.rs.client.WebTarget;
import com.intellij.hub.auth.oauth2.consumer.TokenHolder;
import org.jetbrains.annotations.Nullable;
import jetbrains.jetpass.client.BaseFilter;
import jetbrains.jetpass.client.FieldPartial;
import jetbrains.jetpass.rest.dto.ServiceJSON;
import javax.ws.rs.client.Entity;
import org.glassfish.jersey.uri.UriComponent;
import javax.ws.rs.WebApplicationException;
import javax.ws.rs.core.Response;
import jetbrains.jetpass.rest.dto.QueryAssistJSON;
import javax.ws.rs.core.GenericType;
import java.util.List;
import jetbrains.jetpass.rest.dto.HeaderItemJSON;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlSeeAlso;
import jetbrains.mps.webr.rpc.rest.json.common.runtime.BasePage;
import javax.xml.bind.annotation.XmlElement;
import java.util.ArrayList;
import jetbrains.jetpass.rest.dto.SpaceRoleJSON;
import jetbrains.jetpass.rest.dto.ProjectRoleJSON;
import jetbrains.jetpass.rest.dto.ResourceJSON;
import jetbrains.jetpass.rest.dto.PermissionJSON;
import jetbrains.jetpass.rest.dto.RoleJSON;
import jetbrains.jetpass.rest.dto.UserGroupJSON;

public class ServiceClient extends BaseClient {
  public ServiceClient(@NotNull WebTarget rootResource) {
    this(rootResource, null);
  }

  public ServiceClient(@NotNull WebTarget rootResource, TokenHolder container) {
    super(rootResource.path("services"), container);
  }

  @NotNull
  public ServiceClient.Page getServicePage(@Nullable BaseFilter filter, @Nullable FieldPartial<Partial.Service> partial) {
    return this.prepare(apply(partial, filter)).get(ServiceClient.Page.class);
  }

  @NotNull
  public ServiceJSON createService(@NotNull ServiceJSON entity, @Nullable FieldPartial<Partial.Service> partial) {
    return this.prepare(apply(partial)).post(Entity.json(entity), ServiceJSON.class);
  }

  @Nullable
  public ServiceJSON getService(@NotNull String serviceId, @Nullable FieldPartial<Partial.Service> partial) {
    return get(null, serviceId, partial);
  }

  @Nullable
  public ServiceJSON getServiceByName(@NotNull String name, @Nullable FieldPartial<Partial.Service> partial) {
    return get("byname", name, partial);
  }

  private ServiceJSON get(String byproperty, String key, @Nullable FieldPartial<Partial.Service> partial) {
    WebTarget resource = apply(partial);
    if (byproperty != null) {
      resource = resource.path(byproperty);
    }
    resource = resource.path(UriComponent.encode(key, UriComponent.Type.PATH_SEGMENT));
    try {
      return this.prepare(resource).get(ServiceJSON.class);
    } catch (WebApplicationException ex) {
      // Let's do it like in documentation 
      // https://jersey.java.net/nonav/documentation/latest/client-api.html 
      if (ex.getResponse().getStatus() == Response.Status.NOT_FOUND.getStatusCode()) {
        return null;
      }
      // rethrow 
      throw ex;
    }
  }

  public void deleteService(@NotNull String serviceId) {
    WebTarget path = path(serviceId);
    this.prepare(path).delete(ServiceJSON.class);
  }

  public void updateService(@NotNull String serviceId, @NotNull ServiceJSON entity) {
    this.prepare(path(serviceId)).post(Entity.json(entity), ServiceJSON.class);
  }

  public QueryAssistJSON queryAssist(@Nullable String query, @Nullable Integer caret, @Nullable FieldPartial<Partial.QueryAssist> partial) {
    WebTarget resource = this.apply(partial);
    WebTarget r = resource;
    if (query != null) {
      r = r.queryParam("query", BaseClient.wrapObject(query));
    }
    if (caret != null) {
      r = r.queryParam("caret", BaseClient.wrapObject(caret));
    }
    return this.prepare(r.path("queryAssist")).method("GET", new GenericType<QueryAssistJSON>() {
      {
        // Do nothing 
      }
    });
  }

  public List<HeaderItemJSON> header(@Nullable FieldPartial<Partial.HeaderItem> partial) {
    WebTarget resource = this.apply(partial);
    WebTarget r = resource;
    return this.prepare(r.path("header")).method("GET", new GenericType<List<HeaderItemJSON>>() {
      {
        // Do nothing 
      }
    });
  }

  public ServiceJSON me(@Nullable FieldPartial<Partial.Service> partial) {
    WebTarget resource = this.apply(partial);
    WebTarget r = resource;
    return this.prepare(r.path("me")).method("GET", new GenericType<ServiceJSON>() {
      {
        // Do nothing 
      }
    });
  }

  @NotNull
  @Deprecated
  public ServiceClient.RoleClient getRolesClient(@NotNull String serviceId) {
    return new ServiceClient.RoleClient(path(serviceId), container);
  }

  @NotNull
  public ServiceClient.ProjectRoleClient getProjectrolesClient(@NotNull String serviceId) {
    return new ServiceClient.ProjectRoleClient(path(serviceId), container);
  }

  @NotNull
  public ServiceClient.ResourceClient getResourcesClient(@NotNull String serviceId) {
    return new ServiceClient.ResourceClient(path(serviceId), container);
  }

  @NotNull
  public ServiceClient.PermissionClient getPermissionsClient(@NotNull String serviceId) {
    return new ServiceClient.PermissionClient(path(serviceId), container);
  }

  @NotNull
  public ServiceClient.DefaultRoleClient getDefaultrolesClient(@NotNull String serviceId) {
    return new ServiceClient.DefaultRoleClient(path(serviceId), container);
  }

  @NotNull
  public ServiceClient.HeaderVisibleGroupClient getHeadervisiblegroupsClient(@NotNull String serviceId) {
    return new ServiceClient.HeaderVisibleGroupClient(path(serviceId), container);
  }

  @NotNull
  public static ServiceClient.Filter filter() {
    return new ServiceClient.Filter();
  }

  @XmlRootElement(name = "page")
  @XmlAccessorType(value = XmlAccessType.FIELD)
  @XmlSeeAlso(value = BasePage.class)
  public static class Page extends BasePage<ServiceJSON> {
    @XmlElement(name = "services")
    private List<ServiceJSON> services;

    public Page() {
    }

    @NotNull
    public List<ServiceJSON> getServices() {
      return getItems();
    }

    @NotNull
    public List<ServiceJSON> getItems() {
      return (services != null ?
        services :
        new ArrayList<ServiceJSON>(0)
      );
    }
  }

  public static class Filter extends BaseFilter<ServiceClient.Filter> {
    private Filter() {
    }
  }

  @Deprecated
  public static class RoleClient extends BaseClient {
    @Deprecated
    private RoleClient(WebTarget idResource, TokenHolder container) {
      super(idResource.path("roles"), container);
    }

    @NotNull
    public ServiceClient.RoleClient.Page getRolePage(@Nullable ServiceClient.RoleClient.Filter filter, @Nullable FieldPartial<Partial.SpaceRole> partial) {
      return this.prepare(apply(partial, filter)).get(ServiceClient.RoleClient.Page.class);
    }

    @NotNull
    public SpaceRoleJSON addRole(@NotNull SpaceRoleJSON entity, @Nullable FieldPartial<Partial.SpaceRole> partial) {
      return this.prepare(apply(partial)).post(Entity.json(entity), SpaceRoleJSON.class);
    }

    @NotNull
    public SpaceRoleJSON getRole(@NotNull String id, @Nullable FieldPartial<Partial.SpaceRole> partial) {
      return this.prepare(apply(partial).path(id)).get(SpaceRoleJSON.class);
    }

    public void removeRole(@NotNull String id) {
      this.prepare(path(id)).delete(SpaceRoleJSON.class);
    }

    @NotNull
    public static ServiceClient.RoleClient.Filter filter() {
      return new ServiceClient.RoleClient.Filter();
    }

    @XmlRootElement(name = "page")
    @XmlAccessorType(value = XmlAccessType.FIELD)
    @XmlSeeAlso(value = BasePage.class)
    public static class Page extends BasePage<SpaceRoleJSON> {
      @XmlElement(name = "roles")
      private List<SpaceRoleJSON> roles;

      public Page() {
      }

      @NotNull
      public List<SpaceRoleJSON> getRoles() {
        return getItems();
      }

      @NotNull
      public List<SpaceRoleJSON> getItems() {
        return (roles != null ?
          roles :
          new ArrayList<SpaceRoleJSON>(0)
        );
      }
    }

    public static class Filter extends BaseFilter<ServiceClient.RoleClient.Filter> {
      private Filter() {
      }
    }
  }

  public static class ProjectRoleClient extends BaseClient {
    private ProjectRoleClient(WebTarget idResource, TokenHolder container) {
      super(idResource.path("projectroles"), container);
    }

    @NotNull
    public ServiceClient.ProjectRoleClient.Page getProjectRolePage(@Nullable ServiceClient.ProjectRoleClient.Filter filter, @Nullable FieldPartial<Partial.ProjectRole> partial) {
      return this.prepare(apply(partial, filter)).get(ServiceClient.ProjectRoleClient.Page.class);
    }

    @NotNull
    public ProjectRoleJSON addProjectRole(@NotNull ProjectRoleJSON entity, @Nullable FieldPartial<Partial.ProjectRole> partial) {
      return this.prepare(apply(partial)).post(Entity.json(entity), ProjectRoleJSON.class);
    }

    @NotNull
    public ProjectRoleJSON getProjectRole(@NotNull String id, @Nullable FieldPartial<Partial.ProjectRole> partial) {
      return this.prepare(apply(partial).path(id)).get(ProjectRoleJSON.class);
    }

    public void removeProjectRole(@NotNull String id) {
      this.prepare(path(id)).delete(ProjectRoleJSON.class);
    }

    @NotNull
    public static ServiceClient.ProjectRoleClient.Filter filter() {
      return new ServiceClient.ProjectRoleClient.Filter();
    }

    @XmlRootElement(name = "page")
    @XmlAccessorType(value = XmlAccessType.FIELD)
    @XmlSeeAlso(value = BasePage.class)
    public static class Page extends BasePage<ProjectRoleJSON> {
      @XmlElement(name = "projectroles")
      private List<ProjectRoleJSON> projectroles;

      public Page() {
      }

      @NotNull
      public List<ProjectRoleJSON> getProjectroles() {
        return getItems();
      }

      @NotNull
      public List<ProjectRoleJSON> getItems() {
        return (projectroles != null ?
          projectroles :
          new ArrayList<ProjectRoleJSON>(0)
        );
      }
    }

    public static class Filter extends BaseFilter<ServiceClient.ProjectRoleClient.Filter> {
      private Filter() {
      }
    }
  }

  public static class ResourceClient extends BaseClient {
    private ResourceClient(WebTarget idResource, TokenHolder container) {
      super(idResource.path("resources"), container);
    }

    @NotNull
    public ServiceClient.ResourceClient.Page getResourcePage(@Nullable ServiceClient.ResourceClient.Filter filter, @Nullable FieldPartial<Partial.Resource> partial) {
      return this.prepare(apply(partial, filter)).get(ServiceClient.ResourceClient.Page.class);
    }

    @NotNull
    public ResourceJSON addResource(@NotNull ResourceJSON entity, @Nullable FieldPartial<Partial.Resource> partial) {
      return this.prepare(apply(partial)).post(Entity.json(entity), ResourceJSON.class);
    }

    @NotNull
    public ResourceJSON getResource(@NotNull String id, @Nullable FieldPartial<Partial.Resource> partial) {
      return this.prepare(apply(partial).path(id)).get(ResourceJSON.class);
    }

    public void removeResource(@NotNull String id) {
      this.prepare(path(id)).delete(ResourceJSON.class);
    }

    @NotNull
    public static ServiceClient.ResourceClient.Filter filter() {
      return new ServiceClient.ResourceClient.Filter();
    }

    @XmlRootElement(name = "page")
    @XmlAccessorType(value = XmlAccessType.FIELD)
    @XmlSeeAlso(value = BasePage.class)
    public static class Page extends BasePage<ResourceJSON> {
      @XmlElement(name = "resources")
      private List<ResourceJSON> resources;

      public Page() {
      }

      @NotNull
      public List<ResourceJSON> getResources() {
        return getItems();
      }

      @NotNull
      public List<ResourceJSON> getItems() {
        return (resources != null ?
          resources :
          new ArrayList<ResourceJSON>(0)
        );
      }
    }

    public static class Filter extends BaseFilter<ServiceClient.ResourceClient.Filter> {
      private Filter() {
      }
    }
  }

  public static class PermissionClient extends BaseClient {
    private PermissionClient(WebTarget idResource, TokenHolder container) {
      super(idResource.path("permissions"), container);
    }

    @NotNull
    public ServiceClient.PermissionClient.Page getPermissionPage(@Nullable ServiceClient.PermissionClient.Filter filter, @Nullable FieldPartial<Partial.Permission> partial) {
      return this.prepare(apply(partial, filter)).get(ServiceClient.PermissionClient.Page.class);
    }

    @NotNull
    public PermissionJSON addPermission(@NotNull PermissionJSON entity, @Nullable FieldPartial<Partial.Permission> partial) {
      return this.prepare(apply(partial)).post(Entity.json(entity), PermissionJSON.class);
    }

    @NotNull
    public PermissionJSON getPermission(@NotNull String id, @Nullable FieldPartial<Partial.Permission> partial) {
      return this.prepare(apply(partial).path(id)).get(PermissionJSON.class);
    }

    public void removePermission(@NotNull String id) {
      this.prepare(path(id)).delete(PermissionJSON.class);
    }

    @NotNull
    public static ServiceClient.PermissionClient.Filter filter() {
      return new ServiceClient.PermissionClient.Filter();
    }

    @XmlRootElement(name = "page")
    @XmlAccessorType(value = XmlAccessType.FIELD)
    @XmlSeeAlso(value = BasePage.class)
    public static class Page extends BasePage<PermissionJSON> {
      @XmlElement(name = "permissions")
      private List<PermissionJSON> permissions;

      public Page() {
      }

      @NotNull
      public List<PermissionJSON> getPermissions() {
        return getItems();
      }

      @NotNull
      public List<PermissionJSON> getItems() {
        return (permissions != null ?
          permissions :
          new ArrayList<PermissionJSON>(0)
        );
      }
    }

    public static class Filter extends BaseFilter<ServiceClient.PermissionClient.Filter> {
      private Filter() {
      }
    }
  }

  public static class DefaultRoleClient extends BaseClient {
    private DefaultRoleClient(WebTarget idResource, TokenHolder container) {
      super(idResource.path("defaultroles"), container);
    }

    @NotNull
    public ServiceClient.DefaultRoleClient.Page getDefaultRolePage(@Nullable ServiceClient.DefaultRoleClient.Filter filter, @Nullable FieldPartial<Partial.Role> partial) {
      return this.prepare(apply(partial, filter)).get(ServiceClient.DefaultRoleClient.Page.class);
    }

    @NotNull
    public RoleJSON addDefaultRole(@NotNull RoleJSON entity, @Nullable FieldPartial<Partial.Role> partial) {
      return this.prepare(apply(partial)).post(Entity.json(entity), RoleJSON.class);
    }

    @NotNull
    public RoleJSON getDefaultRole(@NotNull String id, @Nullable FieldPartial<Partial.Role> partial) {
      return this.prepare(apply(partial).path(id)).get(RoleJSON.class);
    }

    public void removeDefaultRole(@NotNull String id) {
      this.prepare(path(id)).delete(RoleJSON.class);
    }

    @NotNull
    public static ServiceClient.DefaultRoleClient.Filter filter() {
      return new ServiceClient.DefaultRoleClient.Filter();
    }

    @XmlRootElement(name = "page")
    @XmlAccessorType(value = XmlAccessType.FIELD)
    @XmlSeeAlso(value = BasePage.class)
    public static class Page extends BasePage<RoleJSON> {
      @XmlElement(name = "defaultroles")
      private List<RoleJSON> defaultroles;

      public Page() {
      }

      @NotNull
      public List<RoleJSON> getDefaultroles() {
        return getItems();
      }

      @NotNull
      public List<RoleJSON> getItems() {
        return (defaultroles != null ?
          defaultroles :
          new ArrayList<RoleJSON>(0)
        );
      }
    }

    public static class Filter extends BaseFilter<ServiceClient.DefaultRoleClient.Filter> {
      private Filter() {
      }
    }
  }

  public static class HeaderVisibleGroupClient extends BaseClient {
    private HeaderVisibleGroupClient(WebTarget idResource, TokenHolder container) {
      super(idResource.path("headervisiblegroups"), container);
    }

    @NotNull
    public ServiceClient.HeaderVisibleGroupClient.Page getHeaderVisibleGroupPage(@Nullable ServiceClient.HeaderVisibleGroupClient.Filter filter, @Nullable FieldPartial<Partial.UserGroup> partial) {
      return this.prepare(apply(partial, filter)).get(ServiceClient.HeaderVisibleGroupClient.Page.class);
    }

    @NotNull
    public UserGroupJSON addHeaderVisibleGroup(@NotNull UserGroupJSON entity, @Nullable FieldPartial<Partial.UserGroup> partial) {
      return this.prepare(apply(partial)).post(Entity.json(entity), UserGroupJSON.class);
    }

    @NotNull
    public UserGroupJSON getHeaderVisibleGroup(@NotNull String id, @Nullable FieldPartial<Partial.UserGroup> partial) {
      return this.prepare(apply(partial).path(id)).get(UserGroupJSON.class);
    }

    public void removeHeaderVisibleGroup(@NotNull String id) {
      this.prepare(path(id)).delete(UserGroupJSON.class);
    }

    @NotNull
    public static ServiceClient.HeaderVisibleGroupClient.Filter filter() {
      return new ServiceClient.HeaderVisibleGroupClient.Filter();
    }

    @XmlRootElement(name = "page")
    @XmlAccessorType(value = XmlAccessType.FIELD)
    @XmlSeeAlso(value = BasePage.class)
    public static class Page extends BasePage<UserGroupJSON> {
      @XmlElement(name = "headervisiblegroups")
      private List<UserGroupJSON> headervisiblegroups;

      public Page() {
      }

      @NotNull
      public List<UserGroupJSON> getHeadervisiblegroups() {
        return getItems();
      }

      @NotNull
      public List<UserGroupJSON> getItems() {
        return (headervisiblegroups != null ?
          headervisiblegroups :
          new ArrayList<UserGroupJSON>(0)
        );
      }
    }

    public static class Filter extends BaseFilter<ServiceClient.HeaderVisibleGroupClient.Filter> {
      private Filter() {
      }
    }
  }
}
