package jetbrains.jetpass.client.accounts;

/*Generated by MPS */

import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

public class ServiceCredentialsValidationResult {
  private String myMessage;
  private ServiceCredentialsValidationResult.Status myStatus;
  private Throwable myCause;

  public ServiceCredentialsValidationResult(@NotNull ServiceCredentialsValidationResult.Status status) {
    this(status, null, null);
  }

  public ServiceCredentialsValidationResult(@NotNull ServiceCredentialsValidationResult.Status status, @NotNull String message) {
    this(status, message, null);
  }

  public ServiceCredentialsValidationResult(@NotNull ServiceCredentialsValidationResult.Status status, @Nullable String message, @Nullable Throwable cause) {
    this.setStatus(status);
    this.setMessage((message != null ?
      message :
      status.getMessage()
    ));
    this.setCause(cause);
  }

  public String getMessage() {
    return this.myMessage;
  }

  private void setMessage(String value) {
    this.myMessage = value;
  }

  public ServiceCredentialsValidationResult.Status getStatus() {
    return this.myStatus;
  }

  private void setStatus(ServiceCredentialsValidationResult.Status value) {
    this.myStatus = value;
  }

  public Throwable getCause() {
    return this.myCause;
  }

  private void setCause(Throwable value) {
    this.myCause = value;
  }

  public boolean getRegistered() {
    return ServiceCredentialsValidationResult.this.getStatus() == ServiceCredentialsValidationResult.Status.OK || ServiceCredentialsValidationResult.this.getStatus() == ServiceCredentialsValidationResult.Status.SERVICE_WRONG_SECRET || ServiceCredentialsValidationResult.this.getStatus() == ServiceCredentialsValidationResult.Status.SERVICE_NOT_VERIFIED;
  }

  public boolean getSecretValid() {
    return ServiceCredentialsValidationResult.this.getStatus() == ServiceCredentialsValidationResult.Status.OK || ServiceCredentialsValidationResult.this.getStatus() == ServiceCredentialsValidationResult.Status.SERVICE_NOT_VERIFIED;
  }

  public boolean getVerified() {
    return ServiceCredentialsValidationResult.this.getStatus() == ServiceCredentialsValidationResult.Status.OK;
  }

  public static   enum Status {
    EMPTY_URL("Empty Ring URL"),
    MALFORMED_URL("Malformed Ring URL"),
    UNKNOWN_HOST("Unknown host in Ring URL"),
    CANT_CONNECT("Can't connect to Ring"),
    TIMEOUT("Connection to Ring timed out"),
    WRONG_URL("Wrong Ring URL"),
    SERVICE_CREDENTIALS_UNDEFINED("Service credentials are undefined"),
    SERVICE_NOT_REGISTERED("Service is not registered in Ring"),
    SERVICE_WRONG_SECRET("Service is registered in Ring but with the different client secret"),
    SERVICE_NOT_VERIFIED("Service isn't verified in Ring"),
    OTHER("Service responded with unknown response. See message."),
    OK("Service is registered and verified in Ring");

    private String message;

    Status(String message) {
      this.message = message;
    }

    public String getMessage() {
      return message;
    }
  }
}
