package jetbrains.jetpass.client.accounts;

/*Generated by MPS */

import jetbrains.jetpass.client.BaseClient;
import org.jetbrains.annotations.NotNull;
import javax.ws.rs.client.WebTarget;
import com.intellij.hub.auth.oauth2.consumer.TokenHolder;
import org.jetbrains.annotations.Nullable;
import jetbrains.jetpass.client.BaseFilter;
import jetbrains.jetpass.client.FieldPartial;
import jetbrains.jetpass.rest.dto.SettingsJSON;
import javax.ws.rs.client.Entity;
import org.glassfish.jersey.uri.UriComponent;
import javax.ws.rs.WebApplicationException;
import javax.ws.rs.core.Response;
import javax.ws.rs.core.GenericType;
import java.util.List;
import jetbrains.jetpass.rest.dto.LocaleJSON;
import jetbrains.jetpass.rest.dto.BackupStatusJSON;
import jetbrains.jetpass.rest.dto.UpdateStatusJSON;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlSeeAlso;
import jetbrains.mps.webr.rpc.rest.json.common.runtime.BasePage;
import javax.xml.bind.annotation.XmlElement;
import java.util.ArrayList;

public class SettingClient extends BaseClient {
  public SettingClient(@NotNull WebTarget rootResource) {
    this(rootResource, null);
  }

  public SettingClient(@NotNull WebTarget rootResource, TokenHolder container) {
    super(rootResource.path("settings"), container);
  }

  @NotNull
  public SettingClient.Page getSettingPage(@Nullable BaseFilter filter, @Nullable FieldPartial<Partial.Settings> partial) {
    return this.prepare(apply(partial, filter)).get(SettingClient.Page.class);
  }

  @NotNull
  public SettingsJSON createSetting(@NotNull SettingsJSON entity, @Nullable FieldPartial<Partial.Settings> partial) {
    return this.prepare(apply(partial)).post(Entity.json(entity), SettingsJSON.class);
  }

  @Nullable
  public SettingsJSON getSetting(@NotNull String settingId, @Nullable FieldPartial<Partial.Settings> partial) {
    return get(null, settingId, partial);
  }

  private SettingsJSON get(String byproperty, String key, @Nullable FieldPartial<Partial.Settings> partial) {
    WebTarget resource = apply(partial);
    if (byproperty != null) {
      resource = resource.path(byproperty);
    }
    resource = resource.path(UriComponent.encode(key, UriComponent.Type.PATH_SEGMENT));
    try {
      return this.prepare(resource).get(SettingsJSON.class);
    } catch (WebApplicationException ex) {
      // Let's do it like in documentation 
      // https://jersey.java.net/nonav/documentation/latest/client-api.html 
      if (ex.getResponse().getStatus() == Response.Status.NOT_FOUND.getStatusCode()) {
        return null;
      }
      // rethrow 
      throw ex;
    }
  }

  public void deleteSetting(@NotNull String settingId, @Nullable String successor) {
    WebTarget path = path(settingId);
    if (successor != null) {
      path = path.queryParam("successor", BaseClient.wrapObject(successor));
    }
    this.prepare(path).delete(SettingsJSON.class);
  }

  public void updateSetting(@NotNull String settingId, @NotNull SettingsJSON entity) {
    this.prepare(path(settingId)).post(Entity.json(entity), SettingsJSON.class);
  }

  public SettingsJSON test(@NotNull String settingId, @Nullable String contact, @Nullable FieldPartial<Partial.Settings> partial) {
    WebTarget resource = this.apply(partial);
    WebTarget r = resource.path(settingId);
    if (contact != null) {
      r = r.queryParam("contact", BaseClient.wrapObject(contact));
    }
    return this.prepare(r.path("test")).method("POST", new GenericType<SettingsJSON>() {
      {
        // Do nothing 
      }
    });
  }

  public List<LocaleJSON> locales(@Nullable FieldPartial<Partial.Locale> partial) {
    WebTarget resource = this.apply(partial);
    WebTarget r = resource;
    return this.prepare(r.path("locales")).method("GET", new GenericType<List<LocaleJSON>>() {
      {
        // Do nothing 
      }
    });
  }

  public BackupStatusJSON backupData(@Nullable FieldPartial<Partial.BackupStatus> partial) {
    WebTarget resource = this.apply(partial);
    WebTarget r = resource;
    return this.prepare(r.path("backupData")).method("POST", new GenericType<BackupStatusJSON>() {
      {
        // Do nothing 
      }
    });
  }

  public UpdateStatusJSON updateStatus(@Nullable FieldPartial<Partial.UpdateStatus> partial) {
    WebTarget resource = this.apply(partial);
    WebTarget r = resource;
    return this.prepare(r.path("updateStatus")).method("GET", new GenericType<UpdateStatusJSON>() {
      {
        // Do nothing 
      }
    });
  }

  @NotNull
  public static SettingClient.Filter filter() {
    return new SettingClient.Filter();
  }

  @XmlRootElement(name = "page")
  @XmlAccessorType(value = XmlAccessType.FIELD)
  @XmlSeeAlso(value = BasePage.class)
  public static class Page extends BasePage<SettingsJSON> {
    @XmlElement(name = "settings")
    private List<SettingsJSON> settings;

    public Page() {
    }

    @NotNull
    public List<SettingsJSON> getSettings() {
      return getItems();
    }

    @NotNull
    public List<SettingsJSON> getItems() {
      return (settings != null ?
        settings :
        new ArrayList<SettingsJSON>(0)
      );
    }
  }

  public static class Filter extends BaseFilter<SettingClient.Filter> {
    private Filter() {
    }
  }
}
