package jetbrains.jetpass.client.accounts;

/*Generated by MPS */

import jetbrains.jetpass.client.BaseClient;
import org.jetbrains.annotations.NotNull;
import javax.ws.rs.client.WebTarget;
import com.intellij.hub.auth.oauth2.consumer.TokenHolder;
import org.jetbrains.annotations.Nullable;
import jetbrains.jetpass.client.BaseFilter;
import jetbrains.jetpass.client.FieldPartial;
import jetbrains.jetpass.rest.dto.SpaceJSON;
import javax.ws.rs.client.Entity;
import org.glassfish.jersey.uri.UriComponent;
import javax.ws.rs.WebApplicationException;
import javax.ws.rs.core.Response;
import jetbrains.jetpass.rest.dto.QueryAssistJSON;
import javax.ws.rs.core.GenericType;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlSeeAlso;
import jetbrains.mps.webr.rpc.rest.json.common.runtime.BasePage;
import javax.xml.bind.annotation.XmlElement;
import java.util.List;
import java.util.ArrayList;
import jetbrains.jetpass.rest.dto.ResourceJSON;

@Deprecated
public class SpaceClient extends BaseClient {
  @Deprecated
  public SpaceClient(@NotNull WebTarget rootResource) {
    this(rootResource, null);
  }

  @Deprecated
  public SpaceClient(@NotNull WebTarget rootResource, TokenHolder container) {
    super(rootResource.path("spaces"), container);
  }

  @NotNull
  public SpaceClient.Page getSpacePage(@Nullable BaseFilter filter, @Nullable FieldPartial<Partial.Space> partial) {
    return this.prepare(apply(partial, filter)).get(SpaceClient.Page.class);
  }

  @NotNull
  public SpaceJSON createSpace(@NotNull SpaceJSON entity, @Nullable FieldPartial<Partial.Space> partial) {
    return this.prepare(apply(partial)).post(Entity.json(entity), SpaceJSON.class);
  }

  @Nullable
  public SpaceJSON getSpace(@NotNull String spaceId, @Nullable FieldPartial<Partial.Space> partial) {
    return get(null, spaceId, partial);
  }

  @Nullable
  public SpaceJSON getSpaceByName(@NotNull String name, @Nullable FieldPartial<Partial.Space> partial) {
    return get("byname", name, partial);
  }

  private SpaceJSON get(String byproperty, String key, @Nullable FieldPartial<Partial.Space> partial) {
    WebTarget resource = apply(partial);
    if (byproperty != null) {
      resource = resource.path(byproperty);
    }
    resource = resource.path(UriComponent.encode(key, UriComponent.Type.PATH_SEGMENT));
    try {
      return this.prepare(resource).get(SpaceJSON.class);
    } catch (WebApplicationException ex) {
      // Let's do it like in documentation 
      // https://jersey.java.net/nonav/documentation/latest/client-api.html 
      if (ex.getResponse().getStatus() == Response.Status.NOT_FOUND.getStatusCode()) {
        return null;
      }
      // rethrow 
      throw ex;
    }
  }

  public void deleteSpace(@NotNull String spaceId, @Nullable String successor) {
    WebTarget path = path(spaceId);
    if (successor != null) {
      path = path.queryParam("successor", BaseClient.wrapObject(successor));
    }
    this.prepare(path).delete(SpaceJSON.class);
  }

  public void updateSpace(@NotNull String spaceId, @NotNull SpaceJSON entity) {
    this.prepare(path(spaceId)).post(Entity.json(entity), SpaceJSON.class);
  }

  public QueryAssistJSON queryAssist(@Nullable String query, @Nullable Integer caret, @Nullable FieldPartial<Partial.QueryAssist> partial) {
    WebTarget resource = this.apply(partial);
    WebTarget r = resource;
    if (query != null) {
      r = r.queryParam("query", BaseClient.wrapObject(query));
    }
    if (caret != null) {
      r = r.queryParam("caret", BaseClient.wrapObject(caret));
    }
    return this.prepare(r.path("queryAssist")).method("GET", new GenericType<QueryAssistJSON>() {
      {
        // Do nothing 
      }
    });
  }

  public SpaceJSON global(@Nullable FieldPartial<Partial.Space> partial) {
    WebTarget resource = this.apply(partial);
    WebTarget r = resource;
    return this.prepare(r.path("global")).method("GET", new GenericType<SpaceJSON>() {
      {
        // Do nothing 
      }
    });
  }

  @NotNull
  public SpaceClient.ResourceClient getResourcesClient(@NotNull String spaceId) {
    return new SpaceClient.ResourceClient(path(spaceId), container);
  }

  @NotNull
  public static SpaceClient.Filter filter() {
    return new SpaceClient.Filter();
  }

  @XmlRootElement(name = "page")
  @XmlAccessorType(value = XmlAccessType.FIELD)
  @XmlSeeAlso(value = BasePage.class)
  public static class Page extends BasePage<SpaceJSON> {
    @XmlElement(name = "spaces")
    private List<SpaceJSON> spaces;

    public Page() {
    }

    @NotNull
    public List<SpaceJSON> getSpaces() {
      return getItems();
    }

    @NotNull
    public List<SpaceJSON> getItems() {
      return (spaces != null ?
        spaces :
        new ArrayList<SpaceJSON>(0)
      );
    }
  }

  public static class Filter extends BaseFilter<SpaceClient.Filter> {
    private Filter() {
    }

    public SpaceClient.Filter archived(Boolean archived) {
      add("archived", archived);
      return this;
    }
  }

  public static class ResourceClient extends BaseClient {
    private ResourceClient(WebTarget idResource, TokenHolder container) {
      super(idResource.path("resources"), container);
    }

    @NotNull
    public SpaceClient.ResourceClient.Page getResourcePage(@Nullable SpaceClient.ResourceClient.Filter filter, @Nullable FieldPartial<Partial.Resource> partial) {
      return this.prepare(apply(partial, filter)).get(SpaceClient.ResourceClient.Page.class);
    }

    @NotNull
    public ResourceJSON addResource(@NotNull ResourceJSON entity, @Nullable FieldPartial<Partial.Resource> partial) {
      return this.prepare(apply(partial)).post(Entity.json(entity), ResourceJSON.class);
    }

    @NotNull
    public ResourceJSON getResource(@NotNull String id, @Nullable FieldPartial<Partial.Resource> partial) {
      return this.prepare(apply(partial).path(id)).get(ResourceJSON.class);
    }

    public void removeResource(@NotNull String id) {
      this.prepare(path(id)).delete(ResourceJSON.class);
    }

    @NotNull
    public static SpaceClient.ResourceClient.Filter filter() {
      return new SpaceClient.ResourceClient.Filter();
    }

    @XmlRootElement(name = "page")
    @XmlAccessorType(value = XmlAccessType.FIELD)
    @XmlSeeAlso(value = BasePage.class)
    public static class Page extends BasePage<ResourceJSON> {
      @XmlElement(name = "resources")
      private List<ResourceJSON> resources;

      public Page() {
      }

      @NotNull
      public List<ResourceJSON> getResources() {
        return getItems();
      }

      @NotNull
      public List<ResourceJSON> getItems() {
        return (resources != null ?
          resources :
          new ArrayList<ResourceJSON>(0)
        );
      }
    }

    public static class Filter extends BaseFilter<SpaceClient.ResourceClient.Filter> {
      private Filter() {
      }
    }
  }
}
