package jetbrains.jetpass.client.accounts;

/*Generated by MPS */

import jetbrains.jetpass.client.BaseClient;
import org.jetbrains.annotations.NotNull;
import javax.ws.rs.client.WebTarget;
import com.intellij.hub.auth.oauth2.consumer.TokenHolder;
import org.jetbrains.annotations.Nullable;
import jetbrains.jetpass.client.BaseFilter;
import jetbrains.jetpass.client.FieldPartial;
import jetbrains.jetpass.rest.dto.UserJSON;
import javax.ws.rs.client.Entity;
import org.glassfish.jersey.uri.UriComponent;
import javax.ws.rs.WebApplicationException;
import javax.ws.rs.core.Response;
import java.util.List;
import javax.ws.rs.core.GenericType;
import jetbrains.jetpass.rest.dto.QueryAssistJSON;
import jetbrains.jetpass.rest.dto.ProfileJSON;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlSeeAlso;
import jetbrains.mps.webr.rpc.rest.json.common.runtime.BasePage;
import javax.xml.bind.annotation.XmlElement;
import java.util.ArrayList;
import jetbrains.jetpass.rest.dto.DetailsJSON;
import jetbrains.jetpass.rest.dto.SpaceRoleJSON;
import jetbrains.jetpass.rest.dto.ProjectRoleJSON;
import jetbrains.jetpass.rest.dto.UserGroupJSON;
import jetbrains.jetpass.rest.dto.SshPublicKeyJSON;

public class UserClient extends BaseClient {
  public UserClient(@NotNull WebTarget rootResource) {
    this(rootResource, null);
  }

  public UserClient(@NotNull WebTarget rootResource, TokenHolder container) {
    super(rootResource.path("users"), container);
  }

  @NotNull
  public UserClient.Page getUserPage(@Nullable BaseFilter filter, @Nullable FieldPartial<Partial.User> partial) {
    return this.prepare(apply(partial, filter)).get(UserClient.Page.class);
  }

  @NotNull
  public UserJSON createUser(@NotNull UserJSON entity, @Nullable FieldPartial<Partial.User> partial) {
    return this.prepare(apply(partial)).post(Entity.json(entity), UserJSON.class);
  }

  @Nullable
  public UserJSON getUser(@NotNull String userId, @Nullable FieldPartial<Partial.User> partial) {
    return get(null, userId, partial);
  }

  @Nullable
  public UserJSON getUserByName(@NotNull String name, @Nullable FieldPartial<Partial.User> partial) {
    return get("byname", name, partial);
  }

  private UserJSON get(String byproperty, String key, @Nullable FieldPartial<Partial.User> partial) {
    WebTarget resource = apply(partial);
    if (byproperty != null) {
      resource = resource.path(byproperty);
    }
    resource = resource.path(UriComponent.encode(key, UriComponent.Type.PATH_SEGMENT));
    try {
      return this.prepare(resource).get(UserJSON.class);
    } catch (WebApplicationException ex) {
      // Let's do it like in documentation 
      // https://jersey.java.net/nonav/documentation/latest/client-api.html 
      if (ex.getResponse().getStatus() == Response.Status.NOT_FOUND.getStatusCode()) {
        return null;
      }
      // rethrow 
      throw ex;
    }
  }

  public void deleteUser(@NotNull String userId, @Nullable String successor) {
    WebTarget path = path(userId);
    if (successor != null) {
      path = path.queryParam("successor", BaseClient.wrapObject(successor));
    }
    this.prepare(path).delete(UserJSON.class);
  }

  public void updateUser(@NotNull String userId, @NotNull UserJSON entity) {
    this.prepare(path(userId)).post(Entity.json(entity), UserJSON.class);
  }

  public List<UserJSON> invite(@Nullable List<String> email, @Nullable String group, @Nullable FieldPartial<Partial.User> partial) {
    WebTarget resource = this.apply(partial);
    WebTarget r = resource;
    if (email != null) {
      for (String pValue : email) {
        r = r.queryParam("email", BaseClient.wrapObject(pValue));
      }
    }
    if (group != null) {
      r = r.queryParam("group", BaseClient.wrapObject(group));
    }
    return this.prepare(r.path("invite")).method("POST", new GenericType<List<UserJSON>>() {
      {
        // Do nothing 
      }
    });
  }

  public UserJSON me(@Nullable FieldPartial<Partial.User> partial) {
    WebTarget resource = this.apply(partial);
    WebTarget r = resource;
    return this.prepare(r.path("me")).method("GET", new GenericType<UserJSON>() {
      {
        // Do nothing 
      }
    });
  }

  public UserJSON guest(@Nullable FieldPartial<Partial.User> partial) {
    WebTarget resource = this.apply(partial);
    WebTarget r = resource;
    return this.prepare(r.path("guest")).method("GET", new GenericType<UserJSON>() {
      {
        // Do nothing 
      }
    });
  }

  public QueryAssistJSON queryAssist(@Nullable String query, @Nullable Integer caret, @Nullable FieldPartial<Partial.QueryAssist> partial) {
    WebTarget resource = this.apply(partial);
    WebTarget r = resource;
    if (query != null) {
      r = r.queryParam("query", BaseClient.wrapObject(query));
    }
    if (caret != null) {
      r = r.queryParam("caret", BaseClient.wrapObject(caret));
    }
    return this.prepare(r.path("queryAssist")).method("GET", new GenericType<QueryAssistJSON>() {
      {
        // Do nothing 
      }
    });
  }

  public UserJSON merge(@Nullable String login, @Nullable String visibleName, @Nullable String email, @Nullable String jabber, @Nullable Boolean banned, @NotNull UserJSON[] entity, @Nullable FieldPartial<Partial.User> partial) {
    WebTarget resource = this.apply(partial);
    WebTarget r = resource;
    if (login != null) {
      r = r.queryParam("login", BaseClient.wrapObject(login));
    }
    if (visibleName != null) {
      r = r.queryParam("visibleName", BaseClient.wrapObject(visibleName));
    }
    if (email != null) {
      r = r.queryParam("email", BaseClient.wrapObject(email));
    }
    if (jabber != null) {
      r = r.queryParam("jabber", BaseClient.wrapObject(jabber));
    }
    if (banned != null) {
      r = r.queryParam("banned", BaseClient.wrapObject(banned));
    }
    return this.prepare(r.path("merge")).method("POST", Entity.json(entity), new GenericType<UserJSON>() {
      {
        // Do nothing 
      }
    });
  }

  public ProfileJSON verifyContact(@NotNull String userId, @NotNull ProfileJSON entity, @Nullable FieldPartial<Partial.Profile> partial) {
    WebTarget resource = this.apply(partial);
    WebTarget r = resource.path(userId);
    return this.prepare(r.path("verifyContact")).method("POST", Entity.json(entity), new GenericType<ProfileJSON>() {
      {
        // Do nothing 
      }
    });
  }

  @NotNull
  public UserClient.UserDetailClient getUserdetailsClient(@NotNull String userId) {
    return new UserClient.UserDetailClient(path(userId), container);
  }

  @NotNull
  @Deprecated
  public UserClient.RoleClient getRolesClient(@NotNull String userId) {
    return new UserClient.RoleClient(path(userId), container);
  }

  @NotNull
  public UserClient.ProjectRoleClient getProjectrolesClient(@NotNull String userId) {
    return new UserClient.ProjectRoleClient(path(userId), container);
  }

  @NotNull
  public UserClient.GroupClient getGroupsClient(@NotNull String userId) {
    return new UserClient.GroupClient(path(userId), container);
  }

  @NotNull
  public UserClient.SshPublicKeyClient getSshpublickeysClient(@NotNull String userId) {
    return new UserClient.SshPublicKeyClient(path(userId), container);
  }

  @NotNull
  public static UserClient.Filter filter() {
    return new UserClient.Filter();
  }

  @XmlRootElement(name = "page")
  @XmlAccessorType(value = XmlAccessType.FIELD)
  @XmlSeeAlso(value = BasePage.class)
  public static class Page extends BasePage<UserJSON> {
    @XmlElement(name = "users")
    private List<UserJSON> users;

    public Page() {
    }

    @NotNull
    public List<UserJSON> getUsers() {
      return getItems();
    }

    @NotNull
    public List<UserJSON> getItems() {
      return (users != null ?
        users :
        new ArrayList<UserJSON>(0)
      );
    }
  }

  public static class Filter extends BaseFilter<UserClient.Filter> {
    private Filter() {
    }
  }

  public static class UserDetailClient extends BaseClient {
    private UserDetailClient(WebTarget idResource, TokenHolder container) {
      super(idResource.path("userdetails"), container);
    }

    @NotNull
    public UserClient.UserDetailClient.Page getUserDetailPage(@Nullable UserClient.UserDetailClient.Filter filter, @Nullable FieldPartial<Partial.Details> partial) {
      return this.prepare(apply(partial, filter)).get(UserClient.UserDetailClient.Page.class);
    }

    @NotNull
    public DetailsJSON addUserDetail(@NotNull DetailsJSON entity, @Nullable FieldPartial<Partial.Details> partial) {
      return this.prepare(apply(partial)).post(Entity.json(entity), DetailsJSON.class);
    }

    @NotNull
    public DetailsJSON getUserDetail(@NotNull String id, @Nullable FieldPartial<Partial.Details> partial) {
      return this.prepare(apply(partial).path(id)).get(DetailsJSON.class);
    }

    public void removeUserDetail(@NotNull String id) {
      this.prepare(path(id)).delete(DetailsJSON.class);
    }

    @NotNull
    public static UserClient.UserDetailClient.Filter filter() {
      return new UserClient.UserDetailClient.Filter();
    }

    @XmlRootElement(name = "page")
    @XmlAccessorType(value = XmlAccessType.FIELD)
    @XmlSeeAlso(value = BasePage.class)
    public static class Page extends BasePage<DetailsJSON> {
      @XmlElement(name = "userdetails")
      private List<DetailsJSON> userdetails;

      public Page() {
      }

      @NotNull
      public List<DetailsJSON> getUserdetails() {
        return getItems();
      }

      @NotNull
      public List<DetailsJSON> getItems() {
        return (userdetails != null ?
          userdetails :
          new ArrayList<DetailsJSON>(0)
        );
      }
    }

    public static class Filter extends BaseFilter<UserClient.UserDetailClient.Filter> {
      private Filter() {
      }
    }
  }

  @Deprecated
  public static class RoleClient extends BaseClient {
    @Deprecated
    private RoleClient(WebTarget idResource, TokenHolder container) {
      super(idResource.path("roles"), container);
    }

    @NotNull
    public UserClient.RoleClient.Page getRolePage(@Nullable UserClient.RoleClient.Filter filter, @Nullable FieldPartial<Partial.SpaceRole> partial) {
      return this.prepare(apply(partial, filter)).get(UserClient.RoleClient.Page.class);
    }

    @NotNull
    public SpaceRoleJSON addRole(@NotNull SpaceRoleJSON entity, @Nullable FieldPartial<Partial.SpaceRole> partial) {
      return this.prepare(apply(partial)).post(Entity.json(entity), SpaceRoleJSON.class);
    }

    @NotNull
    public SpaceRoleJSON getRole(@NotNull String id, @Nullable FieldPartial<Partial.SpaceRole> partial) {
      return this.prepare(apply(partial).path(id)).get(SpaceRoleJSON.class);
    }

    public void removeRole(@NotNull String id) {
      this.prepare(path(id)).delete(SpaceRoleJSON.class);
    }

    @NotNull
    public static UserClient.RoleClient.Filter filter() {
      return new UserClient.RoleClient.Filter();
    }

    @XmlRootElement(name = "page")
    @XmlAccessorType(value = XmlAccessType.FIELD)
    @XmlSeeAlso(value = BasePage.class)
    public static class Page extends BasePage<SpaceRoleJSON> {
      @XmlElement(name = "roles")
      private List<SpaceRoleJSON> roles;

      public Page() {
      }

      @NotNull
      public List<SpaceRoleJSON> getRoles() {
        return getItems();
      }

      @NotNull
      public List<SpaceRoleJSON> getItems() {
        return (roles != null ?
          roles :
          new ArrayList<SpaceRoleJSON>(0)
        );
      }
    }

    public static class Filter extends BaseFilter<UserClient.RoleClient.Filter> {
      private Filter() {
      }
    }
  }

  public static class ProjectRoleClient extends BaseClient {
    private ProjectRoleClient(WebTarget idResource, TokenHolder container) {
      super(idResource.path("projectroles"), container);
    }

    @NotNull
    public UserClient.ProjectRoleClient.Page getProjectRolePage(@Nullable UserClient.ProjectRoleClient.Filter filter, @Nullable FieldPartial<Partial.ProjectRole> partial) {
      return this.prepare(apply(partial, filter)).get(UserClient.ProjectRoleClient.Page.class);
    }

    @NotNull
    public ProjectRoleJSON addProjectRole(@NotNull ProjectRoleJSON entity, @Nullable FieldPartial<Partial.ProjectRole> partial) {
      return this.prepare(apply(partial)).post(Entity.json(entity), ProjectRoleJSON.class);
    }

    @NotNull
    public ProjectRoleJSON getProjectRole(@NotNull String id, @Nullable FieldPartial<Partial.ProjectRole> partial) {
      return this.prepare(apply(partial).path(id)).get(ProjectRoleJSON.class);
    }

    public void removeProjectRole(@NotNull String id) {
      this.prepare(path(id)).delete(ProjectRoleJSON.class);
    }

    @NotNull
    public static UserClient.ProjectRoleClient.Filter filter() {
      return new UserClient.ProjectRoleClient.Filter();
    }

    @XmlRootElement(name = "page")
    @XmlAccessorType(value = XmlAccessType.FIELD)
    @XmlSeeAlso(value = BasePage.class)
    public static class Page extends BasePage<ProjectRoleJSON> {
      @XmlElement(name = "projectroles")
      private List<ProjectRoleJSON> projectroles;

      public Page() {
      }

      @NotNull
      public List<ProjectRoleJSON> getProjectroles() {
        return getItems();
      }

      @NotNull
      public List<ProjectRoleJSON> getItems() {
        return (projectroles != null ?
          projectroles :
          new ArrayList<ProjectRoleJSON>(0)
        );
      }
    }

    public static class Filter extends BaseFilter<UserClient.ProjectRoleClient.Filter> {
      private Filter() {
      }
    }
  }

  public static class GroupClient extends BaseClient {
    private GroupClient(WebTarget idResource, TokenHolder container) {
      super(idResource.path("groups"), container);
    }

    @NotNull
    public UserClient.GroupClient.Page getGroupPage(@Nullable UserClient.GroupClient.Filter filter, @Nullable FieldPartial<Partial.UserGroup> partial) {
      return this.prepare(apply(partial, filter)).get(UserClient.GroupClient.Page.class);
    }

    @NotNull
    public UserGroupJSON addGroup(@NotNull UserGroupJSON entity, @Nullable FieldPartial<Partial.UserGroup> partial) {
      return this.prepare(apply(partial)).post(Entity.json(entity), UserGroupJSON.class);
    }

    @NotNull
    public UserGroupJSON getGroup(@NotNull String id, @Nullable FieldPartial<Partial.UserGroup> partial) {
      return this.prepare(apply(partial).path(id)).get(UserGroupJSON.class);
    }

    public void removeGroup(@NotNull String id) {
      this.prepare(path(id)).delete(UserGroupJSON.class);
    }

    @NotNull
    public static UserClient.GroupClient.Filter filter() {
      return new UserClient.GroupClient.Filter();
    }

    @XmlRootElement(name = "page")
    @XmlAccessorType(value = XmlAccessType.FIELD)
    @XmlSeeAlso(value = BasePage.class)
    public static class Page extends BasePage<UserGroupJSON> {
      @XmlElement(name = "groups")
      private List<UserGroupJSON> groups;

      public Page() {
      }

      @NotNull
      public List<UserGroupJSON> getGroups() {
        return getItems();
      }

      @NotNull
      public List<UserGroupJSON> getItems() {
        return (groups != null ?
          groups :
          new ArrayList<UserGroupJSON>(0)
        );
      }
    }

    public static class Filter extends BaseFilter<UserClient.GroupClient.Filter> {
      private Filter() {
      }
    }
  }

  public static class SshPublicKeyClient extends BaseClient {
    private SshPublicKeyClient(WebTarget idResource, TokenHolder container) {
      super(idResource.path("sshpublickeys"), container);
    }

    @NotNull
    public UserClient.SshPublicKeyClient.Page getSshPublicKeyPage(@Nullable UserClient.SshPublicKeyClient.Filter filter, @Nullable FieldPartial<Partial.SshPublicKey> partial) {
      return this.prepare(apply(partial, filter)).get(UserClient.SshPublicKeyClient.Page.class);
    }

    @NotNull
    public SshPublicKeyJSON addSshPublicKey(@NotNull SshPublicKeyJSON entity, @Nullable FieldPartial<Partial.SshPublicKey> partial) {
      return this.prepare(apply(partial)).post(Entity.json(entity), SshPublicKeyJSON.class);
    }

    @NotNull
    public SshPublicKeyJSON getSshPublicKey(@NotNull String id, @Nullable FieldPartial<Partial.SshPublicKey> partial) {
      return this.prepare(apply(partial).path(id)).get(SshPublicKeyJSON.class);
    }

    public void removeSshPublicKey(@NotNull String id) {
      this.prepare(path(id)).delete(SshPublicKeyJSON.class);
    }

    @NotNull
    public static UserClient.SshPublicKeyClient.Filter filter() {
      return new UserClient.SshPublicKeyClient.Filter();
    }

    @XmlRootElement(name = "page")
    @XmlAccessorType(value = XmlAccessType.FIELD)
    @XmlSeeAlso(value = BasePage.class)
    public static class Page extends BasePage<SshPublicKeyJSON> {
      @XmlElement(name = "sshpublickeys")
      private List<SshPublicKeyJSON> sshpublickeys;

      public Page() {
      }

      @NotNull
      public List<SshPublicKeyJSON> getSshpublickeys() {
        return getItems();
      }

      @NotNull
      public List<SshPublicKeyJSON> getItems() {
        return (sshpublickeys != null ?
          sshpublickeys :
          new ArrayList<SshPublicKeyJSON>(0)
        );
      }
    }

    public static class Filter extends BaseFilter<UserClient.SshPublicKeyClient.Filter> {
      private Filter() {
      }
    }
  }
}
