package jetbrains.jetpass.client.accounts;

/*Generated by MPS */

import jetbrains.jetpass.client.BaseClient;
import org.jetbrains.annotations.NotNull;
import javax.ws.rs.client.WebTarget;
import com.intellij.hub.auth.oauth2.consumer.TokenHolder;
import org.jetbrains.annotations.Nullable;
import jetbrains.jetpass.client.BaseFilter;
import jetbrains.jetpass.client.FieldPartial;
import jetbrains.jetpass.rest.dto.DetailsJSON;
import javax.ws.rs.client.Entity;
import org.glassfish.jersey.uri.UriComponent;
import javax.ws.rs.WebApplicationException;
import javax.ws.rs.core.Response;
import jetbrains.jetpass.rest.dto.QueryAssistJSON;
import javax.ws.rs.core.GenericType;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlSeeAlso;
import jetbrains.mps.webr.rpc.rest.json.common.runtime.BasePage;
import javax.xml.bind.annotation.XmlElement;
import java.util.List;
import java.util.ArrayList;

public class UserDetailClient extends BaseClient {
  public UserDetailClient(@NotNull WebTarget rootResource) {
    this(rootResource, null);
  }

  public UserDetailClient(@NotNull WebTarget rootResource, TokenHolder container) {
    super(rootResource.path("userdetails"), container);
  }

  @NotNull
  public UserDetailClient.Page getUserDetailPage(@Nullable BaseFilter filter, @Nullable FieldPartial<Partial.Details> partial) {
    return this.prepare(apply(partial, filter)).get(UserDetailClient.Page.class);
  }

  @NotNull
  public DetailsJSON createUserDetail(@NotNull DetailsJSON entity, @Nullable FieldPartial<Partial.Details> partial) {
    return this.prepare(apply(partial)).post(Entity.json(entity), DetailsJSON.class);
  }

  @Nullable
  public DetailsJSON getUserDetail(@NotNull String userDetailId, @Nullable FieldPartial<Partial.Details> partial) {
    return get(null, userDetailId, partial);
  }

  private DetailsJSON get(String byproperty, String key, @Nullable FieldPartial<Partial.Details> partial) {
    WebTarget resource = apply(partial);
    if (byproperty != null) {
      resource = resource.path(byproperty);
    }
    resource = resource.path(UriComponent.encode(key, UriComponent.Type.PATH_SEGMENT));
    try {
      return this.prepare(resource).get(DetailsJSON.class);
    } catch (WebApplicationException ex) {
      // Let's do it like in documentation 
      // https://jersey.java.net/nonav/documentation/latest/client-api.html 
      if (ex.getResponse().getStatus() == Response.Status.NOT_FOUND.getStatusCode()) {
        return null;
      }
      // rethrow 
      throw ex;
    }
  }

  public void deleteUserDetail(@NotNull String userDetailId) {
    WebTarget path = path(userDetailId);
    this.prepare(path).delete(DetailsJSON.class);
  }

  public void updateUserDetail(@NotNull String userDetailId, @NotNull DetailsJSON entity) {
    this.prepare(path(userDetailId)).post(Entity.json(entity), DetailsJSON.class);
  }

  public QueryAssistJSON queryAssist(@Nullable String query, @Nullable Integer caret, @Nullable FieldPartial<Partial.QueryAssist> partial) {
    WebTarget resource = this.apply(partial);
    WebTarget r = resource;
    if (query != null) {
      r = r.queryParam("query", BaseClient.wrapObject(query));
    }
    if (caret != null) {
      r = r.queryParam("caret", BaseClient.wrapObject(caret));
    }
    return this.prepare(r.path("queryAssist")).method("GET", new GenericType<QueryAssistJSON>() {
      {
        // Do nothing 
      }
    });
  }

  public void revoke(@NotNull String userDetailId) {
    WebTarget resource = this.apply(null);
    WebTarget r = resource.path(userDetailId);
    this.prepare(r.path("revoke")).method("POST");
  }

  @NotNull
  public static UserDetailClient.Filter filter() {
    return new UserDetailClient.Filter();
  }

  @XmlRootElement(name = "page")
  @XmlAccessorType(value = XmlAccessType.FIELD)
  @XmlSeeAlso(value = BasePage.class)
  public static class Page extends BasePage<DetailsJSON> {
    @XmlElement(name = "userdetails")
    private List<DetailsJSON> userdetails;

    public Page() {
    }

    @NotNull
    public List<DetailsJSON> getUserdetails() {
      return getItems();
    }

    @NotNull
    public List<DetailsJSON> getItems() {
      return (userdetails != null ?
        userdetails :
        new ArrayList<DetailsJSON>(0)
      );
    }
  }

  public static class Filter extends BaseFilter<UserDetailClient.Filter> {
    private Filter() {
    }
  }
}
