package jetbrains.jetpass.client.accounts;

/*Generated by MPS */

import jetbrains.jetpass.client.BaseClient;
import org.jetbrains.annotations.NotNull;
import javax.ws.rs.client.WebTarget;
import com.intellij.hub.auth.oauth2.consumer.TokenHolder;
import org.jetbrains.annotations.Nullable;
import jetbrains.jetpass.client.BaseFilter;
import jetbrains.jetpass.client.FieldPartial;
import jetbrains.jetpass.rest.dto.UserGroupJSON;
import javax.ws.rs.client.Entity;
import org.glassfish.jersey.uri.UriComponent;
import javax.ws.rs.WebApplicationException;
import javax.ws.rs.core.Response;
import jetbrains.jetpass.rest.dto.QueryAssistJSON;
import javax.ws.rs.core.GenericType;
import java.util.List;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlSeeAlso;
import jetbrains.mps.webr.rpc.rest.json.common.runtime.BasePage;
import javax.xml.bind.annotation.XmlElement;
import java.util.ArrayList;
import jetbrains.jetpass.rest.dto.SpaceRoleJSON;
import jetbrains.jetpass.rest.dto.ProjectRoleJSON;
import jetbrains.jetpass.rest.dto.UserJSON;

public class UserGroupClient extends BaseClient {
  public UserGroupClient(@NotNull WebTarget rootResource) {
    this(rootResource, null);
  }

  public UserGroupClient(@NotNull WebTarget rootResource, TokenHolder container) {
    super(rootResource.path("usergroups"), container);
  }

  @NotNull
  public UserGroupClient.Page getUserGroupPage(@Nullable BaseFilter filter, @Nullable FieldPartial<Partial.UserGroup> partial) {
    return this.prepare(apply(partial, filter)).get(UserGroupClient.Page.class);
  }

  @NotNull
  public UserGroupJSON createUserGroup(@NotNull UserGroupJSON entity, @Nullable FieldPartial<Partial.UserGroup> partial) {
    return this.prepare(apply(partial)).post(Entity.json(entity), UserGroupJSON.class);
  }

  @Nullable
  public UserGroupJSON getUserGroup(@NotNull String userGroupId, @Nullable FieldPartial<Partial.UserGroup> partial) {
    return get(null, userGroupId, partial);
  }

  @Nullable
  public UserGroupJSON getUserGroupByName(@NotNull String name, @Nullable FieldPartial<Partial.UserGroup> partial) {
    return get("byname", name, partial);
  }

  private UserGroupJSON get(String byproperty, String key, @Nullable FieldPartial<Partial.UserGroup> partial) {
    WebTarget resource = apply(partial);
    if (byproperty != null) {
      resource = resource.path(byproperty);
    }
    resource = resource.path(UriComponent.encode(key, UriComponent.Type.PATH_SEGMENT));
    try {
      return this.prepare(resource).get(UserGroupJSON.class);
    } catch (WebApplicationException ex) {
      // Let's do it like in documentation 
      // https://jersey.java.net/nonav/documentation/latest/client-api.html 
      if (ex.getResponse().getStatus() == Response.Status.NOT_FOUND.getStatusCode()) {
        return null;
      }
      // rethrow 
      throw ex;
    }
  }

  public void deleteUserGroup(@NotNull String userGroupId, @Nullable String successor) {
    WebTarget path = path(userGroupId);
    if (successor != null) {
      path = path.queryParam("successor", BaseClient.wrapObject(successor));
    }
    this.prepare(path).delete(UserGroupJSON.class);
  }

  public void updateUserGroup(@NotNull String userGroupId, @NotNull UserGroupJSON entity) {
    this.prepare(path(userGroupId)).post(Entity.json(entity), UserGroupJSON.class);
  }

  public QueryAssistJSON queryAssist(@Nullable String query, @Nullable Integer caret, @Nullable FieldPartial<Partial.QueryAssist> partial) {
    WebTarget resource = this.apply(partial);
    WebTarget r = resource;
    if (query != null) {
      r = r.queryParam("query", BaseClient.wrapObject(query));
    }
    if (caret != null) {
      r = r.queryParam("caret", BaseClient.wrapObject(caret));
    }
    return this.prepare(r.path("queryAssist")).method("GET", new GenericType<QueryAssistJSON>() {
      {
        // Do nothing 
      }
    });
  }

  public List<UserGroupJSON> forest(@Nullable FieldPartial<Partial.UserGroup> partial) {
    WebTarget resource = this.apply(partial);
    WebTarget r = resource;
    return this.prepare(r.path("forest")).method("GET", new GenericType<List<UserGroupJSON>>() {
      {
        // Do nothing 
      }
    });
  }

  public UserGroupJSON root(@Nullable FieldPartial<Partial.UserGroup> partial) {
    WebTarget resource = this.apply(partial);
    WebTarget r = resource;
    return this.prepare(r.path("root")).method("GET", new GenericType<UserGroupJSON>() {
      {
        // Do nothing 
      }
    });
  }

  public UserGroupJSON merge(@Nullable String name, @Nullable String description, @Nullable Boolean authJoin, @Nullable String project, @Nullable String parentGroup, @NotNull UserGroupJSON[] entity, @Nullable FieldPartial<Partial.UserGroup> partial) {
    WebTarget resource = this.apply(partial);
    WebTarget r = resource;
    if (name != null) {
      r = r.queryParam("name", BaseClient.wrapObject(name));
    }
    if (description != null) {
      r = r.queryParam("description", BaseClient.wrapObject(description));
    }
    if (authJoin != null) {
      r = r.queryParam("authJoin", BaseClient.wrapObject(authJoin));
    }
    if (project != null) {
      r = r.queryParam("project", BaseClient.wrapObject(project));
    }
    if (parentGroup != null) {
      r = r.queryParam("parentGroup", BaseClient.wrapObject(parentGroup));
    }
    return this.prepare(r.path("merge")).method("POST", Entity.json(entity), new GenericType<UserGroupJSON>() {
      {
        // Do nothing 
      }
    });
  }

  @NotNull
  @Deprecated
  public UserGroupClient.RoleClient getRolesClient(@NotNull String userGroupId) {
    return new UserGroupClient.RoleClient(path(userGroupId), container);
  }

  @NotNull
  public UserGroupClient.ProjectRoleClient getProjectrolesClient(@NotNull String userGroupId) {
    return new UserGroupClient.ProjectRoleClient(path(userGroupId), container);
  }

  @NotNull
  public UserGroupClient.SubgroupClient getSubgroupsClient(@NotNull String userGroupId) {
    return new UserGroupClient.SubgroupClient(path(userGroupId), container);
  }

  @NotNull
  public UserGroupClient.UserClient getUsersClient(@NotNull String userGroupId) {
    return new UserGroupClient.UserClient(path(userGroupId), container);
  }

  @NotNull
  public static UserGroupClient.Filter filter() {
    return new UserGroupClient.Filter();
  }

  @XmlRootElement(name = "page")
  @XmlAccessorType(value = XmlAccessType.FIELD)
  @XmlSeeAlso(value = BasePage.class)
  public static class Page extends BasePage<UserGroupJSON> {
    @XmlElement(name = "usergroups")
    private List<UserGroupJSON> usergroups;

    public Page() {
    }

    @NotNull
    public List<UserGroupJSON> getUsergroups() {
      return getItems();
    }

    @NotNull
    public List<UserGroupJSON> getItems() {
      return (usergroups != null ?
        usergroups :
        new ArrayList<UserGroupJSON>(0)
      );
    }
  }

  public static class Filter extends BaseFilter<UserGroupClient.Filter> {
    private Filter() {
    }
  }

  @Deprecated
  public static class RoleClient extends BaseClient {
    @Deprecated
    private RoleClient(WebTarget idResource, TokenHolder container) {
      super(idResource.path("roles"), container);
    }

    @NotNull
    public UserGroupClient.RoleClient.Page getRolePage(@Nullable UserGroupClient.RoleClient.Filter filter, @Nullable FieldPartial<Partial.SpaceRole> partial) {
      return this.prepare(apply(partial, filter)).get(UserGroupClient.RoleClient.Page.class);
    }

    @NotNull
    public SpaceRoleJSON addRole(@NotNull SpaceRoleJSON entity, @Nullable FieldPartial<Partial.SpaceRole> partial) {
      return this.prepare(apply(partial)).post(Entity.json(entity), SpaceRoleJSON.class);
    }

    @NotNull
    public SpaceRoleJSON getRole(@NotNull String id, @Nullable FieldPartial<Partial.SpaceRole> partial) {
      return this.prepare(apply(partial).path(id)).get(SpaceRoleJSON.class);
    }

    public void removeRole(@NotNull String id) {
      this.prepare(path(id)).delete(SpaceRoleJSON.class);
    }

    @NotNull
    public static UserGroupClient.RoleClient.Filter filter() {
      return new UserGroupClient.RoleClient.Filter();
    }

    @XmlRootElement(name = "page")
    @XmlAccessorType(value = XmlAccessType.FIELD)
    @XmlSeeAlso(value = BasePage.class)
    public static class Page extends BasePage<SpaceRoleJSON> {
      @XmlElement(name = "roles")
      private List<SpaceRoleJSON> roles;

      public Page() {
      }

      @NotNull
      public List<SpaceRoleJSON> getRoles() {
        return getItems();
      }

      @NotNull
      public List<SpaceRoleJSON> getItems() {
        return (roles != null ?
          roles :
          new ArrayList<SpaceRoleJSON>(0)
        );
      }
    }

    public static class Filter extends BaseFilter<UserGroupClient.RoleClient.Filter> {
      private Filter() {
      }
    }
  }

  public static class ProjectRoleClient extends BaseClient {
    private ProjectRoleClient(WebTarget idResource, TokenHolder container) {
      super(idResource.path("projectroles"), container);
    }

    @NotNull
    public UserGroupClient.ProjectRoleClient.Page getProjectRolePage(@Nullable UserGroupClient.ProjectRoleClient.Filter filter, @Nullable FieldPartial<Partial.ProjectRole> partial) {
      return this.prepare(apply(partial, filter)).get(UserGroupClient.ProjectRoleClient.Page.class);
    }

    @NotNull
    public ProjectRoleJSON addProjectRole(@NotNull ProjectRoleJSON entity, @Nullable FieldPartial<Partial.ProjectRole> partial) {
      return this.prepare(apply(partial)).post(Entity.json(entity), ProjectRoleJSON.class);
    }

    @NotNull
    public ProjectRoleJSON getProjectRole(@NotNull String id, @Nullable FieldPartial<Partial.ProjectRole> partial) {
      return this.prepare(apply(partial).path(id)).get(ProjectRoleJSON.class);
    }

    public void removeProjectRole(@NotNull String id) {
      this.prepare(path(id)).delete(ProjectRoleJSON.class);
    }

    @NotNull
    public static UserGroupClient.ProjectRoleClient.Filter filter() {
      return new UserGroupClient.ProjectRoleClient.Filter();
    }

    @XmlRootElement(name = "page")
    @XmlAccessorType(value = XmlAccessType.FIELD)
    @XmlSeeAlso(value = BasePage.class)
    public static class Page extends BasePage<ProjectRoleJSON> {
      @XmlElement(name = "projectroles")
      private List<ProjectRoleJSON> projectroles;

      public Page() {
      }

      @NotNull
      public List<ProjectRoleJSON> getProjectroles() {
        return getItems();
      }

      @NotNull
      public List<ProjectRoleJSON> getItems() {
        return (projectroles != null ?
          projectroles :
          new ArrayList<ProjectRoleJSON>(0)
        );
      }
    }

    public static class Filter extends BaseFilter<UserGroupClient.ProjectRoleClient.Filter> {
      private Filter() {
      }
    }
  }

  public static class SubgroupClient extends BaseClient {
    private SubgroupClient(WebTarget idResource, TokenHolder container) {
      super(idResource.path("subgroups"), container);
    }

    @NotNull
    public UserGroupClient.SubgroupClient.Page getSubgroupPage(@Nullable UserGroupClient.SubgroupClient.Filter filter, @Nullable FieldPartial<Partial.UserGroup> partial) {
      return this.prepare(apply(partial, filter)).get(UserGroupClient.SubgroupClient.Page.class);
    }

    @NotNull
    public UserGroupJSON addSubgroup(@NotNull UserGroupJSON entity, @Nullable FieldPartial<Partial.UserGroup> partial) {
      return this.prepare(apply(partial)).post(Entity.json(entity), UserGroupJSON.class);
    }

    @NotNull
    public UserGroupJSON getSubgroup(@NotNull String id, @Nullable FieldPartial<Partial.UserGroup> partial) {
      return this.prepare(apply(partial).path(id)).get(UserGroupJSON.class);
    }

    public void removeSubgroup(@NotNull String id) {
      this.prepare(path(id)).delete(UserGroupJSON.class);
    }

    @NotNull
    public static UserGroupClient.SubgroupClient.Filter filter() {
      return new UserGroupClient.SubgroupClient.Filter();
    }

    @XmlRootElement(name = "page")
    @XmlAccessorType(value = XmlAccessType.FIELD)
    @XmlSeeAlso(value = BasePage.class)
    public static class Page extends BasePage<UserGroupJSON> {
      @XmlElement(name = "subgroups")
      private List<UserGroupJSON> subgroups;

      public Page() {
      }

      @NotNull
      public List<UserGroupJSON> getSubgroups() {
        return getItems();
      }

      @NotNull
      public List<UserGroupJSON> getItems() {
        return (subgroups != null ?
          subgroups :
          new ArrayList<UserGroupJSON>(0)
        );
      }
    }

    public static class Filter extends BaseFilter<UserGroupClient.SubgroupClient.Filter> {
      private Filter() {
      }
    }
  }

  public static class UserClient extends BaseClient {
    private UserClient(WebTarget idResource, TokenHolder container) {
      super(idResource.path("users"), container);
    }

    @NotNull
    public UserGroupClient.UserClient.Page getUserPage(@Nullable UserGroupClient.UserClient.Filter filter, @Nullable FieldPartial<Partial.User> partial) {
      return this.prepare(apply(partial, filter)).get(UserGroupClient.UserClient.Page.class);
    }

    @NotNull
    public UserJSON addUser(@NotNull UserJSON entity, @Nullable FieldPartial<Partial.User> partial) {
      return this.prepare(apply(partial)).post(Entity.json(entity), UserJSON.class);
    }

    @NotNull
    public UserJSON getUser(@NotNull String id, @Nullable FieldPartial<Partial.User> partial) {
      return this.prepare(apply(partial).path(id)).get(UserJSON.class);
    }

    public void removeUser(@NotNull String id) {
      this.prepare(path(id)).delete(UserJSON.class);
    }

    @NotNull
    public static UserGroupClient.UserClient.Filter filter() {
      return new UserGroupClient.UserClient.Filter();
    }

    @XmlRootElement(name = "page")
    @XmlAccessorType(value = XmlAccessType.FIELD)
    @XmlSeeAlso(value = BasePage.class)
    public static class Page extends BasePage<UserJSON> {
      @XmlElement(name = "users")
      private List<UserJSON> users;

      public Page() {
      }

      @NotNull
      public List<UserJSON> getUsers() {
        return getItems();
      }

      @NotNull
      public List<UserJSON> getItems() {
        return (users != null ?
          users :
          new ArrayList<UserJSON>(0)
        );
      }
    }

    public static class Filter extends BaseFilter<UserGroupClient.UserClient.Filter> {
      private Filter() {
      }
    }
  }
}
