package jetbrains.jetpass.client.hub;

/*Generated by MPS */

import org.jetbrains.annotations.NotNull;
import java.net.URI;
import javax.ws.rs.client.Client;
import javax.ws.rs.client.WebTarget;
import com.intellij.hub.core.URIHelper;
import jetbrains.jetpass.client.accounts.BaseAccountsClient;
import jetbrains.jetpass.client.oauth2.token.OAuth2ClientFlow;
import jetbrains.jetpass.client.oauth2.OAuth2Client;
import org.jetbrains.annotations.Nullable;
import com.intellij.hub.auth.oauth2.consumer.TokenHolder;
import jetbrains.jetpass.client.accounts.ImmutableAccountsClient;
import javax.ws.rs.client.ClientBuilder;
import java.util.Set;
import java.util.HashSet;
import java.net.URL;
import org.glassfish.jersey.client.ClientProperties;
import javax.ws.rs.ext.ContextResolver;
import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.ws.rs.ext.Provider;
import com.fasterxml.jackson.jaxrs.json.JacksonJsonProvider;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.fasterxml.jackson.databind.DeserializationFeature;
import com.fasterxml.jackson.databind.introspect.AnnotationIntrospectorPair;
import com.fasterxml.jackson.module.jaxb.JaxbAnnotationIntrospector;
import com.fasterxml.jackson.databind.introspect.JacksonAnnotationIntrospector;
import jetbrains.jetpass.rest.dto.EmailJSON;
import jetbrains.jetpass.rest.dto.JabberJSON;
import jetbrains.jetpass.auth.module.rest.client.json.ExternalauthmoduleJSON;
import jetbrains.jetpass.auth.module.core.rest.client.json.CoreuserdetailsJSON;
import jetbrains.jetpass.auth.module.core.rest.client.json.LoginuserdetailsJSON;
import jetbrains.jetpass.auth.module.core.rest.client.json.EmailuserdetailsJSON;
import jetbrains.jetpass.auth.module.core.rest.client.json.PlainpasswordJSON;
import jetbrains.jetpass.auth.module.core.rest.client.json.ShapasswordJSON;
import jetbrains.jetpass.auth.module.core.rest.client.json.Md5passwordJSON;
import jetbrains.jetpass.auth.module.core.rest.client.json.CoreauthmoduleJSON;
import jetbrains.jetpass.auth.module.ldap.rest.client.json.LdapdetailsJSON;
import jetbrains.jetpass.auth.module.ldap.rest.client.json.LdapauthmoduleJSON;
import jetbrains.jetpass.auth.module.jira.rest.client.json.JiradetailsJSON;
import jetbrains.jetpass.auth.module.jira.rest.client.json.JiraauthmoduleJSON;
import jetbrains.jetpass.auth.module.jba.rest.client.json.JbadetailsJSON;
import jetbrains.jetpass.auth.module.jba.rest.client.json.JbaauthmoduleJSON;
import jetbrains.jetpass.auth.module.openid.rest.client.json.OpeniddetailsJSON;
import jetbrains.jetpass.auth.module.openid.rest.client.json.OpenidauthmoduleJSON;
import jetbrains.jetpass.auth.module.google.rest.client.json.GoogledetailsJSON;
import jetbrains.jetpass.auth.module.google.rest.client.json.GoogleauthmoduleJSON;
import jetbrains.jetpass.auth.module.github.rest.client.json.GithubdetailsJSON;
import jetbrains.jetpass.auth.module.github.rest.client.json.GithubauthmoduleJSON;
import jetbrains.jetpass.rest.dto.LicenseJSON;
import jetbrains.jetpass.rest.dto.PublicSettingsJSON;
import jetbrains.jetpass.rest.dto.SmtpSettingsJSON;
import jetbrains.jetpass.rest.dto.JabberSettingsJSON;
import jetbrains.jetpass.rest.dto.BackupSettingsJSON;
import jetbrains.jetpass.rest.dto.ImportSettingsJSON;
import jetbrains.jetpass.rest.dto.UserJSON;
import jetbrains.jetpass.rest.dto.UserGroupJSON;
import jetbrains.jetpass.rest.dto.ServiceJSON;

public class HubClient {
  @NotNull
  private final URI baseUrl;
  private final Client client;
  private final WebTarget root;
  private final HubURLBuilder urlBuilder;

  private HubClient(HubClient.HubClientBuilder builder) {
    this.baseUrl = builder.baseUrl;
    this.client = builder.client;
    this.root = client.target(URIHelper.toApiUri(baseUrl));
    this.urlBuilder = new HubURLBuilder(baseUrl.toASCIIString());
  }

  @NotNull
  public String getBaseUrl() {
    return baseUrl.toASCIIString();
  }

  @NotNull
  public URI getBaseUri() {
    return baseUrl;
  }

  @NotNull
  public Client getJerseyClient() {
    return client;
  }

  @NotNull
  public WebTarget getRootResource() {
    return root;
  }

  @NotNull
  public HubURLBuilder getURLBuilder() {
    return this.urlBuilder;
  }

  @NotNull
  public BaseAccountsClient getAccountsClient() {
    return getAccountsClient(null, null);
  }

  @NotNull
  public BaseAccountsClient getAccountsClient(String serviceId, String serviceSecret, String... scope) {
    OAuth2ClientFlow flow = null;
    if ((serviceId != null && serviceId.length() > 0)) {
      OAuth2Client o = getOAuthClient();

      flow = o.clientFlow().clientId(serviceId).clientSecret(serviceSecret).scope(scope).addScope(o.getHubScope()).build();
    }

    return getAccountsClient(flow);
  }

  @NotNull
  public BaseAccountsClient getAccountsClient(@Nullable TokenHolder holder) {
    return new ImmutableAccountsClient(this, holder);
  }

  @NotNull
  public OAuth2Client getOAuthClient() {
    return OAuth2Client.builder(client).baseUrl(baseUrl).build();
  }

  @NotNull
  public static HubClient.HubClientBuilder builder() {
    return builder(ClientBuilder.newBuilder());
  }

  @NotNull
  public static HubClient.HubClientBuilder builder(ClientBuilder builder) {
    return new HubClient.HubClientBuilder(builder);
  }

  public static class HubClientBuilder implements jetbrains.jetpass.client.hub.ClientBuilder<HubClient> {
    private static final Set<Class> STATIC_CONTEXT = new HashSet();

    private final Client client;
    @Nullable
    private URI baseUrl;

    private HubClientBuilder(final ClientBuilder builder) {
      builder.register(HubClient.HubClientBuilder.JacksonProvider.class);
      builder.register(HubClient.HubClientBuilder.JAXBContextResolver.class);
      this.client = builder.build();
    }

    public HubClient.HubClientBuilder baseUrl(@Nullable String baseUrl) {
      return baseUrl((baseUrl != null ?
        URI.create(baseUrl) :
        null
      ));
    }

    public HubClient.HubClientBuilder baseUrl(@Nullable URL baseUrl) {
      if (baseUrl == null) {
        return this;
      }
      return baseUrl(baseUrl.toString());
    }

    public HubClient.HubClientBuilder baseUrl(@Nullable URI baseUri) {
      this.baseUrl = baseUri;
      return this;
    }

    public HubClient.HubClientBuilder connectTimeout(Integer timeout) {
      client.property(ClientProperties.CONNECT_TIMEOUT, timeout);
      return this;
    }

    public HubClient.HubClientBuilder readTimeout(Integer timeout) {
      client.property(ClientProperties.READ_TIMEOUT, timeout);
      return this;
    }

    public Client getClient() {
      return client;
    }

    public HubClient build() {
      if (baseUrl == null) {
        throw new IllegalStateException("Empty Ring URL");
      }
      HubClient client = new HubClient(this);
      return client;
    }

    public static class JAXBContextResolver implements ContextResolver<JAXBContext> {
      public JAXBContextResolver() {
      }

      public JAXBContext getContext(Class<?> clazz) {
        ClassLoader original = Thread.currentThread().getContextClassLoader();
        try {
          Thread.currentThread().setContextClassLoader(this.getClass().getClassLoader());
          int staticSize = STATIC_CONTEXT.size();
          Class[] context = new Class[staticSize + 1];
          context = STATIC_CONTEXT.toArray(context);
          context[staticSize] = clazz;
          return JAXBContext.newInstance(context);
        } catch (JAXBException e) {
          e.printStackTrace();
          return null;
        } finally {
          Thread.currentThread().setContextClassLoader(original);
        }
      }
    }

    @Provider
    public static class JacksonProvider extends JacksonJsonProvider {
      public JacksonProvider() {
        ObjectMapper mapper = new ObjectMapper();
        mapper.disable(DeserializationFeature.FAIL_ON_UNKNOWN_PROPERTIES);
        mapper.setAnnotationIntrospector(new AnnotationIntrospectorPair(new JaxbAnnotationIntrospector(), new JacksonAnnotationIntrospector()));
        mapper.registerSubtypes(STATIC_CONTEXT.toArray(new Class[STATIC_CONTEXT.size()]));
        this.setMapper(mapper);
      }
    }

    static {
      // Contact extensions 
      STATIC_CONTEXT.add(EmailJSON.class);
      STATIC_CONTEXT.add(JabberJSON.class);

      STATIC_CONTEXT.add(ExternalauthmoduleJSON.class);

      // Core user details extenstion 
      STATIC_CONTEXT.add(CoreuserdetailsJSON.class);
      STATIC_CONTEXT.add(LoginuserdetailsJSON.class);
      STATIC_CONTEXT.add(EmailuserdetailsJSON.class);
      STATIC_CONTEXT.add(PlainpasswordJSON.class);
      STATIC_CONTEXT.add(ShapasswordJSON.class);
      STATIC_CONTEXT.add(Md5passwordJSON.class);

      STATIC_CONTEXT.add(CoreauthmoduleJSON.class);

      // LDAP user details extenstion 
      STATIC_CONTEXT.add(LdapdetailsJSON.class);
      STATIC_CONTEXT.add(LdapauthmoduleJSON.class);

      // JIRA user details extenstion 
      STATIC_CONTEXT.add(JiradetailsJSON.class);
      STATIC_CONTEXT.add(JiraauthmoduleJSON.class);

      // JBA user details extenstion 
      STATIC_CONTEXT.add(JbadetailsJSON.class);
      STATIC_CONTEXT.add(JbaauthmoduleJSON.class);

      // OpenId user details extenstion 
      STATIC_CONTEXT.add(OpeniddetailsJSON.class);
      STATIC_CONTEXT.add(OpenidauthmoduleJSON.class);

      // Google user details extenstion 
      STATIC_CONTEXT.add(GoogledetailsJSON.class);
      STATIC_CONTEXT.add(GoogleauthmoduleJSON.class);

      // GitHub user details extenstion 
      STATIC_CONTEXT.add(GithubdetailsJSON.class);
      STATIC_CONTEXT.add(GithubauthmoduleJSON.class);

      // Settings extensions 
      STATIC_CONTEXT.add(LicenseJSON.class);
      STATIC_CONTEXT.add(PublicSettingsJSON.class);
      STATIC_CONTEXT.add(SmtpSettingsJSON.class);
      STATIC_CONTEXT.add(JabberSettingsJSON.class);
      STATIC_CONTEXT.add(BackupSettingsJSON.class);
      STATIC_CONTEXT.add(ImportSettingsJSON.class);

      // Authholder extensions 
      STATIC_CONTEXT.add(UserJSON.class);
      STATIC_CONTEXT.add(UserGroupJSON.class);
      STATIC_CONTEXT.add(ServiceJSON.class);
    }
  }
}
