package jetbrains.jetpass.client.hub;

/*Generated by MPS */

import org.jetbrains.annotations.NotNull;
import javax.ws.rs.core.UriBuilder;

public class HubURLBuilder {
  private final String baseUrl;

  public HubURLBuilder(final String baseUrl) {
    String base = baseUrl;
    if (!(baseUrl.endsWith("/"))) {
      base = base + "/";
    }
    this.baseUrl = base;
  }

  @NotNull
  public String getUserProfileURL(String userId) {
    return UriBuilder.fromUri(baseUrl).path("users").path("{userId}").build(userId).toString();
  }

  @NotNull
  public String getMyUserProfileURL() {
    return UriBuilder.fromUri(baseUrl).path("users").path("{userId}").build("me").toString();
  }

  @NotNull
  public String getGroupURL(String groupId) {
    return UriBuilder.fromUri(baseUrl).path("groups").path("{groupId}").build(groupId).toString();
  }

  @NotNull
  public String getServiceURL(String serviceId, String wikiMessage) {
    UriBuilder builder = UriBuilder.fromUri(baseUrl);
    builder.path("services").path("{serviceId}");
    if (wikiMessage != null) {
      builder.queryParam("wikiMessage", wikiMessage);
    }
    return builder.build(serviceId).toString();
  }

  @NotNull
  @Deprecated
  public String getSpaceURL(String spaceId) {
    return UriBuilder.fromUri(baseUrl).path("projects").path("{spaceId}").build(spaceId).toString();
  }

  @NotNull
  public String getProjectURL(String projectId) {
    return UriBuilder.fromUri(baseUrl).path("projects").path("{projectId}").build(projectId).toString();
  }

  @NotNull
  public String getRoleURL(String roleId) {
    return UriBuilder.fromUri(baseUrl).path("roles").path("{roleId}").build(roleId).toString();
  }

  @NotNull
  public String getAvatarURL(String userId) {
    return getAvatarURL(userId, -1);
  }

  @NotNull
  public String getAvatarURL(String userId, int size) {
    UriBuilder fromUri = UriBuilder.fromUri(baseUrl);
    if (!(baseUrl.endsWith("/api/"))) {
      fromUri.path("api");
    }
    UriBuilder path = fromUri.path("rest").path("avatar").path("{userId}");
    if (size > 0) {
      path.queryParam("s", size);
    }
    return path.build(userId).toString();
  }
}
