package jetbrains.jetpass.client.oauth2.auth;

/*Generated by MPS */

import jetbrains.jetpass.client.oauth2.token.OAuth2CodeResponseFlow;
import java.net.URI;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;
import jetbrains.jetpass.client.oauth2.token.OAuth2TokenFlow;

public class CodeHandler {
  private final OAuth2CodeResponseFlow.Builder builder;
  private final URI redirectUri;
  private final String state;

  public CodeHandler(@NotNull OAuth2CodeResponseFlow.Builder builder, @NotNull URI redirectUri, @Nullable String state) {
    this.builder = builder;
    this.redirectUri = redirectUri;
    this.state = (state != null ?
      state.intern() :
      null
    );
  }

  public OAuth2CodeResponseFlow exchange(@NotNull String clientSecret, @NotNull String code) {
    return exchange(clientSecret, code, null, null);
  }

  public OAuth2CodeResponseFlow exchange(@NotNull String clientSecret, @NotNull String code, @Nullable String state) {
    if (this.state != null) {
      if (!(this.state.equals(state))) {
        throw new IllegalStateException("State doesn't match. Expected [" + this.state + "], but was [" + state + "]");
      }
    }

    builder.code(code).clientSecret(clientSecret).build();
    return exchange(clientSecret, code, state, null);
  }

  public OAuth2CodeResponseFlow exchange(@NotNull String clientSecret, @NotNull String code, @Nullable String state, @Nullable OAuth2TokenFlow.ClientAuth clientAuth) {
    if (this.state != null) {
      if (!(this.state.equals(state))) {
        throw new IllegalStateException("State doesn't match. Expected [" + this.state + "], but was [" + state + "]");
      }
    }

    if (clientAuth != null) {
      builder.clientAuth(clientAuth);
    }
    return builder.code(code).clientSecret(clientSecret).build();
  }

  public URI getRedirectUri() {
    return redirectUri;
  }

  @Nullable
  public String getState() {
    return state;
  }
}
