package jetbrains.jetpass.client.oauth2.auth;

/*Generated by MPS */

import com.intellij.hub.auth.request.AuthRequestParameter;
import com.intellij.hub.auth.request.ResponseType;
import org.jetbrains.annotations.NotNull;
import jetbrains.jetpass.client.oauth2.token.OAuth2CodeResponseFlow;
import javax.ws.rs.core.MultivaluedMap;
import javax.ws.rs.client.Client;
import java.net.URI;

public class OAuth2CodeFlow extends OAuth2AuthFlow {
  private final AuthRequestParameter.AccessType accessType;

  private OAuth2CodeFlow(OAuth2CodeFlow.Builder builder) {
    super(builder, ResponseType.CODE);
    accessType = builder.accessType;
  }

  @NotNull
  public CodeHandler getCodeHandler() {
    return new CodeHandler(new OAuth2CodeResponseFlow.Builder(client, authServerURI).redirectUri(redirectUri).clientId(clientId), getAuthUri(), state);
  }

  @NotNull
  @Override
  protected MultivaluedMap<String, String> buildParams() {
    MultivaluedMap<String, String> params = super.buildParams();
    param(params, AuthRequestParameter.ACCESS_TYPE, (accessType != null ?
      accessType.name().toLowerCase() :
      null
    ));
    return params;
  }

  public static class Builder extends OAuth2AuthFlow.Builder<OAuth2CodeFlow.Builder, OAuth2CodeFlow> {
    private AuthRequestParameter.AccessType accessType = null;

    public Builder(@NotNull Client client, @NotNull URI authServerURI) {
      super(client, authServerURI);
    }

    public OAuth2CodeFlow.Builder accessType(AuthRequestParameter.AccessType accessType) {
      this.accessType = accessType;
      return this;
    }

    @NotNull
    public OAuth2CodeFlow build() {
      return new OAuth2CodeFlow(this);
    }
  }
}
