package jetbrains.jetpass.client.oauth2.token;

/*Generated by MPS */

import javax.ws.rs.core.MultivaluedMap;
import javax.ws.rs.core.MultivaluedHashMap;
import com.intellij.hub.auth.request.TokenFormParameter;
import com.intellij.hub.auth.request.GrantType;
import org.jetbrains.annotations.NotNull;
import javax.ws.rs.client.Client;
import java.net.URI;

public class OAuth2RefreshTokenFlow extends OAuth2TokenFlow {
  private final String token;

  private OAuth2RefreshTokenFlow(OAuth2RefreshTokenFlow.Builder builder) {
    super(builder);
    token = builder.token;
  }

  protected MultivaluedMap<String, String> buildParams() {
    MultivaluedMap mMap = new MultivaluedHashMap();
    param(mMap, TokenFormParameter.GRANT_TYPE, GrantType.REFRESH_TOKEN);
    param(mMap, TokenFormParameter.REFRESH_TOKEN, token);
    scope(mMap, TokenFormParameter.SCOPE, scope, encodedScope);
    return mMap;
  }

  public String getRefreshToken() {
    return token;
  }

  public static class Builder extends OAuth2TokenFlow.Builder<OAuth2RefreshTokenFlow.Builder, OAuth2RefreshTokenFlow> {
    private String token;

    public Builder(@NotNull Client client, @NotNull URI authServerURI) {
      super(client, authServerURI);
    }

    @NotNull
    public OAuth2RefreshTokenFlow.Builder token(@NotNull String token) {
      this.token = token;
      return this;
    }

    @NotNull
    public OAuth2RefreshTokenFlow build() {
      return new OAuth2RefreshTokenFlow(this);
    }
  }
}
