package jetbrains.jetpass.client.oauth2.token;

/*Generated by MPS */

import javax.ws.rs.core.MultivaluedMap;
import javax.ws.rs.core.MultivaluedHashMap;
import com.intellij.hub.auth.request.TokenFormParameter;
import com.intellij.hub.auth.request.GrantType;
import org.jetbrains.annotations.NotNull;
import javax.ws.rs.client.Client;
import java.net.URI;

public class OAuth2ResourceOwnerFlow extends OAuth2TokenFlow {
  private final String username;
  private final String password;

  private OAuth2ResourceOwnerFlow(OAuth2ResourceOwnerFlow.Builder builder) {
    super(builder);
    username = builder.username;
    password = builder.password;
  }

  protected MultivaluedMap<String, String> buildParams() {
    MultivaluedMap mMap = new MultivaluedHashMap();
    param(mMap, TokenFormParameter.GRANT_TYPE, GrantType.PASSWORD);
    param(mMap, TokenFormParameter.USERNAME, username);
    param(mMap, TokenFormParameter.PASSWORD, password);
    scope(mMap, TokenFormParameter.SCOPE, scope, encodedScope);
    return mMap;
  }

  public static class Builder extends OAuth2TokenFlow.Builder<OAuth2ResourceOwnerFlow.Builder, OAuth2ResourceOwnerFlow> {
    private String username;
    private String password;

    public Builder(@NotNull Client client, @NotNull URI authServerURI) {
      super(client, authServerURI);
    }

    @NotNull
    public OAuth2ResourceOwnerFlow.Builder username(@NotNull String username) {
      this.username = username;
      return this;
    }

    @NotNull
    public OAuth2ResourceOwnerFlow.Builder password(@NotNull String password) {
      this.password = password;
      return this;
    }

    @NotNull
    public OAuth2ResourceOwnerFlow build() {
      return new OAuth2ResourceOwnerFlow(this);
    }
  }
}
