package jetbrains.jetpass.client.resource;

/*Generated by MPS */

import com.intellij.hub.auth.oauth2.provider.source.BaseDSAPublicKeySource;
import jetbrains.jetpass.client.hub.HubClient;
import org.jetbrains.annotations.NotNull;
import com.intellij.hub.auth.oauth2.provider.source.KeyAndVersion;
import com.intellij.hub.auth.oauth2.provider.source.KeyLoadException;
import javax.ws.rs.WebApplicationException;
import javax.ws.rs.core.Response;
import com.intellij.hub.auth.oauth2.provider.source.UnexpectedKeyResponseCodeException;

public class DSAPublicKeySource extends BaseDSAPublicKeySource {
  private final HubClient client;

  public DSAPublicKeySource(HubClient client) {
    this.client = client;
  }

  @NotNull
  protected KeyAndVersion loadKey() throws KeyLoadException {
    try {
      String key = client.getOAuthClient().getPublicKey();

      // some paranoid stuff from Danila Ponomarenko 
      if ((key == null || key.length() == 0)) {
        throw new IllegalStateException("Hub returned empty response instead of public auth key");
      }

      return KeyAndVersion.parse(key);
    } catch (WebApplicationException ex) {
      int status = ex.getResponse().getStatus();
      if (status != Response.Status.OK.getStatusCode()) {
        throw new UnexpectedKeyResponseCodeException(status);
      }
      throw new KeyLoadException(ex);
    }
  }
}
