package jetbrains.jetpass.dao.api;

/*Generated by MPS */

import jetbrains.jetpass.api.IdItem;
import org.jetbrains.annotations.Nullable;

public 
/**
 * Mutable services allows you to modify items which they provides
 * 
 * @param T item type which handles service
 */
interface MutableDAO<T extends IdItem> extends DAO<T> {
  public T create(T item) throws DataAccessException;
  public void update(String id, T item) throws DataAccessException;
  /**
   * Deletes entity by id
   * Default deletion policy may be applied
   * 
   * @param id entity id to delete
   * @throws DataAccessException is some errors occurs
   */
  public void delete(String id) throws DataAccessException;
  /**
   * Deletes entity by id
   * If successor is provided, than deleted id will be saved to successor history
   * If successor is not provided, than default successor will be used
   * 
   * @param id entity id to delete
   * @param successor id of successor where to write hisotry
   * @throws DataAccessException is some errors occurs
   */
  public void delete(String id, @Nullable String successor) throws DataAccessException;
  public void addListener(Listener<T> listener);
  public void removeListener(Listener<T> listener);
}
