package jetbrains.jetpass.dao.api.authority;

/*Generated by MPS */

import jetbrains.jetpass.dao.api.MutableDAO;
import jetbrains.jetpass.api.authority.module.AuthModule;
import jetbrains.jetpass.dao.api.NamedDAO;
import jetbrains.jetpass.sequence.Sequence;
import jetbrains.jetpass.api.authority.UserGroup;
import jetbrains.jetpass.dao.api.DataAccessException;
import jetbrains.jetpass.api.authority.details.UserDetails;
import org.jetbrains.annotations.NotNull;
import jetbrains.jetpass.api.authority.User;
import org.jetbrains.annotations.Nullable;

public interface AuthModuleDAO extends MutableDAO<AuthModule>, NamedDAO<AuthModule> {
  public AuthModule getByUrl(String url);
  public Sequence<AuthModule> getByType(String typeName);
  public void addAutoJoinGroup(AuthModule module, UserGroup userGroup) throws DataAccessException;
  public void removeAutoJoinGroup(AuthModule module, UserGroup userGroup) throws DataAccessException;
  public UserDetails resolve(AuthModule module, String username, String password) throws DataAccessException;
  /**
   * Login by username and password
   * 
   * @param username user identifier
   * @param password user password
   * @throws DataAccessException login fail exception
   * @return logged in user
   */
  @NotNull
  public User login(@NotNull String username, @NotNull String password) throws DataAccessException;
  /**
   * Is used to support old case of migration users from YouTrack for users with same creds but from
   * different services
   * 
   * @param username user login or identifier
   * @param password user password
   * @param clientServiceId service id - if service id is passed than resulting users with same creads will be sorted by service id
   * @throws DataAccessException unable to login with give credentials
   * @return logged in user
   */
  @NotNull
  public User login(@NotNull String username, @NotNull String password, @Nullable String clientServiceId) throws DataAccessException;
}
