package jetbrains.jetpass.dao.api.authority;

/*Generated by MPS */

import jetbrains.jetpass.dao.api.NamedDAO;
import jetbrains.jetpass.api.authority.User;
import jetbrains.jetpass.dao.api.MutableDAO;
import org.jetbrains.annotations.NotNull;
import jetbrains.jetpass.api.authority.profile.DefaultAvatar;
import jetbrains.jetpass.api.authority.details.UserDetails;
import jetbrains.jetpass.dao.api.DataAccessException;
import org.jetbrains.annotations.Nullable;
import jetbrains.jetpass.api.authority.Profile;
import jetbrains.jetpass.api.authority.SshPublicKey;

public interface UserDAO extends NamedDAO<User>, MutableDAO<User>, AuthorityHolderDAO<User> {
  @NotNull
  public User getGuest();
  @NotNull
  public DefaultAvatar getDefaultAvatar();
  public UserDetails addUserDetails(String userId, UserDetails userDetails) throws DataAccessException;
  public void removeUserDetails(String userId, String userDetailsId) throws DataAccessException;
  public User invite(String email) throws DataAccessException;
  @Nullable
  public User merge(Iterable<User> users, String login, String name, String email, String jabber, Boolean banned) throws DataAccessException;
  public Profile verifyContact(String userId, Profile profile) throws DataAccessException;
  public SshPublicKey addSshPublicKey(String userId, SshPublicKey sshPublicKey) throws DataAccessException;
  public void removeSshPublicKey(String userId, String fingerPrint) throws DataAccessException;
}
