package jetbrains.jetpass.dao.api.permissionCache;

/*Generated by MPS */

import java.util.Set;

public abstract class BasePermissionQuery<B> {
  protected final String globalProjectUUID;
  protected String permissionUUID;
  protected String rolesUUID;
  protected String projectUUID;

  public BasePermissionQuery(String globalProjectUUID) {
    this.globalProjectUUID = globalProjectUUID;
  }

  public final B withPermission(String permissionUUID) {
    this.permissionUUID = permissionUUID;
    this.rolesUUID = null;
    return ((B) this);
  }

  public final B withRole(String roleUUID) {
    this.permissionUUID = null;
    this.rolesUUID = roleUUID;
    return ((B) this);
  }

  public final B toProject(String projectUUID) {
    this.projectUUID = projectUUID;
    return ((B) this);
  }

  public final B toGlobalProject() {
    this.projectUUID = globalProjectUUID;
    return ((B) this);
  }

  public B copy(BasePermissionQuery source) {
    this.permissionUUID = source.permissionUUID;
    this.rolesUUID = source.rolesUUID;
    this.projectUUID = source.projectUUID;
    return ((B) this);
  }

  public String getGlobalProjectUUID() {
    return globalProjectUUID;
  }

  public abstract B clone();

  public abstract boolean canAccess();

  public abstract boolean canAccessGlobal();

  public abstract Set<String> getAccessibleProjects();

  public abstract Set<String> getGrantedRoles();

  public abstract Set<String> getGrantedPermissions();
}
