package jetbrains.jetpass.dao.api.permissionCache;

/*Generated by MPS */


public abstract class PermissionSource {
  public PermissionSource() {
  }

  public PermissionSource getGlobal() {
    return this;
  }

  public static PermissionSource.OwnRole ownRole(String projectUUID, String roleUUID) {
    return new PermissionSource.OwnRole(projectUUID, roleUUID);
  }

  public static PermissionSource.OwnRole ownRole(String projectUUID, String roleUUID, boolean global) {
    return new PermissionSource.OwnRole(projectUUID, roleUUID, global);
  }

  public static PermissionSource.OwnRole ownGlobalRole(PermissionSource.OwnRole ownRole) {
    return new PermissionSource.OwnRole(ownRole.projectUUID, ownRole.roleUUID, true);
  }

  public static PermissionSource.ContainingGroup containingGroup(String groupUUID) {
    return new PermissionSource.ContainingGroup(groupUUID);
  }

  public static PermissionSource.ParentGroup parentGroup(String groupUUID) {
    return new PermissionSource.ParentGroup(groupUUID);
  }

  public static class OwnRole extends PermissionSource {
    private final String projectUUID;
    private final boolean global;
    private final String roleUUID;

    protected OwnRole(String projectUUID, String roleUUID) {
      this(projectUUID, roleUUID, false);
    }

    protected OwnRole(String projectUUID, String roleUUID, boolean global) {
      this.global = global;
      this.projectUUID = projectUUID;
      this.roleUUID = roleUUID;
    }

    @Override
    public PermissionSource getGlobal() {
      return PermissionSource.ownGlobalRole(this);
    }

    public String getProjectUUID() {
      return projectUUID;
    }

    public String getRoleUUID() {
      return roleUUID;
    }

    public boolean isGlobal() {
      return global;
    }

    @Override
    public boolean equals(Object o) {
      if (this == o) {
        return true;
      }
      if (o == null || this.getClass() != o.getClass()) {
        return false;
      }

      PermissionSource.OwnRole that = (PermissionSource.OwnRole) o;
      if ((projectUUID != null ?
        !(((Object) projectUUID).equals(that.projectUUID)) :
        that.projectUUID != null
      )) {
        return false;
      }
      if (global != that.global) {
        return false;
      }
      if ((roleUUID != null ?
        !(((Object) roleUUID).equals(that.roleUUID)) :
        that.roleUUID != null
      )) {
        return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      int result = 0;
      result = 31 * result + ((projectUUID != null ?
        String.valueOf(projectUUID).hashCode() :
        0
      ));
      result = 31 * result + ((global ?
        1 :
        0
      ));
      result = 31 * result + ((roleUUID != null ?
        String.valueOf(roleUUID).hashCode() :
        0
      ));
      return result;
    }

    @Override
    public String toString() {
      return "OwnRole{" + "projectUUID=" + projectUUID + ", global=" + global + ", roleUUID=" + roleUUID + "}";
    }
  }

  public static class ContainingGroup extends PermissionSource {
    private final String groupUUID;

    protected ContainingGroup(String groupUUID) {
      this.groupUUID = groupUUID;
    }

    public String getGroupUUID() {
      return groupUUID;
    }

    @Override
    public boolean equals(Object o) {
      if (this == o) {
        return true;
      }
      if (o == null || this.getClass() != o.getClass()) {
        return false;
      }

      PermissionSource.ContainingGroup that = (PermissionSource.ContainingGroup) o;
      if ((groupUUID != null ?
        !(((Object) groupUUID).equals(that.groupUUID)) :
        that.groupUUID != null
      )) {
        return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      int result = 0;
      result = 31 * result + ((groupUUID != null ?
        String.valueOf(groupUUID).hashCode() :
        0
      ));
      return result;
    }

    @Override
    public String toString() {
      return "ContainingGroup{" + "groupUUID=" + groupUUID + "}";
    }
  }

  public static class ParentGroup extends PermissionSource {
    private final String parentGroupUUID;

    protected ParentGroup(String parentGroupUUID) {
      this.parentGroupUUID = parentGroupUUID;
    }

    public String getParentGroupUUID() {
      return parentGroupUUID;
    }

    @Override
    public boolean equals(Object o) {
      if (this == o) {
        return true;
      }
      if (o == null || this.getClass() != o.getClass()) {
        return false;
      }

      PermissionSource.ParentGroup that = (PermissionSource.ParentGroup) o;
      if ((parentGroupUUID != null ?
        !(((Object) parentGroupUUID).equals(that.parentGroupUUID)) :
        that.parentGroupUUID != null
      )) {
        return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      int result = 0;
      result = 31 * result + ((parentGroupUUID != null ?
        String.valueOf(parentGroupUUID).hashCode() :
        0
      ));
      return result;
    }

    @Override
    public String toString() {
      return "ParentGroup{" + "parentGroupUUID=" + parentGroupUUID + "}";
    }
  }
}
