package jetbrains.jetpass.dao.api.security;

/*Generated by MPS */

import jetbrains.jetpass.dao.api.MutableDAO;
import jetbrains.jetpass.api.security.Project;
import jetbrains.jetpass.dao.api.NamedDAO;
import org.jetbrains.annotations.NotNull;
import jetbrains.jetpass.sequence.Sequence;
import jetbrains.jetpass.dao.api.DataAccessException;
import jetbrains.jetpass.api.security.Team;

public interface ProjectDAO extends MutableDAO<Project>, NamedDAO<Project> {
  /**
   * Returns all project items without archived
   * 
   * @return sequence of projects
   */
  @NotNull
  public Sequence<Project> getAllItems();
  /**
   * Returns all project items
   * 
   * @param withArchived if true - returns also archived spces
   * @return sequence of projects
   */
  @NotNull
  public Sequence<Project> getAllItems(boolean withArchived);
  public Project getGlobal();
  public void addResource(String projectId, String resourceId) throws DataAccessException;
  public void removeResource(String projectId, String resourceId) throws DataAccessException;
  public Project merge(Iterable<Project> projects, String key, String name, String description, Boolean archived) throws DataAccessException;
  public Sequence<Team> getTeams(String projectId) throws DataAccessException;
  public Team getWholeTeam(String projectId) throws DataAccessException;
  public Team getTeam(String projectId, String roleId) throws DataAccessException;
  public Team addTeam(String projectId, Team team) throws DataAccessException;
}
