package jetbrains.jetpass.dao.remote.api;

/*Generated by MPS */

import jetbrains.jetpass.sequence.iter.ImmutableIterator;
import java.util.Iterator;
import java.util.NoSuchElementException;
import jetbrains.mps.webr.rpc.rest.json.common.runtime.Page;

public abstract class PageIterator<J> extends ImmutableIterator<J> {
  private static final int DEFAULT_PAGE_SIZE = 100;

  private int page = 0;
  private int pageSize;
  private Iterator<J> pageIterator;
  private boolean hasNextPage = true;

  public PageIterator() {
    this(DEFAULT_PAGE_SIZE);
  }

  public PageIterator(int pageSize) {
    this.pageSize = Math.max(pageSize, 1);
  }

  public boolean hasNext() {
    if (pageIterator == null) {
      this.move();
    }
    boolean hasNext = pageIterator.hasNext();
    if (!(hasNext)) {
      // check if we have next page 
      if (hasNextPage) {
        this.move();
        hasNext = pageIterator.hasNext();
      } else {
        hasNext = false;
      }
    }
    return hasNext;
  }

  public J next() {
    if (!(hasNext())) {
      throw new NoSuchElementException();
    }
    return pageIterator.next();
  }

  protected abstract Page<J> fetch(int skip, int top);

  private void move() {
    Page<J> remotePage = fetch(page * pageSize, pageSize);
    page++;
    hasNextPage = isNotEmpty_vrzfvi_a0a2a3(remotePage.getNext());
    this.pageIterator = remotePage.getItems().iterator();
  }

  public static boolean isNotEmpty_vrzfvi_a0a2a3(String str) {
    return str != null && str.length() > 0;
  }
}
