package jetbrains.jetpass.dao.remote.api;

/*Generated by MPS */

import jetbrains.jetpass.dao.api.API;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import java.util.List;
import java.util.ArrayList;
import java.util.Map;
import java.util.HashMap;
import jetbrains.jetpass.dao.api.permissionCache.PermissionCache;
import java.util.concurrent.atomic.AtomicBoolean;
import jetbrains.jetpass.dao.remote.api.event.RemoteEventDAO;
import jetbrains.jetpass.dao.remote.api.security.RemoteResourceDAO;
import jetbrains.jetpass.dao.remote.api.security.RemoteSpaceRoleDAO;
import jetbrains.jetpass.dao.remote.api.security.RemoteProjectRoleDAO;
import jetbrains.jetpass.dao.remote.api.security.RemotePermissionDAO;
import jetbrains.jetpass.dao.remote.api.security.RemoteRoleDAO;
import jetbrains.jetpass.dao.remote.api.security.RemoteSpaceDAO;
import jetbrains.jetpass.dao.remote.api.security.RemoteProjectDAO;
import jetbrains.jetpass.dao.remote.api.authority.RemoteUserDAO;
import jetbrains.jetpass.dao.remote.api.authority.RemoteUserGroupDAO;
import jetbrains.jetpass.dao.remote.api.authority.RemoteUserDetailsDAO;
import jetbrains.jetpass.dao.remote.api.authority.RemoteAuthModuleDAO;
import jetbrains.jetpass.dao.remote.api.settings.RemoteSettingsDAO;
import jetbrains.jetpass.dao.remote.api.ssl.RemoteKeyStoreDAO;
import jetbrains.jetpass.dao.remote.api.ssl.RemoteCertificateDAO;
import jetbrains.jetpass.dao.remote.api.metrics.RemoteMetricsDAO;
import jetbrains.jetpass.client.accounts.EventClient;
import jetbrains.jetpass.client.accounts.BaseAccountsClient;
import org.jetbrains.annotations.Nullable;
import jetbrains.jetpass.api.event.Event;
import jetbrains.jetpass.rest.dto.EventJSON;
import jetbrains.jetpass.api.Service;
import jetbrains.jetpass.rest.dto.ServiceJSON;
import jetbrains.jetpass.client.accounts.Partial;
import jetbrains.jetpass.api.settings.Settings;
import jetbrains.jetpass.rest.dto.SettingsJSON;
import jetbrains.jetpass.api.settings.LicenseSettings;
import jetbrains.jetpass.rest.dto.LicenseJSON;
import jetbrains.jetpass.api.settings.PublicSettings;
import jetbrains.jetpass.rest.dto.PublicSettingsJSON;
import jetbrains.jetpass.api.settings.SMTPSettings;
import jetbrains.jetpass.rest.dto.SmtpSettingsJSON;
import jetbrains.jetpass.api.settings.JabberSettings;
import jetbrains.jetpass.rest.dto.JabberSettingsJSON;
import jetbrains.jetpass.api.settings.BackupSettings;
import jetbrains.jetpass.rest.dto.BackupSettingsJSON;
import jetbrains.jetpass.api.settings.ImportSettings;
import jetbrains.jetpass.rest.dto.ImportSettingsJSON;
import jetbrains.jetpass.api.metrics.Metrics;
import jetbrains.jetpass.rest.dto.MetricsJSON;
import jetbrains.jetpass.api.ssl.KeyStore;
import jetbrains.jetpass.rest.dto.KeyStoreJSON;
import jetbrains.jetpass.api.ssl.Certificate;
import jetbrains.jetpass.rest.dto.CertificateJSON;
import jetbrains.jetpass.api.security.Resource;
import jetbrains.jetpass.rest.dto.ResourceJSON;
import jetbrains.jetpass.api.security.SpaceRole;
import jetbrains.jetpass.rest.dto.SpaceRoleJSON;
import jetbrains.jetpass.api.security.ProjectRole;
import jetbrains.jetpass.rest.dto.ProjectRoleJSON;
import jetbrains.jetpass.api.security.Permission;
import jetbrains.jetpass.rest.dto.PermissionJSON;
import jetbrains.jetpass.api.security.Role;
import jetbrains.jetpass.rest.dto.RoleJSON;
import jetbrains.jetpass.api.security.Space;
import jetbrains.jetpass.rest.dto.SpaceJSON;
import jetbrains.jetpass.api.security.Project;
import jetbrains.jetpass.rest.dto.ProjectJSON;
import jetbrains.jetpass.api.authority.User;
import jetbrains.jetpass.rest.dto.UserJSON;
import jetbrains.jetpass.api.authority.UserGroup;
import jetbrains.jetpass.rest.dto.UserGroupJSON;
import jetbrains.jetpass.api.authority.details.UserDetails;
import jetbrains.jetpass.rest.dto.DetailsJSON;
import jetbrains.jetpass.auth.module.ldap.rest.client.api.LdapUserDetails;
import jetbrains.jetpass.auth.module.ldap.rest.client.json.LdapdetailsJSON;
import jetbrains.jetpass.auth.module.jira.rest.client.api.JiraUserDetails;
import jetbrains.jetpass.auth.module.jira.rest.client.json.JiradetailsJSON;
import jetbrains.jetpass.auth.module.openid.rest.client.api.OpenIDUserDetails;
import jetbrains.jetpass.auth.module.openid.rest.client.json.OpeniddetailsJSON;
import jetbrains.jetpass.auth.module.jba.rest.client.api.JBAUserDetails;
import jetbrains.jetpass.auth.module.jba.rest.client.json.JbadetailsJSON;
import jetbrains.jetpass.auth.module.core.rest.client.api.LoginUserDetails;
import jetbrains.jetpass.auth.module.core.rest.client.json.LoginuserdetailsJSON;
import jetbrains.jetpass.auth.module.core.rest.client.api.EmailUserDetails;
import jetbrains.jetpass.auth.module.core.rest.client.json.EmailuserdetailsJSON;
import jetbrains.jetpass.auth.module.github.rest.client.api.GithubUserDetails;
import jetbrains.jetpass.auth.module.github.rest.client.json.GithubdetailsJSON;
import jetbrains.jetpass.auth.module.google.rest.client.api.GoogleUserDetails;
import jetbrains.jetpass.auth.module.google.rest.client.json.GoogledetailsJSON;
import jetbrains.jetpass.api.authority.module.AuthModule;
import jetbrains.jetpass.rest.dto.AuthmoduleJSON;
import jetbrains.jetpass.auth.module.ldap.rest.client.api.LdapAuthModule;
import jetbrains.jetpass.auth.module.ldap.rest.client.json.LdapauthmoduleJSON;
import jetbrains.jetpass.auth.module.jira.rest.client.api.JiraAuthModule;
import jetbrains.jetpass.auth.module.jira.rest.client.json.JiraauthmoduleJSON;
import jetbrains.jetpass.auth.module.openid.rest.client.api.OpenIDAuthModule;
import jetbrains.jetpass.auth.module.openid.rest.client.json.OpenidauthmoduleJSON;
import jetbrains.jetpass.auth.module.jba.rest.client.api.JBAAuthModule;
import jetbrains.jetpass.auth.module.jba.rest.client.json.JbaauthmoduleJSON;
import jetbrains.jetpass.auth.module.core.rest.client.api.CoreAuthModule;
import jetbrains.jetpass.auth.module.core.rest.client.json.CoreauthmoduleJSON;
import jetbrains.jetpass.auth.module.github.rest.client.api.GithubAuthModule;
import jetbrains.jetpass.auth.module.github.rest.client.json.GithubauthmoduleJSON;
import jetbrains.jetpass.auth.module.google.rest.client.api.GoogleAuthModule;
import jetbrains.jetpass.auth.module.google.rest.client.json.GoogleauthmoduleJSON;
import jetbrains.jetpass.api.IdItem;
import java.util.Collections;
import jetbrains.jetpass.dao.api.Listener;
import java.util.Set;
import java.util.HashSet;
import jetbrains.jetpass.dao.remote.HubAPI;
import jetbrains.jetpass.api.event.Change;

public class RemoteAPI implements RemoteItemStoreContainer, API {
  private static final long NEVER = -1;
  protected static Log log = LogFactory.getLog(RemoteAPI.class);

  private List<FieldFetchListener> fieldFetchListeners = new ArrayList<FieldFetchListener>(1);
  private Map<Class<?>, RemoteItemStore<?, ?>> remoteItemStores = new HashMap<Class<?>, RemoteItemStore<?, ?>>();
  private final RemoteAPI.PermissionCacheUpdater permissionCacheUpdater = new RemoteAPI.PermissionCacheUpdater(new PermissionCache());
  private final long syncInteval;
  private volatile long lastSyncMoment = NEVER;
  private AtomicBoolean allSynced = new AtomicBoolean(false);
  private final Runnable syncChecker;
  private RemoteEventDAO myEventDAO;
  private RemoteServiceDAO myServiceDAO;
  private RemoteResourceDAO myResourceDAO;
  private RemoteSpaceRoleDAO mySpaceRoleDAO;
  private RemoteProjectRoleDAO myProjectRoleDAO;
  private RemotePermissionDAO myPermissionDAO;
  private RemoteRoleDAO myRoleDAO;
  private RemoteSpaceDAO mySpaceDAO;
  private RemoteProjectDAO myProjectDAO;
  private RemoteUserDAO myUserDAO;
  private RemoteUserGroupDAO myUserGroupDAO;
  private RemoteUserDetailsDAO myUserDetailsDAO;
  private RemoteAuthModuleDAO myAuthModuleDAO;
  private RemoteSettingsDAO mySettingsDAO;
  private RemoteKeyStoreDAO myKeyStoreDAO;
  private RemoteCertificateDAO myCertificateDAO;
  private RemoteMetricsDAO myMetricsDAO;
  private EventClient myEventClient;
  private BaseAccountsClient myClient;

  protected RemoteAPI(BaseAccountsClient client, final long syncInterval) {
    this.setClient(client);
    this.syncInteval = syncInterval;
    syncChecker = new Runnable() {
      public void run() {
        try {
          if (allSynced.get()) {
            syncCheck();
          } else {
            resyncAll();
          }
        } catch (RuntimeException ex) {
          if (log.isErrorEnabled()) {
            log.error("Synchronization failed", ex);
          }
        }
      }
    };
  }

  protected RemoteAPI(BaseAccountsClient client, final long syncInterval, @Nullable ScheduledExecutor executor) {
    this(client, syncInterval);
    if (executor != null) {
      executor.scheduleAtFixedRate(syncChecker, syncInterval);
    }
  }

  private void init() {
    initRemoteItemStore(Event.class, EventJSON.class, RemoteAPI.this.getEventDAO());
    initRemoteItemStore(Service.class, ServiceJSON.class, RemoteAPI.this.getServiceDAO(), Partial.Service.DEFAULT_ROLES().getName());

    initRemoteItemStore(Settings.class, SettingsJSON.class, RemoteAPI.this.getSettingsDAO());
    initSettingsRemoteItemStore(LicenseSettings.class, LicenseJSON.class);
    initSettingsRemoteItemStore(PublicSettings.class, PublicSettingsJSON.class);
    initSettingsRemoteItemStore(SMTPSettings.class, SmtpSettingsJSON.class);
    initSettingsRemoteItemStore(JabberSettings.class, JabberSettingsJSON.class);
    initSettingsRemoteItemStore(BackupSettings.class, BackupSettingsJSON.class);
    initSettingsRemoteItemStore(ImportSettings.class, ImportSettingsJSON.class);

    initRemoteItemStore(Metrics.class, MetricsJSON.class, RemoteAPI.this.getMetricsDAO());
    initRemoteItemStore(KeyStore.class, KeyStoreJSON.class, RemoteAPI.this.getKeyStoreDAO());
    initRemoteItemStore(Certificate.class, CertificateJSON.class, RemoteAPI.this.getCertificateDAO());
    initRemoteItemStore(Resource.class, ResourceJSON.class, RemoteAPI.this.getResourceDAO());
    initRemoteItemStore(SpaceRole.class, SpaceRoleJSON.class, RemoteAPI.this.getSpaceRoleDAO());
    initRemoteItemStore(ProjectRole.class, ProjectRoleJSON.class, RemoteAPI.this.getProjectRoleDAO());
    initRemoteItemStore(Permission.class, PermissionJSON.class, RemoteAPI.this.getPermissionDAO());
    initRemoteItemStore(Role.class, RoleJSON.class, RemoteAPI.this.getRoleDAO());
    initRemoteItemStore(Space.class, SpaceJSON.class, RemoteAPI.this.getSpaceDAO());
    initRemoteItemStore(Project.class, ProjectJSON.class, RemoteAPI.this.getProjectDAO());
    initRemoteItemStore(User.class, UserJSON.class, RemoteAPI.this.getUserDAO());
    initRemoteItemStore(UserGroup.class, UserGroupJSON.class, RemoteAPI.this.getUserGroupDAO());

    initRemoteItemStore(UserDetails.class, DetailsJSON.class, RemoteAPI.this.getUserDetailsDAO());
    initUserDetailsRemoteItemStore(LdapUserDetails.class, LdapdetailsJSON.class);
    initUserDetailsRemoteItemStore(JiraUserDetails.class, JiradetailsJSON.class);
    initUserDetailsRemoteItemStore(OpenIDUserDetails.class, OpeniddetailsJSON.class);
    initUserDetailsRemoteItemStore(JBAUserDetails.class, JbadetailsJSON.class);
    initUserDetailsRemoteItemStore(LoginUserDetails.class, LoginuserdetailsJSON.class);
    initUserDetailsRemoteItemStore(EmailUserDetails.class, EmailuserdetailsJSON.class);
    initUserDetailsRemoteItemStore(GithubUserDetails.class, GithubdetailsJSON.class);
    initUserDetailsRemoteItemStore(GoogleUserDetails.class, GoogledetailsJSON.class);

    initRemoteItemStore(AuthModule.class, AuthmoduleJSON.class, RemoteAPI.this.getAuthModuleDAO());
    initAuthModulesRemoteItemStore(LdapAuthModule.class, LdapauthmoduleJSON.class);
    initAuthModulesRemoteItemStore(JiraAuthModule.class, JiraauthmoduleJSON.class);
    initAuthModulesRemoteItemStore(OpenIDAuthModule.class, OpenidauthmoduleJSON.class);
    initAuthModulesRemoteItemStore(JBAAuthModule.class, JbaauthmoduleJSON.class);
    initAuthModulesRemoteItemStore(CoreAuthModule.class, CoreauthmoduleJSON.class);
    initAuthModulesRemoteItemStore(GithubAuthModule.class, GithubauthmoduleJSON.class);
    initAuthModulesRemoteItemStore(GoogleAuthModule.class, GoogleauthmoduleJSON.class);

    RemoteAPI.this.getEventDAO().itemAccessor.init();
    RemoteAPI.this.getServiceDAO().itemAccessor.init();

    RemoteAPI.this.getSettingsDAO().itemAccessor.init();
    for (RemoteItemAccessor itemAccessor : RemoteAPI.this.getSettingsDAO().getSettingsItemAccessor().values()) {
      itemAccessor.init();
    }

    RemoteAPI.this.getMetricsDAO().itemAccessor.init();
    RemoteAPI.this.getKeyStoreDAO().itemAccessor.init();
    RemoteAPI.this.getCertificateDAO().itemAccessor.init();
    RemoteAPI.this.getResourceDAO().itemAccessor.init();
    RemoteAPI.this.getSpaceRoleDAO().itemAccessor.init();
    RemoteAPI.this.getProjectRoleDAO().itemAccessor.init();
    RemoteAPI.this.getPermissionDAO().itemAccessor.init();
    RemoteAPI.this.getRoleDAO().itemAccessor.init();
    RemoteAPI.this.getSpaceDAO().itemAccessor.init();
    RemoteAPI.this.getProjectDAO().itemAccessor.init();
    RemoteAPI.this.getUserDAO().itemAccessor.init();
    RemoteAPI.this.getUserGroupDAO().itemAccessor.init();
    RemoteAPI.this.getUserDetailsDAO().itemAccessor.init();

    RemoteAPI.this.getAuthModuleDAO().itemAccessor.init();
    for (RemoteItemAccessor itemAccessor : RemoteAPI.this.getUserDetailsDAO().getDetailsRemoteItemAccessor().values()) {
      itemAccessor.init();
    }

    for (RemoteItemAccessor itemAccessor : RemoteAPI.this.getAuthModuleDAO().getAuthModuleItemAccessor().values()) {
      itemAccessor.init();
    }

    RemoteAPI.this.getEventDAO().init();
  }

  protected <I extends IdItem, J extends I> void initRemoteItemStore(Class<I> type, Class<J> dtoType, RemoteDAO<I, J, ?> remoteDAO, String... fieldWrapExclusions) {
    remoteItemStores.put(type, remoteDAO);
    remoteDAO.itemAccessor = new RemoteItemAccessor<I, J>(type, dtoType, this, fieldWrapExclusions);
    remoteDAO.setRemoteAPI(this);
  }

  protected <I extends UserDetails, J extends I> void initUserDetailsRemoteItemStore(Class<I> type, Class<J> dtoType) {
    RemoteAPI.this.getUserDetailsDAO().getDetailsRemoteItemAccessor().put((Class<DetailsJSON>) ((Class) dtoType), new RemoteItemAccessor<I, J>(type, dtoType, this));
    remoteItemStores.put(type, RemoteAPI.this.getUserDetailsDAO());
  }

  protected <I extends AuthModule, J extends I> void initAuthModulesRemoteItemStore(Class<I> type, Class<J> dtoType) {
    RemoteAPI.this.getAuthModuleDAO().getAuthModuleItemAccessor().put((Class<AuthmoduleJSON>) (Class) dtoType, new RemoteItemAccessor<I, J>(type, dtoType, this));
    remoteItemStores.put(type, RemoteAPI.this.getAuthModuleDAO());
  }

  protected <I extends Settings, J extends I> void initSettingsRemoteItemStore(Class<I> type, Class<J> dtoType) {
    RemoteAPI.this.getSettingsDAO().getSettingsItemAccessor().put((Class<SettingsJSON>) (Class) dtoType, new RemoteItemAccessor<I, J>(type, dtoType, this));
    remoteItemStores.put(type, RemoteAPI.this.getSettingsDAO());
  }

  public <I extends IdItem> RemoteItemStore<I, ? extends I> getRemoteDataStore(Class<I> type) {
    return (RemoteItemStore<I, ? extends I>) remoteItemStores.get(type);
  }

  public final void syncNow() {
    sync(RemoteAPI.SyncState.NOW);
  }

  public final void syncCheck() {
    sync(RemoteAPI.SyncState.CHECK);
  }

  public final void resyncAll() {
    sync(RemoteAPI.SyncState.RESET);
  }

  public final void outOfSync() {
    lastSyncMoment = NEVER;
    permissionCacheUpdater.invalidate();
  }

  public Runnable getSyncChecker() {
    return this.syncChecker;
  }

  private void sync(RemoteAPI.SyncState state) {
    long syncStart = System.currentTimeMillis();
    if (state == RemoteAPI.SyncState.CHECK) {
      // fast check without synchronization 
      if (lastSyncMoment >= (syncStart - syncInteval)) {
        return;
      }
      // if time gap is more than synInterval than we need to synchronize and wait if somebody already syncing 
    }

    Iterable<Event> newEvents = Collections.emptyList();
    synchronized (this) {
      switch (state) {
        case CHECK:
          // check if sync needed 
          if (lastSyncMoment >= (syncStart - syncInteval)) {
            return;
          }
          // fall down 
        case NOW:
          // sync delta 
          newEvents = RemoteAPI.this.getEventDAO().syncDelta();
          break;
        case RESET:
          if (allSynced.get()) {
            newEvents = RemoteAPI.this.getEventDAO().syncDelta();
          } else {
            // resync all 
            for (RemoteItemStore<?, ?> itemStore : getUniqueItemStoreValues()) {
              itemStore.sync();
            }
            allSynced.set(true);
            permissionCacheUpdater.requirePermissionCacheUpdate();
          }
          break;
        default:
          // do nothing 
          return;
      }
      lastSyncMoment = syncStart;

      // Notify daos about new events 
      for (final Event event : newEvents) {
        for (RemoteItemStore<IdItem, ? extends IdItem> store : getRelatedDataStores(event)) {
          store.newEvent(event);
        }
      }

      // We are doing it in synchronized because we want to be sure that events are fired in the order they happened 
      notifyDAOListeners(newEvents);
    }

    permissionCacheUpdater.afterSync(allSynced.get(), newEvents);
  }

  private RemoteItemStore<IdItem, ? extends IdItem>[] getRelatedDataStores(Event event) {
    // TODO: remove it when we completely get rid of Spaces 
    RemoteItemStore<IdItem, ? extends IdItem> primaryStore = this.getRemoteDataStore(event.getTargetType());

    if (eq_r5qqy2_a0d0m(event.getTargetType(), Project.class.getSimpleName())) {
      RemoteItemStore<IdItem, ? extends IdItem> spaceStore = this.getRemoteDataStore(Space.class.getSimpleName());
      return new RemoteItemStore[]{primaryStore, spaceStore};
    } else {
      return new RemoteItemStore[]{primaryStore};
    }
  }

  private void notifyDAOListeners(Iterable<Event> newEvents) {
    for (final Event event : newEvents) {
      for (RemoteItemStore<IdItem, ? extends IdItem> store : getRelatedDataStores(event)) {
        if (store instanceof ObservableDAO) {
          // Collect dao listener notifications 
          ObservableDAO<? extends IdItem> observable = (ObservableDAO<? extends IdItem>) store;
          for (Listener<? extends IdItem> listener : observable.getListeners()) {
            Event.Type eventType = Event.Type.fromString(event.getType());
            switch (eventType) {
              case CREATE:
                listener.added(event);
                break;
              case UPDATE:
                listener.updated(event);
                break;
              case REMOVE:
                listener.removed(event);
                break;
              default:
                throw new IllegalArgumentException("Unknown event type: " + eventType.getName());
            }

          }
        }
      }
    }
  }

  private Set<RemoteItemStore<?, ?>> getUniqueItemStoreValues() {
    return new HashSet<RemoteItemStore<?, ?>>(remoteItemStores.values());
  }

  public PermissionCache getPermissionCache() {
    return permissionCacheUpdater.getPermissionCache();
  }

  public void addFieldFetchListener(FieldFetchListener listener) {
    fieldFetchListeners.add(listener);
  }

  public void removeFieldFetchListener(FieldFetchListener listener) {
    fieldFetchListeners.remove(listener);
  }

  public void fireFieldFetchRequested(RemoteDAO dao, String id, String fieldName) {
    for (FieldFetchListener listener : fieldFetchListeners) {
      listener.fetchRequested(dao, id, fieldName);
    }
  }

  public <I extends IdItem> RemoteItemStore<I, ? extends I> getRemoteDataStore(String type) {
    for (Class<?> clz : remoteItemStores.keySet()) {
      if (clz.getSimpleName().equals(type)) {
        return (RemoteItemStore<I, ? extends I>) remoteItemStores.get(clz);
      }
    }
    throw new IllegalArgumentException("Store for type: " + type + " not found");
  }

  public RemoteEventDAO getEventDAO() {
    return this.myEventDAO;
  }

  protected void setEventDAO(RemoteEventDAO value) {
    this.myEventDAO = value;
  }

  public RemoteServiceDAO getServiceDAO() {
    return this.myServiceDAO;
  }

  protected void setServiceDAO(RemoteServiceDAO value) {
    this.myServiceDAO = value;
  }

  public RemoteResourceDAO getResourceDAO() {
    return this.myResourceDAO;
  }

  protected void setResourceDAO(RemoteResourceDAO value) {
    this.myResourceDAO = value;
  }

  public RemoteSpaceRoleDAO getSpaceRoleDAO() {
    return this.mySpaceRoleDAO;
  }

  protected void setSpaceRoleDAO(RemoteSpaceRoleDAO value) {
    this.mySpaceRoleDAO = value;
  }

  public RemoteProjectRoleDAO getProjectRoleDAO() {
    return this.myProjectRoleDAO;
  }

  protected void setProjectRoleDAO(RemoteProjectRoleDAO value) {
    this.myProjectRoleDAO = value;
  }

  public RemotePermissionDAO getPermissionDAO() {
    return this.myPermissionDAO;
  }

  protected void setPermissionDAO(RemotePermissionDAO value) {
    this.myPermissionDAO = value;
  }

  public RemoteRoleDAO getRoleDAO() {
    return this.myRoleDAO;
  }

  protected void setRoleDAO(RemoteRoleDAO value) {
    this.myRoleDAO = value;
  }

  public RemoteSpaceDAO getSpaceDAO() {
    return this.mySpaceDAO;
  }

  protected void setSpaceDAO(RemoteSpaceDAO value) {
    this.mySpaceDAO = value;
  }

  public RemoteProjectDAO getProjectDAO() {
    return this.myProjectDAO;
  }

  protected void setProjectDAO(RemoteProjectDAO value) {
    this.myProjectDAO = value;
  }

  public RemoteUserDAO getUserDAO() {
    return this.myUserDAO;
  }

  protected void setUserDAO(RemoteUserDAO value) {
    this.myUserDAO = value;
  }

  public RemoteUserGroupDAO getUserGroupDAO() {
    return this.myUserGroupDAO;
  }

  protected void setUserGroupDAO(RemoteUserGroupDAO value) {
    this.myUserGroupDAO = value;
  }

  public RemoteUserDetailsDAO getUserDetailsDAO() {
    return this.myUserDetailsDAO;
  }

  protected void setUserDetailsDAO(RemoteUserDetailsDAO value) {
    this.myUserDetailsDAO = value;
  }

  public RemoteAuthModuleDAO getAuthModuleDAO() {
    return this.myAuthModuleDAO;
  }

  protected void setAuthModuleDAO(RemoteAuthModuleDAO value) {
    this.myAuthModuleDAO = value;
  }

  public RemoteSettingsDAO getSettingsDAO() {
    return this.mySettingsDAO;
  }

  protected void setSettingsDAO(RemoteSettingsDAO value) {
    this.mySettingsDAO = value;
  }

  public RemoteKeyStoreDAO getKeyStoreDAO() {
    return this.myKeyStoreDAO;
  }

  protected void setKeyStoreDAO(RemoteKeyStoreDAO value) {
    this.myKeyStoreDAO = value;
  }

  public RemoteCertificateDAO getCertificateDAO() {
    return this.myCertificateDAO;
  }

  protected void setCertificateDAO(RemoteCertificateDAO value) {
    this.myCertificateDAO = value;
  }

  public RemoteMetricsDAO getMetricsDAO() {
    return this.myMetricsDAO;
  }

  protected void setMetricsDAO(RemoteMetricsDAO value) {
    this.myMetricsDAO = value;
  }

  public EventClient getEventClient() {
    return this.myEventClient;
  }

  protected void setEventClient(EventClient value) {
    this.myEventClient = value;
  }

  public BaseAccountsClient getClient() {
    return this.myClient;
  }

  private void setClient(BaseAccountsClient value) {
    this.myClient = value;
  }

  public static RemoteAPI create(BaseAccountsClient accountsClient) {
    return create(accountsClient, HubAPI.DEFAULT_SYNC_INTEVAL);
  }

  public static RemoteAPI create(BaseAccountsClient accountsClient, long syncInteval) {
    return create(accountsClient, syncInteval, null);
  }

  public static RemoteAPI create(BaseAccountsClient accountsClient, long syncInteval, @Nullable ScheduledExecutor executor) {
    RemoteAPI remoteAPI = new RemoteAPI(accountsClient, syncInteval, executor);
    remoteAPI.setServiceDAO(new RemoteServiceDAO());
    remoteAPI.getServiceDAO().setClient(accountsClient.getServiceClient());

    remoteAPI.setSettingsDAO(new RemoteSettingsDAO());
    remoteAPI.getSettingsDAO().setClient(accountsClient.getSettingsClient());

    remoteAPI.setEventDAO(new RemoteEventDAO());
    remoteAPI.getEventDAO().setClient(accountsClient.getEventClient());

    remoteAPI.setKeyStoreDAO(new RemoteKeyStoreDAO());
    remoteAPI.getKeyStoreDAO().setClient(accountsClient.getStoreClient());

    remoteAPI.setCertificateDAO(new RemoteCertificateDAO());
    remoteAPI.getCertificateDAO().setClient(accountsClient.getCertificateClient());

    remoteAPI.setMetricsDAO(new RemoteMetricsDAO());
    remoteAPI.getMetricsDAO().setClient(accountsClient.getMetricsClient());

    remoteAPI.setResourceDAO(new RemoteResourceDAO());
    remoteAPI.getResourceDAO().setClient(accountsClient.getResourceClient());

    remoteAPI.setSpaceRoleDAO(new RemoteSpaceRoleDAO());
    remoteAPI.getSpaceRoleDAO().setClient(accountsClient.getSpaceRoleClient());

    remoteAPI.setProjectRoleDAO(new RemoteProjectRoleDAO());
    remoteAPI.getProjectRoleDAO().setClient(accountsClient.getProjectRoleClient());

    remoteAPI.setPermissionDAO(new RemotePermissionDAO());
    remoteAPI.getPermissionDAO().setClient(accountsClient.getPermissionClient());

    remoteAPI.setRoleDAO(new RemoteRoleDAO());
    remoteAPI.getRoleDAO().setClient(accountsClient.getRoleClient());

    remoteAPI.setSpaceDAO(new RemoteSpaceDAO());
    remoteAPI.getSpaceDAO().setClient(accountsClient.getSpaceClient());

    remoteAPI.setProjectDAO(new RemoteProjectDAO());
    remoteAPI.getProjectDAO().setClient(accountsClient.getProjectClient());

    remoteAPI.setUserDAO(new RemoteUserDAO());
    remoteAPI.getUserDAO().setClient(accountsClient.getUserClient());

    remoteAPI.setUserGroupDAO(new RemoteUserGroupDAO());
    remoteAPI.getUserGroupDAO().setClient(accountsClient.getUserGroupClient());

    remoteAPI.setUserDetailsDAO(new RemoteUserDetailsDAO());
    remoteAPI.getUserDetailsDAO().setClient(accountsClient.getUserDetailClient());

    remoteAPI.setAuthModuleDAO(new RemoteAuthModuleDAO());
    remoteAPI.getAuthModuleDAO().setClient(accountsClient.getAuthModuleClient());

    PermissionCache permissionCache = remoteAPI.permissionCacheUpdater.getPermissionCache();
    permissionCache.setProjectDAO(remoteAPI.getProjectDAO());
    permissionCache.setGroupDAO(remoteAPI.getUserGroupDAO());
    permissionCache.setUserDAO(remoteAPI.getUserDAO());
    permissionCache.setServiceDAO(remoteAPI.getServiceDAO());
    permissionCache.setResourceDAO(remoteAPI.getResourceDAO());
    permissionCache.setPermissionDAO(remoteAPI.getPermissionDAO());

    remoteAPI.init();
    return remoteAPI;
  }

  private static boolean eq_r5qqy2_a0d0m(Object a, Object b) {
    return (a != null ?
      a.equals(b) :
      a == b
    );
  }

  private static   enum SyncState {
    RESET(),
    NOW(),
    CHECK();

    SyncState() {
    }
  }

  private static class PermissionCacheUpdater {
    private volatile boolean updateRequired = false;
    private HashSet<String> permissionCacheAffectingTypes;
    private HashSet<String> permissionCacheAffectingFields;
    private PermissionCache permissionCache;

    private PermissionCacheUpdater(PermissionCache permissionCache) {
      this.permissionCache = permissionCache;
      this.permissionCacheAffectingTypes = new HashSet<String>();
      permissionCacheAffectingTypes.add(jetbrains.jetpass.api.Service.class.getSimpleName());
      permissionCacheAffectingTypes.add(User.class.getSimpleName());
      permissionCacheAffectingTypes.add(UserGroup.class.getSimpleName());
      permissionCacheAffectingTypes.add(Role.class.getSimpleName());
      permissionCacheAffectingTypes.add(Permission.class.getSimpleName());
      permissionCacheAffectingTypes.add(Project.class.getSimpleName());

      this.permissionCacheAffectingFields = new HashSet<String>();
      permissionCacheAffectingFields.add(field(jetbrains.jetpass.api.Service.class, "roles"));
      permissionCacheAffectingFields.add(field(User.class, "roles"));
      permissionCacheAffectingFields.add(field(UserGroup.class, "roles"));
      permissionCacheAffectingFields.add(field(jetbrains.jetpass.api.Service.class, "projectRoles"));
      permissionCacheAffectingFields.add(field(User.class, "projectRoles"));
      permissionCacheAffectingFields.add(field(UserGroup.class, "projectRoles"));
      permissionCacheAffectingFields.add(field(User.class, "groups"));
      permissionCacheAffectingFields.add(field(UserGroup.class, "parent"));
      permissionCacheAffectingFields.add(field(Role.class, "permissions"));
      permissionCacheAffectingFields.add(field(Permission.class, "global"));
      permissionCacheAffectingFields.add(field(LicenseSettings.class, "licenseKey"));
      permissionCacheAffectingFields.add(field(LicenseSettings.class, "licenseName"));
    }

    public void checkIfEventAffectsPermissionCache(Iterable<Event> events) {
      if (updateRequired) {
        return;
      }

      for (Event event : events) {
        if (isPermissionsCacheAffected(event)) {
          updateRequired = true;
          return;
        }
      }
    }

    private boolean isPermissionsCacheAffected(Event event) {
      Event.Type type = Event.Type.fromString(event.getType());
      if (type == Event.Type.CREATE || type == Event.Type.REMOVE) {
        return permissionCacheAffectingTypes.contains(event.getTargetType());
      } else if (type == Event.Type.UPDATE) {
        for (Change change : event.getChanges()) {
          String field = event.getTargetType() + "." + change.getFieldName();
          if (permissionCacheAffectingFields.contains(field)) {
            return true;
          }
        }
      }
      return false;
    }

    public void requirePermissionCacheUpdate() {
      updateRequired = true;
    }

    public void invalidate() {
      if (updateRequired) {
        permissionCache.setDirty();
      }
    }

    private void afterSync(boolean allSynced, Iterable<Event> events) {
      this.checkIfEventAffectsPermissionCache(events);
      if (allSynced) {
        if (updateRequired) {
          updateRequired = false;
          permissionCache.setDirty();
          permissionCache.cancel();
          permissionCache.init();
        }
      } else {
        this.invalidate();
      }

    }

    public PermissionCache getPermissionCache() {
      return permissionCache;
    }

    private String field(Class clazz, String fieldName) {
      return clazz.getSimpleName() + "." + fieldName;
    }
  }
}
