package jetbrains.jetpass.dao.remote.api;

/*Generated by MPS */

import jetbrains.jetpass.api.authority.AuthorityHolder;
import jetbrains.jetpass.client.BaseField;
import jetbrains.jetpass.dao.api.authority.AuthorityHolderDAO;
import jetbrains.jetpass.client.FieldPartial;
import jetbrains.jetpass.client.accounts.Partial;
import jetbrains.jetpass.dao.api.DataAccessException;
import jetbrains.jetpass.dao.remote.api.security.RemoteSpaceRoleDAO;
import jetbrains.jetpass.rest.dto.SpaceRoleJSON;
import javax.ws.rs.WebApplicationException;
import jetbrains.jetpass.dao.remote.api.security.RemoteProjectRoleDAO;
import jetbrains.jetpass.rest.dto.ProjectRoleJSON;
import org.jetbrains.annotations.Nullable;
import jetbrains.jetpass.api.security.Permission;
import jetbrains.jetpass.api.security.Resource;
import jetbrains.jetpass.api.security.Space;
import jetbrains.jetpass.api.security.Project;
import jetbrains.jetpass.dao.api.permissionCache.PermissionQuery;

public abstract class RemoteAuthHolderNamedMutableDAO<I extends AuthorityHolder, J extends I, F extends BaseField> extends RemoteNamedMutableDAO<I, J, F> implements AuthorityHolderDAO<I> {
  @Deprecated
  private FieldPartial<Partial.SpaceRole> spaceRolePartial = Partial.spaceRole(Partial.SpaceRole.ID);
  private FieldPartial<Partial.ProjectRole> projectRolePartial = Partial.projectRole(Partial.ProjectRole.ID);

  public RemoteAuthHolderNamedMutableDAO(FieldPartial<F> minimalPartial) {
    super(minimalPartial);
  }

  @Deprecated
  public jetbrains.jetpass.api.security.SpaceRole addRole(String authorityHolderId, jetbrains.jetpass.api.security.SpaceRole spaceRole) throws DataAccessException {
    getNotNull(authorityHolderId);

    RemoteSpaceRoleDAO spaceRoleDAO = this.getRemoteAPI().getSpaceRoleDAO();
    SpaceRoleJSON added;
    try {
      added = doCreateRole(authorityHolderId, toJSON(spaceRole), spaceRolePartial);
    } catch (WebApplicationException ex) {
      // FIX: who is not found here??????? 
      throw wrapClientException(ex, authorityHolderId);
    }
    this.getRemoteAPI().syncNow();
    return spaceRoleDAO.get(added.getId());
  }

  public jetbrains.jetpass.api.security.ProjectRole addRole(String authorityHolderId, jetbrains.jetpass.api.security.ProjectRole projectRole) throws DataAccessException {
    getNotNull(authorityHolderId);

    RemoteProjectRoleDAO projectRoleDAO = this.getRemoteAPI().getProjectRoleDAO();
    ProjectRoleJSON added;
    try {
      added = doCreateRole(authorityHolderId, toJSON(projectRole), projectRolePartial);
    } catch (WebApplicationException ex) {
      // FIX: who is not found here??????? 
      throw wrapClientException(ex, authorityHolderId);
    }
    this.getRemoteAPI().syncNow();
    return projectRoleDAO.get(added.getId());
  }

  public void removeRole(String authorityHolderId, String projectRoleId) throws DataAccessException {
    getNotNull(authorityHolderId);

    jetbrains.jetpass.api.security.ProjectRole role = this.getRemoteAPI().getProjectRoleDAO().getNotNull(projectRoleId);

    try {
      doDeleteRole(authorityHolderId, role.getId());
    } catch (WebApplicationException ex) {
      // FIX: who is not found here??????? 
      throw wrapClientException(ex, authorityHolderId);
    }
    this.getRemoteAPI().syncNow();
  }

  public boolean hasPermission(String authorityHolderId, @Nullable Permission permission, @Nullable Resource resource) {
    return this.getRemoteAPI().getPermissionCache().hasPermission(getPermissionQuery(authorityHolderId), permission, resource);
  }

  public boolean hasPermission(String authorityHolderId, @Nullable Permission permission, @Nullable Space space) {
    return this.getRemoteAPI().getPermissionCache().hasPermission(getPermissionQuery(authorityHolderId), permission, space);
  }

  public boolean hasPermission(String authorityHolderId, @Nullable Permission permission, @Nullable Project project) {
    return this.getRemoteAPI().getPermissionCache().hasPermission(getPermissionQuery(authorityHolderId), permission, project);
  }

  public abstract PermissionQuery getPermissionQuery(String authHolderId);

  @Deprecated
  protected abstract SpaceRoleJSON doCreateRole(String id, SpaceRoleJSON roleJSON, FieldPartial<Partial.SpaceRole> partial);

  protected abstract ProjectRoleJSON doCreateRole(String id, ProjectRoleJSON roleJSON, FieldPartial<Partial.ProjectRole> partial);

  protected abstract void doDeleteRole(String id, String roleId);

  @Deprecated
  protected SpaceRoleJSON toJSON(jetbrains.jetpass.api.security.SpaceRole spaceRole) {
    return (spaceRole instanceof SpaceRoleJSON ?
      (SpaceRoleJSON) spaceRole :
      new SpaceRoleJSON(spaceRole)
    );
  }

  protected ProjectRoleJSON toJSON(jetbrains.jetpass.api.security.ProjectRole projectRole) {
    return (projectRole instanceof ProjectRoleJSON ?
      (ProjectRoleJSON) projectRole :
      new ProjectRoleJSON(projectRole)
    );
  }
}
