package jetbrains.jetpass.dao.remote.api;

/*Generated by MPS */

import jetbrains.jetpass.api.IdItem;

public class RemoteDynamicItemWrapper<I extends IdItem> implements RemoteValueWrapper<I> {
  private RemoteItemStoreContainer storeContainer;

  public RemoteDynamicItemWrapper(RemoteItemStoreContainer container) {
    this.storeContainer = container;
  }

  public I wrap(I value) {
    if (value == null) {
      return null;
    }

    RemoteItemStore<I, ?> store = findStore(value.getClass());
    if (store == null) {
      return null;
    }

    return store.get(value.getId());
  }

  protected RemoteItemStore<I, ?> findStore(Class clazz) {
    for (Class anInterface : clazz.getInterfaces()) {
      RemoteItemStore<I, ? extends I> store = storeContainer.getRemoteDataStore((Class<I>) anInterface);
      if (store != null) {
        return store;
      }
    }
    return null;
  }
}
