package jetbrains.jetpass.dao.remote.api;

/*Generated by MPS */

import jetbrains.jetpass.api.IdItem;
import java.lang.reflect.InvocationHandler;
import java.lang.reflect.Method;
import java.lang.reflect.InvocationTargetException;

public class RemoteInvocationHandler<I extends IdItem, J extends I> implements InvocationHandler {
  private long loadedFieldsBitSet;
  private RemoteItemAccessor<I, J> accessor;
  private long version;
  private J dto;

  public RemoteInvocationHandler(RemoteItemAccessor<I, J> factory, J dto) {
    this.dto = dto;
    this.accessor = factory;
    this.version = factory.getDataStore().getVersion();
  }

  public Object invoke(Object proxy, Method method, Object[] args) throws Throwable {
    RemoteItemStore<I, J> store = accessor.getDataStore();
    if (store.getVersion() > version) {
      // retouch 
      RemoteItemData<I, J> data = store.getData(dto.getId());
      if (data == null) {
        throw new IllegalStateException("Entity was removed!");
      }
      RemoteInvocationHandler<I, J> handler = data.getHandler();
      this.dto = handler.dto;
      this.loadedFieldsBitSet = handler.loadedFieldsBitSet;
      this.version = handler.version;
    }

    int fieldGetterIndex = accessor.getFieldGetterIndex(method);
    if (fieldGetterIndex >= 0 && !(isFieldSet(fieldGetterIndex))) {
      accessor.requestFieldValue(dto, method);
    }
    RemoteValueWrapper wrapper = accessor.getValueWrapper(method);
    Object returned = method.invoke(dto, args);
    if (wrapper != null) {
      returned = wrapper.wrap(returned);
    }
    return returned;
  }

  private boolean isFieldSet(int fieldIndex) {
    return ((loadedFieldsBitSet >> fieldIndex) & 1) == 1;
  }

  public void resetField(String fieldName) {
    Integer fieldIndex = accessor.getFieldIndex(fieldName);
    if (fieldIndex != null) {
      loadedFieldsBitSet = loadedFieldsBitSet & ~(1l << fieldIndex);
    }
  }

  public void setFieldValue(int fieldIndex, Method setterMethod, Object value) throws InvocationTargetException, IllegalAccessException {
    loadedFieldsBitSet = loadedFieldsBitSet | (1l << fieldIndex);
    setterMethod.invoke(dto, value);
  }
}
