package jetbrains.jetpass.dao.remote.api;

/*Generated by MPS */

import jetbrains.jetpass.api.IdItem;
import jetbrains.jetpass.client.BaseField;
import jetbrains.jetpass.dao.api.MutableDAO;
import java.util.List;
import jetbrains.jetpass.dao.api.Listener;
import java.util.ArrayList;
import jetbrains.jetpass.client.FieldPartial;
import jetbrains.jetpass.dao.api.DataAccessException;
import javax.ws.rs.WebApplicationException;
import org.jetbrains.annotations.Nullable;

public abstract class RemoteMutableDAO<I extends IdItem, J extends I, F extends BaseField> extends RemoteDAO<I, J, F> implements MutableDAO<I>, ObservableDAO<I> {
  private List<Listener<I>> eventListeners = new ArrayList<Listener<I>>(0);

  public RemoteMutableDAO(FieldPartial<F> minimalPartial) {
    super(minimalPartial);
  }

  public I create(I item) throws DataAccessException {
    J json;
    try {
      json = doCreate(toJSON(item), this._partial);
    } catch (WebApplicationException ex) {
      throw wrapClientException(ex, null);
    }
    this.getRemoteAPI().syncNow();
    return get(json.getId());
  }

  public void update(String id, I item) throws DataAccessException {
    J json = toJSON(item);
    try {
      doUpdate(id, json);
    } catch (WebApplicationException ex) {
      throw wrapClientException(ex, id);
    }
    this.getRemoteAPI().syncNow();
  }

  public final void delete(String id) throws DataAccessException {
    delete(id, null);
  }

  public final void delete(String id, @Nullable String successor) throws DataAccessException {
    I item = get(id);
    try {
      doDelete(id, successor);
    } catch (WebApplicationException ex) {
      throw wrapClientException(ex, id);
    }
    this.getRemoteAPI().syncNow();
  }

  public void addListener(Listener<I> listener) {
    eventListeners.add(listener);
  }

  public void removeListener(Listener<I> listener) {
    eventListeners.remove(listener);
  }

  public List<Listener<I>> getListeners() {
    return eventListeners;
  }

  protected abstract J doCreate(J json, FieldPartial<F> partial);

  protected abstract void doUpdate(String id, J change);

  protected abstract void doDelete(String id, @Nullable String successor);

  protected abstract J toJSON(I item);
}
