package jetbrains.jetpass.dao.remote.api;

/*Generated by MPS */

import jetbrains.jetpass.api.IdItem;
import jetbrains.jetpass.sequence.impl.IterableSequence;
import org.jetbrains.annotations.NotNull;
import jetbrains.jetpass.client.BaseField;
import jetbrains.jetpass.client.BaseFilter;
import java.util.Iterator;
import jetbrains.jetpass.sequence.iter.TransformIterator;
import jetbrains.jetpass.sequence.Sequence;
import jetbrains.mps.webr.rpc.rest.json.common.runtime.SortOrder;
import jetbrains.mps.webr.rpc.rest.json.common.runtime.OrderBy;

public class RemoteSequence<I extends IdItem, J extends I> extends IterableSequence<I> {
  private RemoteDAO<I, J, ?> dao;

  public RemoteSequence(@NotNull final RemoteDAO<I, J, BaseField> dao, @NotNull final BaseFilter filter) {
    super(new Iterable<I>() {
      public Iterator<I> iterator() {
        return new TransformIterator<J, I>(dao.createIterator(filter, dao._partial)) {
          protected I transform(J item) {
            return dao.put(item).getItem();
          }
        };
      }
    });
    this.dao = dao;
  }

  public RemoteSequence(@NotNull final RemoteDAO<I, J, BaseField> dao) {
    this(dao, dao.filter());
  }

  @Override
  public Sequence<I> query(String query) {
    return new RemoteSequence(dao, dao.filter().query(query));
  }

  @Override
  public Sequence<I> orderBy(String fieldName, Boolean asc) {
    SortOrder order;
    if (asc == null) {
      order = SortOrder.DEFAULT;
    } else if (asc) {
      order = SortOrder.ASCENDING;
    } else {
      order = SortOrder.DESCENDING;
    }
    return new RemoteSequence(dao, dao.filter().orderBy(new OrderBy(fieldName, order)));
  }
}
