package jetbrains.jetpass.dao.remote.api;

/*Generated by MPS */

import jetbrains.jetpass.api.Service;
import jetbrains.jetpass.rest.dto.ServiceJSON;
import jetbrains.jetpass.client.accounts.Partial;
import jetbrains.jetpass.dao.api.ServiceDAO;
import jetbrains.jetpass.client.accounts.ServiceClient;
import jetbrains.mps.webr.rpc.rest.json.common.runtime.Page;
import jetbrains.jetpass.client.BaseFilter;
import jetbrains.jetpass.client.FieldPartial;
import org.jetbrains.annotations.Nullable;
import jetbrains.jetpass.rest.dto.SpaceRoleJSON;
import jetbrains.jetpass.rest.dto.ProjectRoleJSON;
import jetbrains.jetpass.dao.api.permissionCache.PermissionQuery;
import jetbrains.jetpass.api.security.Resource;
import jetbrains.jetpass.dao.api.DataAccessException;
import jetbrains.jetpass.dao.remote.api.security.RemoteResourceDAO;
import jetbrains.jetpass.rest.dto.ResourceJSON;
import javax.ws.rs.WebApplicationException;
import jetbrains.jetpass.api.security.Permission;
import jetbrains.jetpass.dao.remote.api.security.RemotePermissionDAO;
import jetbrains.jetpass.rest.dto.PermissionJSON;
import jetbrains.jetpass.dao.remote.api.security.RemoteRoleDAO;
import jetbrains.jetpass.rest.dto.RoleJSON;
import jetbrains.jetpass.api.authority.UserGroup;
import jetbrains.jetpass.dao.remote.api.authority.RemoteUserGroupDAO;
import jetbrains.jetpass.sequence.Sequence;
import jetbrains.jetpass.api.HeaderItem;
import java.util.List;
import jetbrains.jetpass.rest.dto.HeaderItemJSON;
import jetbrains.jetpass.sequence.impl.ListSequence;

public class RemoteServiceDAO extends RemoteAuthHolderNamedMutableDAO<Service, ServiceJSON, Partial.Service> implements ServiceDAO {
  private ServiceClient myClient;

  public RemoteServiceDAO() {
    super(Partial.service(Partial.Service.ID, Partial.Service.ALIAS_IDS, Partial.Service.PROJECT_ROLES(Partial.ProjectRole.ID), Partial.Service.DEFAULT_ROLES(Partial.Role.ID, Partial.Role.NAME, Partial.Role.DESCRIPTION, Partial.Role.PERMISSIONS())));
  }

  protected Page<ServiceJSON> fetchPage(BaseFilter filter, FieldPartial<Partial.Service> partial) {
    return RemoteServiceDAO.this.getClient().getServicePage(filter, partial);
  }

  protected ServiceJSON fetchItem(String id, FieldPartial<Partial.Service> partial) {
    return RemoteServiceDAO.this.getClient().getService(id, partial);
  }

  protected FieldPartial<Partial.Service> createPartial(String fieldName) {
    return Partial.service(new Partial.Service(fieldName));
  }

  protected ServiceJSON doCreate(ServiceJSON json, FieldPartial<Partial.Service> partial) {
    return RemoteServiceDAO.this.getClient().createService(json, partial);
  }

  protected void doUpdate(String id, ServiceJSON change) {
    RemoteServiceDAO.this.getClient().updateService(id, change);
  }

  protected void doDelete(String id, @Nullable String successor) {
    RemoteServiceDAO.this.getClient().deleteService(id);
  }

  protected void doDeleteRole(String id, String roleId) {
    RemoteServiceDAO.this.getClient().getRolesClient(id).removeRole(roleId);
  }

  @Deprecated
  protected SpaceRoleJSON doCreateRole(String id, SpaceRoleJSON roleJSON, FieldPartial<Partial.SpaceRole> partial) {
    return RemoteServiceDAO.this.getClient().getRolesClient(id).addRole(roleJSON, partial);
  }

  protected ProjectRoleJSON doCreateRole(String id, ProjectRoleJSON roleJSON, FieldPartial<Partial.ProjectRole> partial) {
    return RemoteServiceDAO.this.getClient().getProjectrolesClient(id).addProjectRole(roleJSON, partial);
  }

  public PermissionQuery getPermissionQuery(String authHolderId) {
    return this.getRemoteAPI().getPermissionCache().service(authHolderId, true);
  }

  protected ServiceJSON toJSON(jetbrains.jetpass.api.Service item) {
    return (item instanceof ServiceJSON ?
      (ServiceJSON) item :
      new ServiceJSON(item)
    );
  }

  public Resource addResource(String serviceId, Resource resource) throws DataAccessException {
    RemoteResourceDAO resourceDAO = this.getRemoteAPI().getResourceDAO();
    try {
      ResourceJSON newResourceJSON = RemoteServiceDAO.this.getClient().getResourcesClient(serviceId).addResource(resourceDAO.toJSON(resource), resourceDAO._partial);
      this.getRemoteAPI().syncNow();
      return resourceDAO.get(newResourceJSON.getId());
    } catch (WebApplicationException ex) {
      throw wrapClientException(ex, null);
    }
  }

  public void removeResource(String serviceId, String resourceId) throws DataAccessException {
    try {
      RemoteServiceDAO.this.getClient().getResourcesClient(serviceId).removeResource(resourceId);
    } catch (WebApplicationException ex) {
      throw wrapClientException(ex, resourceId);
    }
    this.getRemoteAPI().syncNow();
  }

  public Permission addPermission(String serviceId, Permission permission) throws DataAccessException {
    RemotePermissionDAO permissionDAO = this.getRemoteAPI().getPermissionDAO();
    try {
      PermissionJSON newPermissionJSON = RemoteServiceDAO.this.getClient().getPermissionsClient(serviceId).addPermission(permissionDAO.toJSON(permission), permissionDAO._partial);
      this.getRemoteAPI().syncNow();
      return permissionDAO.get(newPermissionJSON.getId());
    } catch (WebApplicationException ex) {
      throw wrapClientException(ex, null);
    }
  }

  public void removePermission(String serviceId, String permissionId) throws DataAccessException {
    try {
      RemoteServiceDAO.this.getClient().getPermissionsClient(serviceId).removePermission(permissionId);
    } catch (WebApplicationException ex) {
      throw wrapClientException(ex, permissionId);
    }
    this.getRemoteAPI().syncNow();
  }

  public jetbrains.jetpass.api.security.Role addDefaultRole(String serviceId, jetbrains.jetpass.api.security.Role defaultRole) throws DataAccessException {
    RemoteRoleDAO roleDAO = this.getRemoteAPI().getRoleDAO();
    try {
      RoleJSON newRoleJSON = RemoteServiceDAO.this.getClient().getDefaultrolesClient(serviceId).addDefaultRole(roleDAO.toJSON(defaultRole), roleDAO._partial);
      this.getRemoteAPI().syncNow();
      for (jetbrains.jetpass.api.security.Role role : get(serviceId).getDefaultRoles()) {
        if (eq_kpiqq9_a0a0c0b0p(role.getId(), newRoleJSON.getId())) {
          return role;
        }
      }
      return null;
    } catch (WebApplicationException ex) {
      throw wrapClientException(ex, null);
    }
  }

  public void removeDefaultRole(String serviceId, String defaultRoleId) throws DataAccessException {
    try {
      RemoteServiceDAO.this.getClient().getDefaultrolesClient(serviceId).removeDefaultRole(defaultRoleId);
    } catch (WebApplicationException ex) {
      throw wrapClientException(ex, defaultRoleId);
    }
    this.getRemoteAPI().syncNow();
  }

  public UserGroup addHeaderVisibleGroup(String serviceId, String groupId) throws DataAccessException {
    RemoteUserGroupDAO groupDAO = this.getRemoteAPI().getUserGroupDAO();
    UserGroup group = groupDAO.getNotNull(groupId);

    RemoteServiceDAO.this.getClient().getHeadervisiblegroupsClient(serviceId).addHeaderVisibleGroup(groupDAO.toJSON(groupId), null);
    this.getRemoteAPI().syncNow();

    return group;
  }

  public void removeHeaderVisibleGroup(String serviceId, String groupId) throws DataAccessException {
    this.getRemoteAPI().getUserGroupDAO().getNotNull(groupId);

    RemoteServiceDAO.this.getClient().getHeadervisiblegroupsClient(serviceId).removeHeaderVisibleGroup(groupId);
    this.getRemoteAPI().syncNow();
  }

  public Sequence<HeaderItem> getHeaderItems() throws DataAccessException {
    List<HeaderItemJSON> header = RemoteServiceDAO.this.getClient().header(Partial.headerItem(Partial.HeaderItem.ID, Partial.HeaderItem.NAME, Partial.HeaderItem.HOME_URL, Partial.HeaderItem.ICON_URL));
    return new ListSequence(header);
  }

  public ServiceClient getClient() {
    return this.myClient;
  }

  public void setClient(ServiceClient value) {
    this.myClient = value;
  }

  private static boolean eq_kpiqq9_a0a0c0b0p(Object a, Object b) {
    return (a != null ?
      a.equals(b) :
      a == b
    );
  }
}
