package jetbrains.jetpass.dao.remote.api.authority;

/*Generated by MPS */

import jetbrains.jetpass.dao.remote.api.RemoteNamedMutableDAO;
import jetbrains.jetpass.api.authority.module.AuthModule;
import jetbrains.jetpass.rest.dto.AuthmoduleJSON;
import jetbrains.jetpass.client.accounts.Partial;
import jetbrains.jetpass.dao.api.authority.AuthModuleDAO;
import jetbrains.jetpass.client.accounts.AuthModuleClient;
import java.util.Map;
import jetbrains.jetpass.dao.remote.api.RemoteItemAccessor;
import java.util.HashMap;
import jetbrains.mps.webr.rpc.rest.json.common.runtime.Page;
import jetbrains.jetpass.client.BaseFilter;
import jetbrains.jetpass.client.FieldPartial;
import jetbrains.jetpass.api.authority.details.UserDetails;
import jetbrains.jetpass.dao.api.DataAccessException;
import jetbrains.jetpass.rest.dto.CredentialsJSON;
import javax.ws.rs.WebApplicationException;
import org.jetbrains.annotations.Nullable;
import jetbrains.jetpass.api.authority.UserGroup;
import jetbrains.jetpass.sequence.Sequence;
import jetbrains.jetpass.dao.remote.api.ConstraintsUtil;
import jetbrains.jetpass.sequence.impl.FilterFunction;
import jetbrains.jetpass.auth.module.rest.client.api.ExternalAuthModule;
import jetbrains.jetpass.dao.api.ItemNotFoundException;
import org.jetbrains.annotations.NotNull;
import jetbrains.jetpass.api.authority.User;

public class RemoteAuthModuleDAO extends RemoteNamedMutableDAO<AuthModule, AuthmoduleJSON, Partial.Authmodule> implements AuthModuleDAO {
  private AuthModuleClient myClient;
  private Map<Class<? extends AuthmoduleJSON>, RemoteItemAccessor> myAuthModuleItemAccessor;

  public RemoteAuthModuleDAO() {
    super(Partial.authmodule(Partial.Authmodule.ID, Partial.Authmodule.ALIAS_IDS));
    RemoteAuthModuleDAO.this.setAuthModuleItemAccessor(new HashMap<Class<? extends AuthmoduleJSON>, RemoteItemAccessor>());
  }

  protected Page<AuthmoduleJSON> fetchPage(BaseFilter filter, FieldPartial<Partial.Authmodule> partial) {
    return RemoteAuthModuleDAO.this.getClient().getAuthModulePage(filter, partial);
  }

  public UserDetails resolve(AuthModule module, String username, String password) throws DataAccessException {
    try {
      CredentialsJSON creds = new CredentialsJSON();
      creds.setUsername(username);
      creds.setPassword(password);
      return RemoteAuthModuleDAO.this.getClient().resolve(module.getId(), creds, null);
    } catch (WebApplicationException ex) {
      throw wrapClientException(ex, module.getId());
    }
  }

  protected AuthmoduleJSON fetchItem(String id, FieldPartial<Partial.Authmodule> partial) {
    return this.getClient().getAuthModule(id, partial);
  }

  protected FieldPartial<Partial.Authmodule> createPartial(String fieldName) {
    return Partial.authmodule(new Partial.Authmodule(fieldName));
  }

  protected AuthmoduleJSON doCreate(AuthmoduleJSON json, FieldPartial<Partial.Authmodule> partial) {
    return RemoteAuthModuleDAO.this.getClient().createAuthModule(json, partial);
  }

  protected void doUpdate(String id, AuthmoduleJSON change) {
    RemoteAuthModuleDAO.this.getClient().updateAuthModule(id, change);
  }

  protected void doDelete(String id, @Nullable String successor) {
    RemoteAuthModuleDAO.this.getClient().deleteAuthModule(id);
  }

  protected AuthmoduleJSON toJSON(AuthModule item) {
    return (item instanceof AuthmoduleJSON ?
      ((AuthmoduleJSON) item) :
      new AuthmoduleJSON(item)
    );
  }

  @Override
  public RemoteItemAccessor<AuthModule, AuthmoduleJSON> getItemAccessor(AuthmoduleJSON dto) {
    return RemoteAuthModuleDAO.this.getAuthModuleItemAccessor().get(dto.getClass());
  }

  public void removeAutoJoinGroup(AuthModule module, UserGroup userGroup) throws DataAccessException {
    this.changeAutoJoingGroups((module != null ?
      module.getId() :
      null
    ), (userGroup != null ?
      userGroup.getId() :
      null
    ), false);
  }

  public void addAutoJoinGroup(AuthModule module, UserGroup userGroup) throws DataAccessException {
    this.changeAutoJoingGroups((module != null ?
      module.getId() :
      null
    ), (userGroup != null ?
      userGroup.getId() :
      null
    ), true);
  }

  public Sequence<AuthModule> getByType(String typeName) {
    throw new UnsupportedOperationException();
  }

  public AuthModule getByUrl(final String url) {
    ConstraintsUtil.checkNotEmpty(url, "Url");
    return getAllItems().where(new FilterFunction<AuthModule>() {
      public boolean matches(AuthModule it) {
        return it instanceof ExternalAuthModule && eq_alzn5o_a0a0a0a0a0a0b0m(url, ((ExternalAuthModule) it).getServerUrl());
      }
    }).first();
  }

  public void changeAutoJoingGroups(String authModuleId, String userGroupId, boolean add) throws ItemNotFoundException {
    this.getRemoteAPI().getUserGroupDAO().getNotNull(userGroupId);
    this.getNotNull(authModuleId);

    AuthModuleClient.AutoJoinGroupClient myClient = RemoteAuthModuleDAO.this.getClient().getAutojoingroupsClient(authModuleId);
    if (add) {
      myClient.addAutoJoinGroup(this.getRemoteAPI().getUserGroupDAO().toJSON(userGroupId), this.getRemoteAPI().getUserGroupDAO().getDefaultPartial());
    } else {
      myClient.removeAutoJoinGroup(userGroupId);
    }
    this.getRemoteAPI().syncNow();
  }

  @NotNull
  public User login(@NotNull String username, @NotNull String password) throws DataAccessException {
    return login(username, password, null);
  }

  @NotNull
  public User login(String username, String password, String clientServiceId) throws DataAccessException {
    throw new UnsupportedOperationException();
  }

  public AuthModuleClient getClient() {
    return this.myClient;
  }

  public void setClient(AuthModuleClient value) {
    this.myClient = value;
  }

  public Map<Class<? extends AuthmoduleJSON>, RemoteItemAccessor> getAuthModuleItemAccessor() {
    return this.myAuthModuleItemAccessor;
  }

  private void setAuthModuleItemAccessor(Map<Class<? extends AuthmoduleJSON>, RemoteItemAccessor> value) {
    this.myAuthModuleItemAccessor = value;
  }

  private static boolean eq_alzn5o_a0a0a0a0a0a0b0m(Object a, Object b) {
    return (a != null ?
      a.equals(b) :
      a == b
    );
  }
}
