package jetbrains.jetpass.dao.remote.api.authority;

/*Generated by MPS */

import jetbrains.jetpass.dao.remote.api.RemoteAuthHolderNamedMutableDAO;
import jetbrains.jetpass.api.authority.User;
import jetbrains.jetpass.rest.dto.UserJSON;
import jetbrains.jetpass.client.accounts.Partial;
import jetbrains.jetpass.dao.api.authority.UserDAO;
import jetbrains.jetpass.rest.dto.DefaultavatarJSON;
import jetbrains.jetpass.client.accounts.UserClient;
import jetbrains.mps.webr.rpc.rest.json.common.runtime.Page;
import jetbrains.jetpass.client.BaseFilter;
import jetbrains.jetpass.client.FieldPartial;
import org.jetbrains.annotations.Nullable;
import jetbrains.jetpass.dao.remote.api.RemoteDataStore;
import jetbrains.jetpass.dao.api.DataAccessException;
import java.util.List;
import java.util.ArrayList;
import jetbrains.jetpass.rest.dto.SpaceRoleJSON;
import jetbrains.jetpass.rest.dto.ProjectRoleJSON;
import jetbrains.jetpass.api.authority.details.UserDetails;
import jetbrains.jetpass.rest.dto.DetailsJSON;
import jetbrains.jetpass.sequence.impl.IterableSequence;
import jetbrains.jetpass.sequence.impl.TransformFunction;
import javax.ws.rs.WebApplicationException;
import jetbrains.jetpass.dao.api.permissionCache.PermissionQuery;
import jetbrains.jetpass.api.authority.Profile;
import jetbrains.jetpass.rest.dto.ProfileJSON;
import org.jetbrains.annotations.NotNull;
import jetbrains.jetpass.api.authority.profile.DefaultAvatar;
import jetbrains.jetpass.api.authority.SshPublicKey;
import jetbrains.jetpass.rest.dto.SshPublicKeyJSON;
import jetbrains.jetpass.api.event.Event;

public class RemoteUserDAO extends RemoteAuthHolderNamedMutableDAO<User, UserJSON, Partial.User> implements UserDAO {
  private DefaultavatarJSON defaultAvatar = new DefaultavatarJSON();
  private UserClient myClient;

  public RemoteUserDAO() {
    super(Partial.user(Partial.User.ID, Partial.User.ALIAS_IDS, Partial.User.GROUPS(Partial.UserGroup.ID), Partial.User.PROJECT_ROLES(Partial.ProjectRole.ID), Partial.User.PROFILE()));
  }

  protected Page<UserJSON> fetchPage(BaseFilter filter, FieldPartial<Partial.User> partial) {
    return RemoteUserDAO.this.getClient().getUserPage(filter, partial);
  }

  protected UserJSON fetchItem(String id, FieldPartial<Partial.User> partial) {
    return RemoteUserDAO.this.getClient().getUser(id, partial);
  }

  protected FieldPartial<Partial.User> createPartial(String fieldName) {
    return Partial.user(new Partial.User(fieldName));
  }

  protected UserJSON doCreate(UserJSON json, FieldPartial<Partial.User> partial) {
    return RemoteUserDAO.this.getClient().createUser(json, partial);
  }

  protected void doUpdate(String id, UserJSON change) {
    RemoteUserDAO.this.getClient().updateUser(id, change);
  }

  protected void doDelete(String id, @Nullable String successor) {
    RemoteUserDAO.this.getClient().deleteUser(id, successor);
  }

  @Override
  protected void removeRemoteItem(RemoteDataStore<jetbrains.jetpass.api.authority.User, UserJSON> store, String itemId) {
    // do nothing - users are not removed but merged 
  }

  protected UserJSON toJSON(jetbrains.jetpass.api.authority.User item) {
    return (item instanceof UserJSON ?
      ((UserJSON) item) :
      new UserJSON(item)
    );
  }

  protected UserJSON toJSON(String userId) {
    UserJSON user = new UserJSON();
    user.setId(userId);
    return user;
  }

  public jetbrains.jetpass.api.authority.User invite(String email) throws DataAccessException {
    List<String> emailList = new ArrayList();
    emailList.add(email);
    List<UserJSON> invited = RemoteUserDAO.this.getClient().invite(emailList, null, this._partial);
    jetbrains.jetpass.api.authority.User user = null;
    if (!(invited.isEmpty())) {
      UserJSON json = invited.get(0);
      this.getRemoteAPI().syncNow();
      user = get(json.getId());
    }
    return user;
  }

  @Deprecated
  protected SpaceRoleJSON doCreateRole(String id, SpaceRoleJSON roleJSON, FieldPartial<Partial.SpaceRole> partial) {
    return RemoteUserDAO.this.getClient().getRolesClient(id).addRole(roleJSON, partial);
  }

  protected ProjectRoleJSON doCreateRole(String id, ProjectRoleJSON roleJSON, FieldPartial<Partial.ProjectRole> partial) {
    return RemoteUserDAO.this.getClient().getProjectrolesClient(id).addProjectRole(roleJSON, partial);
  }

  protected void doDeleteRole(String id, String roleId) {
    RemoteUserDAO.this.getClient().getRolesClient(id).removeRole(roleId);
  }

  public jetbrains.jetpass.api.authority.User getGuest() {
    // TODO: optimize! 
    UserJSON guest = RemoteUserDAO.this.getClient().guest(_partial);
    return get(guest.getId());
  }

  public UserDetails addUserDetails(String userId, UserDetails userDetails) throws DataAccessException {
    getNotNull(userId);

    RemoteUserDetailsDAO dao = this.getRemoteAPI().getUserDetailsDAO();
    DetailsJSON created = RemoteUserDAO.this.getClient().getUserdetailsClient(userId).addUserDetail(dao.toJSON(userDetails), dao.getDefaultPartial());
    this.getRemoteAPI().syncNow();
    return dao.get(created.getId());
  }

  public jetbrains.jetpass.api.authority.User merge(Iterable<jetbrains.jetpass.api.authority.User> users, String login, String name, String email, String jabber, Boolean banned) throws DataAccessException {
    try {
      List<UserJSON> list = new IterableSequence(users).select(new TransformFunction<jetbrains.jetpass.api.authority.User, UserJSON>() {
        public UserJSON transform(jetbrains.jetpass.api.authority.User it) {
          return toJSON(it);
        }
      }).toListSequence().toList();
      String mergedId = RemoteUserDAO.this.getClient().merge(login, name, email, jabber, banned, list.<UserJSON>toArray(new UserJSON[list.size()]), Partial.user(Partial.User.ID)).getId();
      this.getRemoteAPI().syncNow();
      return get(mergedId);
    } catch (WebApplicationException ex) {
      throw wrapClientException(ex, null);
    }
  }

  public PermissionQuery getPermissionQuery(String authHolderId) {
    return this.getRemoteAPI().getPermissionCache().user(authHolderId, true);
  }

  public void removeUserDetails(String userId, String userDetailsId) throws DataAccessException {
    getNotNull(userId);

    RemoteUserDAO.this.getClient().getUserdetailsClient(userId).removeUserDetail(userDetailsId);
    this.getRemoteAPI().syncNow();
  }

  public Profile verifyContact(String userId, Profile profile) throws DataAccessException {
    getNotNull(userId);

    try {
      return RemoteUserDAO.this.getClient().verifyContact(userId, new ProfileJSON(profile), null);
    } catch (WebApplicationException ex) {
      throw wrapClientException(ex, userId);
    }
  }

  @NotNull
  public DefaultAvatar getDefaultAvatar() {
    return defaultAvatar;
  }

  public SshPublicKey addSshPublicKey(String userId, SshPublicKey sshPublicKey) throws DataAccessException {
    getNotNull(userId);
    try {
      SshPublicKeyJSON json = new SshPublicKeyJSON();
      json.setData(sshPublicKey.getData());
      json.setOpenSshKey(sshPublicKey.getOpenSshKey());
      json = RemoteUserDAO.this.getClient().getSshpublickeysClient(userId).addSshPublicKey(json, Partial.sshPublicKey(Partial.SshPublicKey.FINGER_PRINT));

      this.getRemoteAPI().syncNow();
      return json;
    } catch (WebApplicationException ex) {
      throw wrapClientException(ex, userId);
    }
  }

  public void removeSshPublicKey(String userId, String fingerPrint) throws DataAccessException {
    getNotNull(userId);
    try {
      RemoteUserDAO.this.getClient().getSshpublickeysClient(userId).removeSshPublicKey(fingerPrint);
    } catch (WebApplicationException ex) {
      throw wrapClientException(ex, userId);
    }
    this.getRemoteAPI().syncNow();
  }

  public void newEvent(Event event) {
    // When user is created or deleted All Users group should be refreshed 
    Event.Type eventType = Event.Type.fromString(event.getType());
    if (eventType == Event.Type.CREATE || eventType == Event.Type.REMOVE) {
      jetbrains.jetpass.api.authority.UserGroup rootUserGroup = this.getRemoteAPI().getUserGroupDAO().getRootUserGroup();
      this.getRemoteAPI().getUserGroupDAO().refreshGroupUsers(rootUserGroup.getId());
    }
    super.newEvent(event);
  }

  public UserClient getClient() {
    return this.myClient;
  }

  public void setClient(UserClient value) {
    this.myClient = value;
  }
}
