package jetbrains.jetpass.dao.remote.api.authority;

/*Generated by MPS */

import jetbrains.jetpass.dao.remote.api.RemoteMutableDAO;
import jetbrains.jetpass.api.authority.details.UserDetails;
import jetbrains.jetpass.rest.dto.DetailsJSON;
import jetbrains.jetpass.client.accounts.Partial;
import jetbrains.jetpass.dao.api.authority.UserDetailsDAO;
import jetbrains.jetpass.client.accounts.UserDetailClient;
import java.util.Map;
import jetbrains.jetpass.dao.remote.api.RemoteItemAccessor;
import java.util.HashMap;
import jetbrains.mps.webr.rpc.rest.json.common.runtime.Page;
import jetbrains.jetpass.client.BaseFilter;
import jetbrains.jetpass.client.FieldPartial;
import org.jetbrains.annotations.Nullable;
import jetbrains.jetpass.sequence.Sequence;
import jetbrains.jetpass.api.authority.User;
import jetbrains.jetpass.sequence.impl.EmptySequence;
import jetbrains.jetpass.sequence.impl.FilterFunction;

public class RemoteUserDetailsDAO extends RemoteMutableDAO<UserDetails, DetailsJSON, Partial.Details> implements UserDetailsDAO {
  private UserDetailClient myClient;
  private Map<Class<? extends DetailsJSON>, RemoteItemAccessor> myDetailsRemoteItemAccessor;

  public RemoteUserDetailsDAO() {
    super(Partial.details(Partial.Details.ID));
    RemoteUserDetailsDAO.this.setDetailsRemoteItemAccessor(new HashMap<Class<? extends DetailsJSON>, RemoteItemAccessor>());
  }

  protected Page<DetailsJSON> fetchPage(BaseFilter filter, FieldPartial<Partial.Details> partial) {
    return RemoteUserDetailsDAO.this.getClient().getUserDetailPage(filter, partial);
  }

  protected DetailsJSON fetchItem(String id, FieldPartial<Partial.Details> partial) {
    return this.getClient().getUserDetail(id, partial);
  }

  protected FieldPartial<Partial.Details> createPartial(String fieldName) {
    return Partial.details(new Partial.Details(fieldName));
  }

  protected DetailsJSON doCreate(DetailsJSON json, FieldPartial<Partial.Details> partial) {
    return RemoteUserDetailsDAO.this.getClient().createUserDetail(json, partial);
  }

  protected void doUpdate(String id, DetailsJSON change) {
    RemoteUserDetailsDAO.this.getClient().updateUserDetail(id, change);
  }

  protected void doDelete(String id, @Nullable String successor) {
    RemoteUserDetailsDAO.this.getClient().deleteUserDetail(id);
  }

  protected DetailsJSON toJSON(UserDetails item) {
    return (item instanceof DetailsJSON ?
      ((DetailsJSON) item) :
      new DetailsJSON(item)
    );
  }

  public UserDetails resolveUserDetails(UserDetails prototype) {
    return prototype;
  }

  public Sequence<UserDetails> getDetails(final User user) {
    if (user == null || user.getId() == null) {
      return EmptySequence.getInstance();
    }
    return getAllItems().where(new FilterFunction<UserDetails>() {
      public boolean matches(UserDetails it) {
        return eq_d6ko40_a0a0a0a0a0b0i(user.getId(), it.getUser().getId());
      }
    });
  }

  @Override
  public RemoteItemAccessor<UserDetails, DetailsJSON> getItemAccessor(DetailsJSON dto) {
    return RemoteUserDetailsDAO.this.getDetailsRemoteItemAccessor().get(dto.getClass());
  }

  public void revoke(UserDetails id) {
    // TODO 
  }

  public UserDetailClient getClient() {
    return this.myClient;
  }

  public void setClient(UserDetailClient value) {
    this.myClient = value;
  }

  public Map<Class<? extends DetailsJSON>, RemoteItemAccessor> getDetailsRemoteItemAccessor() {
    return this.myDetailsRemoteItemAccessor;
  }

  private void setDetailsRemoteItemAccessor(Map<Class<? extends DetailsJSON>, RemoteItemAccessor> value) {
    this.myDetailsRemoteItemAccessor = value;
  }

  private static boolean eq_d6ko40_a0a0a0a0a0b0i(Object a, Object b) {
    return (a != null ?
      a.equals(b) :
      a == b
    );
  }
}
