package jetbrains.jetpass.dao.remote.api.authority;

/*Generated by MPS */

import jetbrains.jetpass.dao.remote.api.RemoteAuthHolderNamedMutableDAO;
import jetbrains.jetpass.api.authority.UserGroup;
import jetbrains.jetpass.rest.dto.UserGroupJSON;
import jetbrains.jetpass.client.accounts.Partial;
import jetbrains.jetpass.dao.api.authority.UserGroupDAO;
import jetbrains.jetpass.client.accounts.UserGroupClient;
import jetbrains.mps.webr.rpc.rest.json.common.runtime.Page;
import jetbrains.jetpass.client.BaseFilter;
import jetbrains.jetpass.client.FieldPartial;
import org.jetbrains.annotations.Nullable;
import jetbrains.jetpass.rest.dto.SpaceRoleJSON;
import jetbrains.jetpass.rest.dto.ProjectRoleJSON;
import jetbrains.jetpass.dao.api.DataAccessException;
import javax.ws.rs.WebApplicationException;
import java.util.List;
import jetbrains.jetpass.sequence.impl.IterableSequence;
import jetbrains.jetpass.sequence.impl.TransformFunction;
import jetbrains.jetpass.dao.api.permissionCache.PermissionQuery;
import jetbrains.jetpass.dao.remote.api.RemoteItemData;
import jetbrains.jetpass.api.event.Event;

public class RemoteUserGroupDAO extends RemoteAuthHolderNamedMutableDAO<UserGroup, UserGroupJSON, Partial.UserGroup> implements UserGroupDAO {
  private UserGroupClient myClient;

  public RemoteUserGroupDAO() {
    super(Partial.userGroup(Partial.UserGroup.ID, Partial.UserGroup.ALIAS_IDS, Partial.UserGroup.ALIAS_IDS, Partial.UserGroup.PARENT(Partial.UserGroup.ID), Partial.UserGroup.PROJECT_ROLES(Partial.ProjectRole.ID)));
  }

  protected Page<UserGroupJSON> fetchPage(BaseFilter filter, FieldPartial<Partial.UserGroup> partial) {
    return RemoteUserGroupDAO.this.getClient().getUserGroupPage(filter, partial);
  }

  protected UserGroupJSON fetchItem(String id, FieldPartial<Partial.UserGroup> partial) {
    return RemoteUserGroupDAO.this.getClient().getUserGroup(id, partial);
  }

  protected FieldPartial<Partial.UserGroup> createPartial(String fieldName) {
    return Partial.userGroup(new Partial.UserGroup(fieldName));
  }

  protected UserGroupJSON doCreate(UserGroupJSON json, FieldPartial<Partial.UserGroup> partial) {
    return RemoteUserGroupDAO.this.getClient().createUserGroup(json, partial);
  }

  protected void doUpdate(String id, UserGroupJSON change) {
    RemoteUserGroupDAO.this.getClient().updateUserGroup(id, change);
  }

  protected void doDelete(String id, @Nullable String successor) {
    RemoteUserGroupDAO.this.getClient().deleteUserGroup(id, successor);
  }

  protected UserGroupJSON toJSON(jetbrains.jetpass.api.authority.UserGroup item) {
    return ((item instanceof UserGroupJSON) ?
      ((UserGroupJSON) item) :
      new UserGroupJSON(item)
    );
  }

  public UserGroupJSON toJSON(String groupId) {
    UserGroupJSON group = new UserGroupJSON();
    group.setId(groupId);
    return group;
  }

  @Deprecated
  protected SpaceRoleJSON doCreateRole(String id, SpaceRoleJSON roleJSON, FieldPartial<Partial.SpaceRole> partial) {
    return RemoteUserGroupDAO.this.getClient().getRolesClient(id).addRole(roleJSON, partial);
  }

  protected ProjectRoleJSON doCreateRole(String id, ProjectRoleJSON roleJSON, FieldPartial<Partial.ProjectRole> partial) {
    return RemoteUserGroupDAO.this.getClient().getProjectrolesClient(id).addProjectRole(roleJSON, partial);
  }

  protected void doDeleteRole(String id, String roleId) {
    RemoteUserGroupDAO.this.getClient().getRolesClient(id).removeRole(roleId);
  }

  public void removeSubgroup(String parentId, String childId) throws DataAccessException {
    getNotNull(parentId);
    getNotNull(childId);

    try {
      RemoteUserGroupDAO.this.getClient().getSubgroupsClient(parentId).removeSubgroup(childId);
    } catch (WebApplicationException ex) {
      throw wrapClientException(ex, parentId);
    }
    this.getRemoteAPI().syncNow();
  }

  public void addSubgroup(String parentId, String childId) throws DataAccessException {
    getNotNull(parentId);
    getNotNull(childId);

    try {
      RemoteUserGroupDAO.this.getClient().getSubgroupsClient(parentId).addSubgroup(this.getRemoteAPI().getUserGroupDAO().toJSON(childId), _partial);
    } catch (WebApplicationException ex) {
      throw wrapClientException(ex, parentId);
    }
    this.getRemoteAPI().syncNow();
  }

  public void removeUser(String groupId, String userId) throws DataAccessException {
    this.getRemoteAPI().getUserDAO().getNotNull(userId);

    try {
      RemoteUserGroupDAO.this.getClient().getUsersClient(groupId).removeUser(userId);
    } catch (WebApplicationException ex) {
      throw wrapClientException(ex, groupId);
    }
    this.getRemoteAPI().syncNow();
  }

  public void addUser(String groupId, String userId) throws DataAccessException {
    RemoteUserDAO userDAO = this.getRemoteAPI().getUserDAO();
    userDAO.getNotNull(userId);

    try {
      RemoteUserGroupDAO.this.getClient().getUsersClient(groupId).addUser(userDAO.toJSON(userId), null);
    } catch (WebApplicationException ex) {
      throw wrapClientException(ex, groupId);
    }

    this.getRemoteAPI().syncNow();
  }

  public jetbrains.jetpass.api.authority.UserGroup getRootUserGroup() {
    // TODO: optimize! 
    UserGroupJSON rootGroup = RemoteUserGroupDAO.this.getClient().root(Partial.userGroup(Partial.UserGroup.ID));
    return get(rootGroup.getId());
  }

  public jetbrains.jetpass.api.authority.UserGroup merge(Iterable<jetbrains.jetpass.api.authority.UserGroup> groups, String name, String description, Boolean authJoin, String projectUUID, String parentGroupUUID) {
    try {
      List<UserGroupJSON> list = new IterableSequence(groups).select(new TransformFunction<jetbrains.jetpass.api.authority.UserGroup, UserGroupJSON>() {
        public UserGroupJSON transform(jetbrains.jetpass.api.authority.UserGroup it) {
          return toJSON(it);
        }
      }).toListSequence().toList();
      String mergedId = RemoteUserGroupDAO.this.getClient().merge(name, description, authJoin, projectUUID, parentGroupUUID, list.<UserGroupJSON>toArray(new UserGroupJSON[list.size()]), Partial.userGroup(Partial.UserGroup.ID)).getId();
      this.getRemoteAPI().syncNow();
      return get(mergedId);
    } catch (WebApplicationException ex) {
      throw wrapClientException(ex, null);
    }
  }

  public PermissionQuery getPermissionQuery(String authHolderId) {
    return this.getRemoteAPI().getPermissionCache().group(authHolderId, true);
  }

  public void refreshGroupUsers(String groupId) {
    RemoteItemData<jetbrains.jetpass.api.authority.UserGroup, UserGroupJSON> data = getData(groupId);
    data.resetField(Partial.UserGroup.USERS().getName());
    data.resetField(Partial.UserGroup.USER_COUNT.getName());
  }

  @Override
  public void newEvent(Event event) {
    // When userGroup is updated reset users field of it ancestors 
    Event.Type eventType = Event.Type.fromString(event.getType());
    String itemId = event.getTargetId();
    if (eventType == Event.Type.UPDATE) {
      do {
        RemoteItemData<jetbrains.jetpass.api.authority.UserGroup, UserGroupJSON> data = getData(itemId);
        if (data == null) {
          break;
        }
        jetbrains.jetpass.api.authority.UserGroup parent = data.getItem().getParent();
        if (parent == null) {
          break;
        }
        String parentId = parent.getId();
        this.getRemoteAPI().getUserGroupDAO().refreshGroupUsers(parentId);
        itemId = parentId;
      } while (itemId != null);
    }

    super.newEvent(event);
  }

  public UserGroupClient getClient() {
    return this.myClient;
  }

  public void setClient(UserGroupClient value) {
    this.myClient = value;
  }
}
