package jetbrains.jetpass.dao.remote.api.security;

/*Generated by MPS */

import jetbrains.jetpass.dao.remote.api.RemoteNamedMutableDAO;
import jetbrains.jetpass.api.security.Permission;
import jetbrains.jetpass.rest.dto.PermissionJSON;
import jetbrains.jetpass.client.accounts.Partial;
import jetbrains.jetpass.dao.api.security.PermissionDAO;
import jetbrains.jetpass.client.accounts.PermissionClient;
import jetbrains.mps.webr.rpc.rest.json.common.runtime.Page;
import jetbrains.jetpass.client.BaseFilter;
import jetbrains.jetpass.client.FieldPartial;
import org.jetbrains.annotations.Nullable;
import jetbrains.jetpass.dao.remote.api.ConstraintsUtil;
import jetbrains.jetpass.sequence.impl.FilterFunction;
import jetbrains.jetpass.sequence.Sequence;

public class RemotePermissionDAO extends RemoteNamedMutableDAO<Permission, PermissionJSON, Partial.Permission> implements PermissionDAO {
  private PermissionClient myClient;

  public RemotePermissionDAO() {
    super(Partial.permission(Partial.Permission.ID, Partial.Permission.ALIAS_IDS, Partial.Permission.SERVICE(Partial.Service.ID)));
  }

  protected Page<PermissionJSON> fetchPage(BaseFilter filter, FieldPartial<Partial.Permission> partial) {
    return RemotePermissionDAO.this.getClient().getPermissionPage(filter, partial);
  }

  protected PermissionJSON fetchItem(String id, FieldPartial<Partial.Permission> partial) {
    return RemotePermissionDAO.this.getClient().getPermission(id, partial);
  }

  protected FieldPartial<Partial.Permission> createPartial(String fieldName) {
    return Partial.permission(new Partial.Permission(fieldName));
  }

  protected PermissionJSON doCreate(PermissionJSON json, FieldPartial<Partial.Permission> partial) {
    return RemotePermissionDAO.this.getClient().createPermission(json, partial);
  }

  protected void doUpdate(String id, PermissionJSON change) {
    RemotePermissionDAO.this.getClient().updatePermission(id, change);
  }

  protected void doDelete(String id, @Nullable String successor) {
    RemotePermissionDAO.this.getClient().deletePermission(id);
  }

  public jetbrains.jetpass.api.security.Permission getByKey(String key, final String serviceId) {
    ConstraintsUtil.checkNotEmpty(serviceId, "Service Id");
    return getByKey(key).where(new FilterFunction<jetbrains.jetpass.api.security.Permission>() {
      public boolean matches(jetbrains.jetpass.api.security.Permission it) {
        return eq_9a53cu_a0a0a0a0a0a1a6(it.getService().getId(), serviceId);
      }
    }).first();
  }

  public Sequence<jetbrains.jetpass.api.security.Permission> getByKey(final String key) {
    ConstraintsUtil.checkNotEmpty(key, "Key");
    return getAllItems().where(new FilterFunction<jetbrains.jetpass.api.security.Permission>() {
      public boolean matches(jetbrains.jetpass.api.security.Permission it) {
        return eq_9a53cu_a0a0a0a0a0b0h(it.getKey(), key);
      }
    });
  }

  public PermissionJSON toJSON(jetbrains.jetpass.api.security.Permission item) {
    return (item instanceof PermissionJSON ?
      ((PermissionJSON) item) :
      new PermissionJSON(item)
    );
  }

  protected PermissionJSON toJSON(String permissionId) {
    PermissionJSON permission = new PermissionJSON();
    permission.setId(permissionId);
    return permission;
  }

  public PermissionClient getClient() {
    return this.myClient;
  }

  public void setClient(PermissionClient value) {
    this.myClient = value;
  }

  private static boolean eq_9a53cu_a0a0a0a0a0a1a6(Object a, Object b) {
    return (a != null ?
      a.equals(b) :
      a == b
    );
  }

  private static boolean eq_9a53cu_a0a0a0a0a0b0h(Object a, Object b) {
    return (a != null ?
      a.equals(b) :
      a == b
    );
  }
}
