package jetbrains.jetpass.dao.remote.api.security;

/*Generated by MPS */

import jetbrains.jetpass.dao.remote.api.RemoteNamedMutableDAO;
import jetbrains.jetpass.api.security.Resource;
import jetbrains.jetpass.rest.dto.ResourceJSON;
import jetbrains.jetpass.client.accounts.Partial;
import jetbrains.jetpass.dao.api.security.ResourceDAO;
import jetbrains.jetpass.client.accounts.ResourceClient;
import jetbrains.mps.webr.rpc.rest.json.common.runtime.Page;
import jetbrains.jetpass.client.BaseFilter;
import jetbrains.jetpass.client.FieldPartial;
import org.jetbrains.annotations.Nullable;
import jetbrains.jetpass.sequence.Sequence;
import jetbrains.jetpass.api.security.Space;
import jetbrains.jetpass.dao.remote.api.ConstraintsUtil;
import jetbrains.jetpass.sequence.impl.FilterFunction;
import jetbrains.jetpass.sequence.impl.IterableSequence;
import jetbrains.jetpass.api.security.Project;

public class RemoteResourceDAO extends RemoteNamedMutableDAO<Resource, ResourceJSON, Partial.Resource> implements ResourceDAO {
  private ResourceClient myClient;

  public RemoteResourceDAO() {
    super(Partial.resource(Partial.Resource.ID, Partial.Resource.ALIAS_IDS));
  }

  protected Page<ResourceJSON> fetchPage(BaseFilter filter, FieldPartial<Partial.Resource> partial) {
    return RemoteResourceDAO.this.getClient().getResourcePage(filter, partial);
  }

  protected ResourceJSON fetchItem(String id, FieldPartial<Partial.Resource> partial) {
    return RemoteResourceDAO.this.getClient().getResource(id, partial);
  }

  protected FieldPartial<Partial.Resource> createPartial(String fieldName) {
    return Partial.resource(new Partial.Resource(fieldName));
  }

  protected ResourceJSON doCreate(ResourceJSON json, FieldPartial<Partial.Resource> partial) {
    return RemoteResourceDAO.this.getClient().createResource(json, partial);
  }

  protected void doUpdate(String id, ResourceJSON change) {
    RemoteResourceDAO.this.getClient().updateResource(id, change);
  }

  protected void doDelete(String id, @Nullable String successor) {
    RemoteResourceDAO.this.getClient().deleteResource(id);
  }

  public Sequence<Space> getSpaces(final String resourceId) {
    // TODO: cache Resource -> list<Space> 
    ConstraintsUtil.checkNotEmptyId(resourceId);
    return this.getRemoteAPI().getSpaceDAO().getAllItems().where(new FilterFunction<Space>() {
      public boolean matches(Space it) {
        return new IterableSequence(it.getResources()).where(new FilterFunction<jetbrains.jetpass.api.security.Resource>() {
          public boolean matches(jetbrains.jetpass.api.security.Resource it2) {
            return eq_sutyy7_a0a0a0a0a0a0a0a0a0a2a6(it2.getId(), resourceId);
          }
        }).isNotEmpty();
      }
    });
  }

  public Sequence<Project> getProjects(final String resourceId) {
    // TODO: cache Resource -> list<Project> 
    ConstraintsUtil.checkNotEmptyId(resourceId);
    return this.getRemoteAPI().getProjectDAO().getAllItems().where(new FilterFunction<Project>() {
      public boolean matches(Project it) {
        return new IterableSequence(it.getResources()).where(new FilterFunction<jetbrains.jetpass.api.security.Resource>() {
          public boolean matches(jetbrains.jetpass.api.security.Resource it2) {
            return eq_sutyy7_a0a0a0a0a0a0a0a0a0a2a7(it2.getId(), resourceId);
          }
        }).isNotEmpty();
      }
    });
  }

  public Sequence<jetbrains.jetpass.api.security.Resource> getByKey(final String key) {
    ConstraintsUtil.checkNotEmpty(key, "Key");
    return getAllItems().where(new FilterFunction<jetbrains.jetpass.api.security.Resource>() {
      public boolean matches(jetbrains.jetpass.api.security.Resource it) {
        return eq_sutyy7_a0a0a0a0a0b0i(it.getKey(), key);
      }
    });
  }

  public jetbrains.jetpass.api.security.Resource getByKey(String key, final String serviceId) {
    ConstraintsUtil.checkNotEmpty(serviceId, "Service Id");
    return getByKey(key).where(new FilterFunction<jetbrains.jetpass.api.security.Resource>() {
      public boolean matches(jetbrains.jetpass.api.security.Resource it) {
        return eq_sutyy7_a0a0a0a0a0a1a9(it.getService().getId(), serviceId);
      }
    }).first();
  }

  public ResourceJSON toJSON(jetbrains.jetpass.api.security.Resource item) {
    return (item instanceof ResourceJSON ?
      (ResourceJSON) item :
      new ResourceJSON(item)
    );
  }

  protected ResourceJSON toJSON(String resourceId) {
    ResourceJSON resource = new ResourceJSON();
    resource.setId(resourceId);
    return resource;
  }

  public ResourceClient getClient() {
    return this.myClient;
  }

  public void setClient(ResourceClient value) {
    this.myClient = value;
  }

  private static boolean eq_sutyy7_a0a0a0a0a0a0a0a0a0a2a6(Object a, Object b) {
    return (a != null ?
      a.equals(b) :
      a == b
    );
  }

  private static boolean eq_sutyy7_a0a0a0a0a0a0a0a0a0a2a7(Object a, Object b) {
    return (a != null ?
      a.equals(b) :
      a == b
    );
  }

  private static boolean eq_sutyy7_a0a0a0a0a0b0i(Object a, Object b) {
    return (a != null ?
      a.equals(b) :
      a == b
    );
  }

  private static boolean eq_sutyy7_a0a0a0a0a0a1a9(Object a, Object b) {
    return (a != null ?
      a.equals(b) :
      a == b
    );
  }
}
