package jetbrains.jetpass.dao.remote.api.settings;

/*Generated by MPS */

import jetbrains.jetpass.dao.remote.api.RemoteMutableDAO;
import jetbrains.jetpass.api.settings.Settings;
import jetbrains.jetpass.rest.dto.SettingsJSON;
import jetbrains.jetpass.client.accounts.Partial;
import jetbrains.jetpass.dao.api.settings.SettingsDAO;
import jetbrains.jetpass.client.accounts.SettingClient;
import java.util.Map;
import jetbrains.jetpass.dao.remote.api.RemoteItemAccessor;
import java.util.HashMap;
import jetbrains.jetpass.client.FieldPartial;
import org.jetbrains.annotations.Nullable;
import jetbrains.jetpass.api.settings.LicenseSettings;
import jetbrains.jetpass.rest.dto.LicenseJSON;
import jetbrains.jetpass.api.settings.PublicSettings;
import jetbrains.jetpass.rest.dto.PublicSettingsJSON;
import jetbrains.jetpass.api.settings.SMTPSettings;
import jetbrains.jetpass.rest.dto.SmtpSettingsJSON;
import jetbrains.jetpass.api.settings.JabberSettings;
import jetbrains.jetpass.rest.dto.JabberSettingsJSON;
import jetbrains.jetpass.api.settings.BackupSettings;
import jetbrains.jetpass.rest.dto.BackupSettingsJSON;
import jetbrains.jetpass.api.settings.ImportSettings;
import jetbrains.jetpass.rest.dto.ImportSettingsJSON;
import jetbrains.jetpass.sequence.impl.FilterFunction;
import javax.ws.rs.WebApplicationException;
import jetbrains.mps.webr.rpc.rest.json.common.runtime.Page;
import jetbrains.jetpass.client.BaseFilter;
import jetbrains.jetpass.api.settings.Locale;
import jetbrains.jetpass.api.settings.UpdateStatus;

public class RemoteSettingsDAO extends RemoteMutableDAO<Settings, SettingsJSON, Partial.Settings> implements SettingsDAO {
  private SettingClient myClient;
  private Map<Class<? extends SettingsJSON>, RemoteItemAccessor> mySettingsItemAccessor;

  public RemoteSettingsDAO() {
    super(Partial.settings(Partial.Settings.ID, Partial.Settings.ALIAS_IDS));
    RemoteSettingsDAO.this.setSettingsItemAccessor(new HashMap<Class<? extends SettingsJSON>, RemoteItemAccessor>(1));
  }

  protected SettingsJSON doCreate(SettingsJSON json, FieldPartial<Partial.Settings> partial) {
    throw new UnsupportedOperationException();
  }

  protected void doUpdate(String id, SettingsJSON change) {
    RemoteSettingsDAO.this.getClient().updateSetting(id, change);
  }

  protected void doDelete(String id, @Nullable String successor) {
    throw new UnsupportedOperationException();
  }

  protected SettingsJSON toJSON(jetbrains.jetpass.api.settings.Settings item) {
    if (item instanceof SettingsJSON) {
      return (SettingsJSON) item;
    } else if (item instanceof LicenseSettings) {
      return new LicenseJSON((LicenseSettings) item);
    } else if (item instanceof PublicSettings) {
      return new PublicSettingsJSON((PublicSettings) item);
    } else if (item instanceof SMTPSettings) {
      return new SmtpSettingsJSON((SMTPSettings) item);
    } else if (item instanceof JabberSettings) {
      return new JabberSettingsJSON((JabberSettings) item);
    } else if (item instanceof BackupSettings) {
      return new BackupSettingsJSON((BackupSettings) item);
    } else if (item instanceof ImportSettings) {
      return new ImportSettingsJSON((ImportSettings) item);
    } else {
      // TODO: support other types 
      return null;
    }
  }

  private <S extends jetbrains.jetpass.api.settings.Settings> S getByType(final Class<S> type) {
    return (S) getAllItems().where(new FilterFunction<jetbrains.jetpass.api.settings.Settings>() {
      public boolean matches(jetbrains.jetpass.api.settings.Settings element) {
        return type.isAssignableFrom(element.getClass());
      }
    }).first();
  }

  public PublicSettings getPublicSettings() {
    return getByType(PublicSettings.class);
  }

  public LicenseSettings getLicenseSettings() {
    return getByType(LicenseSettings.class);
  }

  public SMTPSettings getSMTPSettings() {
    return getByType(SMTPSettings.class);
  }

  public JabberSettings getJabberSettings() {
    return getByType(JabberSettings.class);
  }

  public BackupSettings getBackupSettings() {
    return getByType(BackupSettings.class);
  }

  public ImportSettings getImportSettings() {
    return getByType(ImportSettings.class);
  }

  public void testEmail(String email) {
    testSettings(getSMTPSettings(), email);
  }

  public void testJabber(String jabber) {
    testSettings(getJabberSettings(), jabber);
  }

  public BackupSettings.Status backup() {
    try {
      return RemoteSettingsDAO.this.getClient().backupData(null);
    } catch (WebApplicationException ex) {
      throw wrapClientException(ex, null);
    }
  }

  private void testSettings(jetbrains.jetpass.api.settings.Settings settings, String contact) {
    String id = settings.getId();
    try {
      RemoteSettingsDAO.this.getClient().test(id, contact, null);
    } catch (WebApplicationException ex) {
      throw wrapClientException(ex, id);
    }
  }

  protected FieldPartial<Partial.Settings> createPartial(String fieldName) {
    return Partial.settings(new Partial.Settings(fieldName));
  }

  protected Page<SettingsJSON> fetchPage(BaseFilter filter, FieldPartial<Partial.Settings> partial) {
    return RemoteSettingsDAO.this.getClient().getSettingPage(filter, partial);
  }

  protected SettingsJSON fetchItem(String id, FieldPartial<Partial.Settings> partial) {
    return RemoteSettingsDAO.this.getClient().getSetting(id, partial);
  }

  @Override
  public RemoteItemAccessor<jetbrains.jetpass.api.settings.Settings, SettingsJSON> getItemAccessor(SettingsJSON dto) {
    return RemoteSettingsDAO.this.getSettingsItemAccessor().get(dto.getClass());
  }

  public Iterable<? extends Locale> getAvailableLocales() {
    return null;
  }

  public UpdateStatus getUpdateStatus() {
    throw new UnsupportedOperationException();
  }

  public SettingClient getClient() {
    return this.myClient;
  }

  public void setClient(SettingClient value) {
    this.myClient = value;
  }

  public Map<Class<? extends SettingsJSON>, RemoteItemAccessor> getSettingsItemAccessor() {
    return this.mySettingsItemAccessor;
  }

  private void setSettingsItemAccessor(Map<Class<? extends SettingsJSON>, RemoteItemAccessor> value) {
    this.mySettingsItemAccessor = value;
  }
}
