package jetbrains.jetpass.rest.dto;

/*Generated by MPS */

import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAccessType;
import com.fasterxml.jackson.annotation.JsonTypeInfo;
import jetbrains.jetpass.api.authority.AuthorityHolder;
import javax.xml.bind.annotation.XmlElement;
import java.util.List;
import org.jetbrains.annotations.NotNull;
import java.util.ArrayList;
import jetbrains.jetpass.api.security.SpaceRole;
import jetbrains.jetpass.api.security.ProjectRole;
import org.jetbrains.annotations.Nullable;
import javax.xml.bind.annotation.XmlTransient;

@XmlRootElement(name = "authorityHolder")
@XmlAccessorType(value = XmlAccessType.FIELD)
@JsonTypeInfo(use = JsonTypeInfo.Id.NAME, include = JsonTypeInfo.As.PROPERTY, property = "type", defaultImpl = AuthorityHolderJSON.class)
public class AuthorityHolderJSON implements AuthorityHolder {
  @XmlElement(name = "id")
  private String id;
  @XmlElement(name = "aliasIds")
  private List<String> aliasIds;
  @XmlElement(name = "url")
  private String url;
  @XmlElement(name = "name")
  private String name;
  @XmlElement(name = "roles")
  private List<SpaceRoleJSON> roles;
  @XmlElement(name = "projectRoles")
  private List<ProjectRoleJSON> projectRoles;

  public AuthorityHolderJSON() {
  }

  public AuthorityHolderJSON(@NotNull AuthorityHolder that) {
    this.setId(that.getId());
    this.setAliasIds(that.getAliasIds());
    this.setName(that.getName());
    if (that.getRoles() != null) {
      List<SpaceRoleJSON> aggregated = new ArrayList<SpaceRoleJSON>();
      for (SpaceRole it : that.getRoles()) {
        aggregated.add(new SpaceRoleJSON(it));
      }
      this.setRoles(aggregated);
    }
    if (that.getProjectRoles() != null) {
      List<ProjectRoleJSON> aggregated = new ArrayList<ProjectRoleJSON>();
      for (ProjectRole it : that.getProjectRoles()) {
        aggregated.add(new ProjectRoleJSON(it));
      }
      this.setProjectRoles(aggregated);
    }
  }

  @Nullable
  public String getId() {
    return this.id;
  }

  @Nullable
  public Iterable<String> getAliasIds() {
    return this.aliasIds;
  }

  @Nullable
  public String getUrl() {
    return this.url;
  }

  @Nullable
  public String getName() {
    return this.name;
  }

  @Nullable
  @Deprecated
  public Iterable<SpaceRoleJSON> getRoles() {
    return this.roles;
  }

  @Nullable
  public Iterable<ProjectRoleJSON> getProjectRoles() {
    return this.projectRoles;
  }

  @XmlTransient
  public void setId(@Nullable String id) {
    this.id = id;
  }

  @XmlTransient
  public void setAliasIds(@Nullable Iterable<String> aliasIds) {
    this.aliasIds = new ArrayList<String>();
    if (aliasIds != null) {
      for (String it : aliasIds) {
        this.aliasIds.add(it);
      }
    }
  }

  @XmlTransient
  public void setUrl(@Nullable String url) {
    this.url = url;
  }

  @XmlTransient
  public void setName(@Nullable String name) {
    this.name = name;
  }

  @XmlTransient
  @Deprecated
  public void setRoles(@Nullable Iterable<SpaceRoleJSON> roles) {
    this.roles = new ArrayList<SpaceRoleJSON>();
    if (roles != null) {
      for (SpaceRoleJSON it : roles) {
        this.roles.add(it);
      }
    }
  }

  @XmlTransient
  public void setProjectRoles(@Nullable Iterable<ProjectRoleJSON> projectRoles) {
    this.projectRoles = new ArrayList<ProjectRoleJSON>();
    if (projectRoles != null) {
      for (ProjectRoleJSON it : projectRoles) {
        this.projectRoles.add(it);
      }
    }
  }

  @Override
  public String toString() {
    return append(new StringBuilder()).toString();
  }

  public StringBuilder append(StringBuilder builder) {
    builder.append('{');
    appendFields(builder, true);
    builder.append('}');
    return builder;
  }

  protected boolean appendFields(StringBuilder builder, boolean firstProperty) {
    firstProperty = firstProperty;
    if (this.id != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("id").append("\": ");
      builder.append(this.id);
    }
    if (this.aliasIds != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("aliasIds").append("\": ");
      {
        builder.append('[');
        boolean firstV = true;
        for (String v : this.aliasIds) {
          if (firstV) {
            firstV = false;
          } else {
            builder.append(", ");
          }
          builder.append(v);
        }
        builder.append(']');
      }
    }
    if (this.url != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("url").append("\": ");
      builder.append(this.url);
    }
    if (this.name != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("name").append("\": ");
      builder.append(this.name);
    }
    if (this.roles != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("roles").append("\": ");
      {
        builder.append('[');
        boolean firstV = true;
        for (SpaceRoleJSON v : this.roles) {
          if (firstV) {
            firstV = false;
          } else {
            builder.append(", ");
          }
          v.append(builder);

        }
        builder.append(']');
      }
    }
    if (this.projectRoles != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("projectRoles").append("\": ");
      {
        builder.append('[');
        boolean firstV = true;
        for (ProjectRoleJSON v : this.projectRoles) {
          if (firstV) {
            firstV = false;
          } else {
            builder.append(", ");
          }
          v.append(builder);

        }
        builder.append(']');
      }
    }
    return firstProperty;
  }
}
