package jetbrains.jetpass.rest.dto;

/*Generated by MPS */

import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAccessType;
import jetbrains.jetpass.api.event.Event;
import javax.xml.bind.annotation.XmlElement;
import java.util.List;
import java.util.Calendar;
import org.jetbrains.annotations.NotNull;
import java.util.ArrayList;
import jetbrains.jetpass.api.event.Change;
import org.jetbrains.annotations.Nullable;
import javax.xml.bind.annotation.XmlTransient;

@XmlRootElement(name = "event")
@XmlAccessorType(value = XmlAccessType.FIELD)
public class EventJSON implements Event {
  @XmlElement(name = "id")
  private String id;
  @XmlElement(name = "aliasIds")
  private List<String> aliasIds;
  @XmlElement(name = "url")
  private String url;
  @XmlElement(name = "targetId")
  private String targetId;
  @XmlElement(name = "targetType")
  private String targetType;
  @XmlElement(name = "targetPresentation")
  private String targetPresentation;
  @XmlElement(name = "author")
  private String author;
  @XmlElement(name = "authorPresentation")
  private String authorPresentation;
  @XmlElement(name = "authorType")
  private String authorType;
  @XmlElement(name = "changes")
  private List<ChangeJSON> changes;
  @XmlElement(name = "type")
  private String type;
  @XmlElement(name = "timestamp")
  private Calendar timestamp;

  public EventJSON() {
  }

  public EventJSON(@NotNull Event that) {
    this.setId(that.getId());
    this.setAliasIds(that.getAliasIds());
    this.setTargetId(that.getTargetId());
    this.setTargetType(that.getTargetType());
    this.setTargetPresentation(that.getTargetPresentation());
    this.setAuthor(that.getAuthor());
    this.setAuthorPresentation(that.getAuthorPresentation());
    this.setAuthorType(that.getAuthorType());
    if (that.getChanges() != null) {
      List<ChangeJSON> aggregated = new ArrayList<ChangeJSON>();
      for (Change it : that.getChanges()) {
        aggregated.add(new ChangeJSON(it));
      }
      this.setChanges(aggregated);
    }
    this.setType(that.getType());
    this.setTimestamp(that.getTimestamp());
  }

  @Nullable
  public String getId() {
    return this.id;
  }

  @Nullable
  public Iterable<String> getAliasIds() {
    return this.aliasIds;
  }

  @Nullable
  public String getUrl() {
    return this.url;
  }

  @Nullable
  public String getTargetId() {
    return this.targetId;
  }

  @Nullable
  public String getTargetType() {
    return this.targetType;
  }

  @Nullable
  public String getTargetPresentation() {
    return this.targetPresentation;
  }

  @Nullable
  public String getAuthor() {
    return this.author;
  }

  @Nullable
  public String getAuthorPresentation() {
    return this.authorPresentation;
  }

  @Nullable
  public String getAuthorType() {
    return this.authorType;
  }

  @Nullable
  public Iterable<ChangeJSON> getChanges() {
    return this.changes;
  }

  @Nullable
  public String getType() {
    return this.type;
  }

  @Nullable
  public Calendar getTimestamp() {
    return this.timestamp;
  }

  @XmlTransient
  public void setId(@Nullable String id) {
    this.id = id;
  }

  @XmlTransient
  public void setAliasIds(@Nullable Iterable<String> aliasIds) {
    this.aliasIds = new ArrayList<String>();
    if (aliasIds != null) {
      for (String it : aliasIds) {
        this.aliasIds.add(it);
      }
    }
  }

  @XmlTransient
  public void setUrl(@Nullable String url) {
    this.url = url;
  }

  @XmlTransient
  public void setTargetId(@Nullable String targetId) {
    this.targetId = targetId;
  }

  @XmlTransient
  public void setTargetType(@Nullable String targetType) {
    this.targetType = targetType;
  }

  @XmlTransient
  public void setTargetPresentation(@Nullable String targetPresentation) {
    this.targetPresentation = targetPresentation;
  }

  @XmlTransient
  public void setAuthor(@Nullable String author) {
    this.author = author;
  }

  @XmlTransient
  public void setAuthorPresentation(@Nullable String authorPresentation) {
    this.authorPresentation = authorPresentation;
  }

  @XmlTransient
  public void setAuthorType(@Nullable String authorType) {
    this.authorType = authorType;
  }

  @XmlTransient
  public void setChanges(@Nullable Iterable<ChangeJSON> changes) {
    this.changes = new ArrayList<ChangeJSON>();
    if (changes != null) {
      for (ChangeJSON it : changes) {
        this.changes.add(it);
      }
    }
  }

  @XmlTransient
  public void setType(@Nullable String type) {
    this.type = type;
  }

  @XmlTransient
  public void setTimestamp(@Nullable Calendar timestamp) {
    this.timestamp = timestamp;
  }

  @Override
  public String toString() {
    return append(new StringBuilder()).toString();
  }

  public StringBuilder append(StringBuilder builder) {
    builder.append('{');
    appendFields(builder, true);
    builder.append('}');
    return builder;
  }

  protected boolean appendFields(StringBuilder builder, boolean firstProperty) {
    firstProperty = firstProperty;
    if (this.id != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("id").append("\": ");
      builder.append(this.id);
    }
    if (this.aliasIds != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("aliasIds").append("\": ");
      {
        builder.append('[');
        boolean firstV = true;
        for (String v : this.aliasIds) {
          if (firstV) {
            firstV = false;
          } else {
            builder.append(", ");
          }
          builder.append(v);
        }
        builder.append(']');
      }
    }
    if (this.url != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("url").append("\": ");
      builder.append(this.url);
    }
    if (this.targetId != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("targetId").append("\": ");
      builder.append(this.targetId);
    }
    if (this.targetType != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("targetType").append("\": ");
      builder.append(this.targetType);
    }
    if (this.targetPresentation != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("targetPresentation").append("\": ");
      builder.append(this.targetPresentation);
    }
    if (this.author != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("author").append("\": ");
      builder.append(this.author);
    }
    if (this.authorPresentation != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("authorPresentation").append("\": ");
      builder.append(this.authorPresentation);
    }
    if (this.authorType != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("authorType").append("\": ");
      builder.append(this.authorType);
    }
    if (this.changes != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("changes").append("\": ");
      {
        builder.append('[');
        boolean firstV = true;
        for (ChangeJSON v : this.changes) {
          if (firstV) {
            firstV = false;
          } else {
            builder.append(", ");
          }
          v.append(builder);

        }
        builder.append(']');
      }
    }
    if (this.type != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("type").append("\": ");
      builder.append(this.type);
    }
    if (this.timestamp != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("timestamp").append("\": ");
      builder.append(this.timestamp);
    }
    return firstProperty;
  }
}
