package jetbrains.jetpass.rest.dto;

/*Generated by MPS */

import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAccessType;
import jetbrains.jetpass.api.ssl.KeyStore;
import javax.xml.bind.annotation.XmlElement;
import java.util.List;
import org.jetbrains.annotations.NotNull;
import java.util.ArrayList;
import jetbrains.jetpass.api.ssl.CertificateInfo;
import org.jetbrains.annotations.Nullable;
import javax.xml.bind.annotation.XmlTransient;

@XmlRootElement(name = "keyStore")
@XmlAccessorType(value = XmlAccessType.FIELD)
public class KeyStoreJSON implements KeyStore {
  @XmlElement(name = "id")
  private String id;
  @XmlElement(name = "aliasIds")
  private List<String> aliasIds;
  @XmlElement(name = "url")
  private String url;
  @XmlElement(name = "name")
  private String name;
  @XmlElement(name = "data")
  private KeyStoreDataJSON data;
  @XmlElement(name = "certificates")
  private List<CertificateInfoJSON> certificates;
  @XmlElement(name = "certificate")
  private CertificateInfoJSON certificate;

  public KeyStoreJSON() {
  }

  public KeyStoreJSON(@NotNull KeyStore that) {
    this.setId(that.getId());
    this.setAliasIds(that.getAliasIds());
    this.setName(that.getName());
    if (that.getData() != null) {
      this.setData(new KeyStoreDataJSON(that.getData()));
    }
    if (that.getCertificates() != null) {
      List<CertificateInfoJSON> aggregated = new ArrayList<CertificateInfoJSON>();
      for (CertificateInfo it : that.getCertificates()) {
        aggregated.add(new CertificateInfoJSON(it));
      }
      this.setCertificates(aggregated);
    }
    if (that.getCertificate() != null) {
      this.setCertificate(new CertificateInfoJSON(that.getCertificate()));
    }
  }

  @Nullable
  public String getId() {
    return this.id;
  }

  @Nullable
  public Iterable<String> getAliasIds() {
    return this.aliasIds;
  }

  @Nullable
  public String getUrl() {
    return this.url;
  }

  @Nullable
  public String getName() {
    return this.name;
  }

  @Nullable
  public KeyStoreDataJSON getData() {
    return this.data;
  }

  @Nullable
  public Iterable<CertificateInfoJSON> getCertificates() {
    return this.certificates;
  }

  @Nullable
  public CertificateInfoJSON getCertificate() {
    return this.certificate;
  }

  @XmlTransient
  public void setId(@Nullable String id) {
    this.id = id;
  }

  @XmlTransient
  public void setAliasIds(@Nullable Iterable<String> aliasIds) {
    this.aliasIds = new ArrayList<String>();
    if (aliasIds != null) {
      for (String it : aliasIds) {
        this.aliasIds.add(it);
      }
    }
  }

  @XmlTransient
  public void setUrl(@Nullable String url) {
    this.url = url;
  }

  @XmlTransient
  public void setName(@Nullable String name) {
    this.name = name;
  }

  @XmlTransient
  public void setData(@Nullable KeyStoreDataJSON data) {
    this.data = data;
  }

  @XmlTransient
  public void setCertificates(@Nullable Iterable<CertificateInfoJSON> certificates) {
    this.certificates = new ArrayList<CertificateInfoJSON>();
    if (certificates != null) {
      for (CertificateInfoJSON it : certificates) {
        this.certificates.add(it);
      }
    }
  }

  @XmlTransient
  public void setCertificate(@Nullable CertificateInfoJSON certificate) {
    this.certificate = certificate;
  }

  @Override
  public String toString() {
    return append(new StringBuilder()).toString();
  }

  public StringBuilder append(StringBuilder builder) {
    builder.append('{');
    appendFields(builder, true);
    builder.append('}');
    return builder;
  }

  protected boolean appendFields(StringBuilder builder, boolean firstProperty) {
    firstProperty = firstProperty;
    if (this.id != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("id").append("\": ");
      builder.append(this.id);
    }
    if (this.aliasIds != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("aliasIds").append("\": ");
      {
        builder.append('[');
        boolean firstV = true;
        for (String v : this.aliasIds) {
          if (firstV) {
            firstV = false;
          } else {
            builder.append(", ");
          }
          builder.append(v);
        }
        builder.append(']');
      }
    }
    if (this.url != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("url").append("\": ");
      builder.append(this.url);
    }
    if (this.name != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("name").append("\": ");
      builder.append(this.name);
    }
    if (this.data != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("data").append("\": ");
      this.data.append(builder);
    }
    if (this.certificates != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("certificates").append("\": ");
      {
        builder.append('[');
        boolean firstV = true;
        for (CertificateInfoJSON v : this.certificates) {
          if (firstV) {
            firstV = false;
          } else {
            builder.append(", ");
          }
          v.append(builder);

        }
        builder.append(']');
      }
    }
    if (this.certificate != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("certificate").append("\": ");
      this.certificate.append(builder);
    }
    return firstProperty;
  }
}
