package jetbrains.jetpass.rest.dto;

/*Generated by MPS */

import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAccessType;
import jetbrains.jetpass.api.security.Project;
import javax.xml.bind.annotation.XmlElement;
import java.util.List;
import org.jetbrains.annotations.NotNull;
import java.util.ArrayList;
import jetbrains.jetpass.api.security.Resource;
import org.jetbrains.annotations.Nullable;
import javax.xml.bind.annotation.XmlTransient;

@XmlRootElement(name = "project")
@XmlAccessorType(value = XmlAccessType.FIELD)
public class ProjectJSON implements Project {
  @XmlElement(name = "id")
  private String id;
  @XmlElement(name = "aliasIds")
  private List<String> aliasIds;
  @XmlElement(name = "url")
  private String url;
  @XmlElement(name = "key")
  private String key;
  @XmlElement(name = "name")
  private String name;
  @XmlElement(name = "archived")
  private Boolean archived;
  @XmlElement(name = "description")
  private String description;
  @XmlElement(name = "iconUrl")
  private String iconUrl;
  @XmlElement(name = "resources")
  private List<ResourceJSON> resources;

  public ProjectJSON() {
  }

  public ProjectJSON(@NotNull Project that) {
    this.setId(that.getId());
    this.setAliasIds(that.getAliasIds());
    this.setKey(that.getKey());
    this.setName(that.getName());
    this.setArchived(that.isArchived());
    this.setDescription(that.getDescription());
    this.setIconUrl(that.getIconUrl());
    if (that.getResources() != null) {
      List<ResourceJSON> references = new ArrayList<ResourceJSON>();
      for (Resource it : that.getResources()) {
        ResourceJSON ref = new ResourceJSON();
        ref.setId(it.getId());
        references.add(ref);
      }
      this.setResources(references);
    }
  }

  @Nullable
  public String getId() {
    return this.id;
  }

  @Nullable
  public Iterable<String> getAliasIds() {
    return this.aliasIds;
  }

  @Nullable
  public String getUrl() {
    return this.url;
  }

  @Nullable
  public String getKey() {
    return this.key;
  }

  @Nullable
  public String getName() {
    return this.name;
  }

  @Nullable
  public Boolean isArchived() {
    return this.archived;
  }

  @Nullable
  public String getDescription() {
    return this.description;
  }

  @Nullable
  public String getIconUrl() {
    return this.iconUrl;
  }

  @Nullable
  public Iterable<ResourceJSON> getResources() {
    return this.resources;
  }

  @XmlTransient
  public void setId(@Nullable String id) {
    this.id = id;
  }

  @XmlTransient
  public void setAliasIds(@Nullable Iterable<String> aliasIds) {
    this.aliasIds = new ArrayList<String>();
    if (aliasIds != null) {
      for (String it : aliasIds) {
        this.aliasIds.add(it);
      }
    }
  }

  @XmlTransient
  public void setUrl(@Nullable String url) {
    this.url = url;
  }

  @XmlTransient
  public void setKey(@Nullable String key) {
    this.key = key;
  }

  @XmlTransient
  public void setName(@Nullable String name) {
    this.name = name;
  }

  @XmlTransient
  public void setArchived(@Nullable Boolean archived) {
    this.archived = archived;
  }

  @XmlTransient
  public void setDescription(@Nullable String description) {
    this.description = description;
  }

  @XmlTransient
  public void setIconUrl(@Nullable String iconUrl) {
    this.iconUrl = iconUrl;
  }

  @XmlTransient
  public void setResources(@Nullable Iterable<ResourceJSON> resources) {
    this.resources = new ArrayList<ResourceJSON>();
    if (resources != null) {
      for (ResourceJSON it : resources) {
        this.resources.add(it);
      }
    }
  }

  @Override
  public String toString() {
    return append(new StringBuilder()).toString();
  }

  public StringBuilder append(StringBuilder builder) {
    builder.append('{');
    appendFields(builder, true);
    builder.append('}');
    return builder;
  }

  protected boolean appendFields(StringBuilder builder, boolean firstProperty) {
    firstProperty = firstProperty;
    if (this.id != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("id").append("\": ");
      builder.append(this.id);
    }
    if (this.aliasIds != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("aliasIds").append("\": ");
      {
        builder.append('[');
        boolean firstV = true;
        for (String v : this.aliasIds) {
          if (firstV) {
            firstV = false;
          } else {
            builder.append(", ");
          }
          builder.append(v);
        }
        builder.append(']');
      }
    }
    if (this.url != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("url").append("\": ");
      builder.append(this.url);
    }
    if (this.key != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("key").append("\": ");
      builder.append(this.key);
    }
    if (this.name != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("name").append("\": ");
      builder.append(this.name);
    }
    if (this.archived != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("archived").append("\": ");
      builder.append(this.archived);
    }
    if (this.description != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("description").append("\": ");
      builder.append(this.description);
    }
    if (this.iconUrl != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("iconUrl").append("\": ");
      builder.append(this.iconUrl);
    }
    if (this.resources != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("resources").append("\": ");
      {
        builder.append('[');
        boolean firstV = true;
        for (ResourceJSON v : this.resources) {
          if (firstV) {
            firstV = false;
          } else {
            builder.append(", ");
          }
          v.append(builder);

        }
        builder.append(']');
      }
    }
    return firstProperty;
  }
}
