package jetbrains.jetpass.rest.dto;

/*Generated by MPS */

import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAccessType;
import jetbrains.jetpass.api.security.Role;
import javax.xml.bind.annotation.XmlElement;
import java.util.List;
import org.jetbrains.annotations.NotNull;
import java.util.ArrayList;
import jetbrains.jetpass.api.security.Permission;
import org.jetbrains.annotations.Nullable;
import javax.xml.bind.annotation.XmlTransient;

@XmlRootElement(name = "role")
@XmlAccessorType(value = XmlAccessType.FIELD)
public class RoleJSON implements Role {
  @XmlElement(name = "id")
  private String id;
  @XmlElement(name = "aliasIds")
  private List<String> aliasIds;
  @XmlElement(name = "url")
  private String url;
  @XmlElement(name = "key")
  private String key;
  @XmlElement(name = "name")
  private String name;
  @XmlElement(name = "description")
  private String description;
  @XmlElement(name = "teamRole")
  private Boolean teamRole;
  @XmlElement(name = "permissions")
  private List<PermissionJSON> permissions;

  public RoleJSON() {
  }

  public RoleJSON(@NotNull Role that) {
    this.setId(that.getId());
    this.setAliasIds(that.getAliasIds());
    this.setKey(that.getKey());
    this.setName(that.getName());
    this.setDescription(that.getDescription());
    this.setTeamRole(that.isTeamRole());
    if (that.getPermissions() != null) {
      List<PermissionJSON> references = new ArrayList<PermissionJSON>();
      for (Permission it : that.getPermissions()) {
        PermissionJSON ref = new PermissionJSON();
        ref.setId(it.getId());
        references.add(ref);
      }
      this.setPermissions(references);
    }
  }

  @Nullable
  public String getId() {
    return this.id;
  }

  @Nullable
  public Iterable<String> getAliasIds() {
    return this.aliasIds;
  }

  @Nullable
  public String getUrl() {
    return this.url;
  }

  @Nullable
  public String getKey() {
    return this.key;
  }

  @Nullable
  public String getName() {
    return this.name;
  }

  @Nullable
  public String getDescription() {
    return this.description;
  }

  @Nullable
  public Boolean isTeamRole() {
    return this.teamRole;
  }

  @Nullable
  public Iterable<PermissionJSON> getPermissions() {
    return this.permissions;
  }

  @XmlTransient
  public void setId(@Nullable String id) {
    this.id = id;
  }

  @XmlTransient
  public void setAliasIds(@Nullable Iterable<String> aliasIds) {
    this.aliasIds = new ArrayList<String>();
    if (aliasIds != null) {
      for (String it : aliasIds) {
        this.aliasIds.add(it);
      }
    }
  }

  @XmlTransient
  public void setUrl(@Nullable String url) {
    this.url = url;
  }

  @XmlTransient
  public void setKey(@Nullable String key) {
    this.key = key;
  }

  @XmlTransient
  public void setName(@Nullable String name) {
    this.name = name;
  }

  @XmlTransient
  public void setDescription(@Nullable String description) {
    this.description = description;
  }

  @XmlTransient
  public void setTeamRole(@Nullable Boolean teamRole) {
    this.teamRole = teamRole;
  }

  @XmlTransient
  public void setPermissions(@Nullable Iterable<PermissionJSON> permissions) {
    this.permissions = new ArrayList<PermissionJSON>();
    if (permissions != null) {
      for (PermissionJSON it : permissions) {
        this.permissions.add(it);
      }
    }
  }

  @Override
  public String toString() {
    return append(new StringBuilder()).toString();
  }

  public StringBuilder append(StringBuilder builder) {
    builder.append('{');
    appendFields(builder, true);
    builder.append('}');
    return builder;
  }

  protected boolean appendFields(StringBuilder builder, boolean firstProperty) {
    firstProperty = firstProperty;
    if (this.id != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("id").append("\": ");
      builder.append(this.id);
    }
    if (this.aliasIds != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("aliasIds").append("\": ");
      {
        builder.append('[');
        boolean firstV = true;
        for (String v : this.aliasIds) {
          if (firstV) {
            firstV = false;
          } else {
            builder.append(", ");
          }
          builder.append(v);
        }
        builder.append(']');
      }
    }
    if (this.url != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("url").append("\": ");
      builder.append(this.url);
    }
    if (this.key != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("key").append("\": ");
      builder.append(this.key);
    }
    if (this.name != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("name").append("\": ");
      builder.append(this.name);
    }
    if (this.description != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("description").append("\": ");
      builder.append(this.description);
    }
    if (this.teamRole != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("teamRole").append("\": ");
      builder.append(this.teamRole);
    }
    if (this.permissions != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("permissions").append("\": ");
      {
        builder.append('[');
        boolean firstV = true;
        for (PermissionJSON v : this.permissions) {
          if (firstV) {
            firstV = false;
          } else {
            builder.append(", ");
          }
          v.append(builder);

        }
        builder.append(']');
      }
    }
    return firstProperty;
  }
}
