package jetbrains.jetpass.rest.dto;

/*Generated by MPS */

import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAccessType;
import com.fasterxml.jackson.annotation.JsonTypeInfo;
import com.fasterxml.jackson.annotation.JsonTypeName;
import jetbrains.jetpass.api.Service;
import javax.xml.bind.annotation.XmlElement;
import java.util.List;
import org.jetbrains.annotations.NotNull;
import java.util.ArrayList;
import jetbrains.jetpass.api.security.SpaceRole;
import jetbrains.jetpass.api.security.ProjectRole;
import jetbrains.jetpass.api.security.Resource;
import jetbrains.jetpass.api.security.Permission;
import jetbrains.jetpass.api.security.Role;
import jetbrains.jetpass.api.authority.UserGroup;
import jetbrains.jetpass.api.ServiceAPI;
import org.jetbrains.annotations.Nullable;
import javax.xml.bind.annotation.XmlTransient;

@XmlRootElement(name = "service")
@XmlAccessorType(value = XmlAccessType.FIELD)
@JsonTypeInfo(use = JsonTypeInfo.Id.NAME, include = JsonTypeInfo.As.PROPERTY, property = "type", defaultImpl = ServiceJSON.class)
@JsonTypeName(value = "service")
public class ServiceJSON extends AuthorityHolderJSON implements Service {
  @XmlElement(name = "key")
  private String key;
  @XmlElement(name = "homeUrl")
  private String homeUrl;
  @XmlElement(name = "userUriPattern")
  private String userUriPattern;
  @XmlElement(name = "groupUriPattern")
  private String groupUriPattern;
  @XmlElement(name = "redirectUris")
  private List<String> redirectUris;
  @XmlElement(name = "applicationName")
  private String applicationName;
  @XmlElement(name = "vendor")
  private String vendor;
  @XmlElement(name = "version")
  private String version;
  @XmlElement(name = "iconUrl")
  private String iconUrl;
  @XmlElement(name = "resources")
  private List<ResourceJSON> resources;
  @XmlElement(name = "permissions")
  private List<PermissionJSON> permissions;
  @XmlElement(name = "defaultRoles")
  private List<RoleJSON> defaultRoles;
  @XmlElement(name = "headerVisibleGroups")
  private List<UserGroupJSON> headerVisibleGroups;
  @XmlElement(name = "licenseSettings")
  private LicenseJSON licenseSettings;
  @XmlElement(name = "apis")
  private List<ServiceAPIJSON> apis;
  @XmlElement(name = "verified")
  private Boolean verified;
  @XmlElement(name = "trusted")
  private Boolean trusted;
  @XmlElement(name = "secret")
  private String secret;

  public ServiceJSON() {
  }

  public ServiceJSON(@NotNull Service that) {
    this.setId(that.getId());
    this.setAliasIds(that.getAliasIds());
    this.setName(that.getName());
    if (that.getRoles() != null) {
      List<SpaceRoleJSON> aggregated = new ArrayList<SpaceRoleJSON>();
      for (SpaceRole it : that.getRoles()) {
        aggregated.add(new SpaceRoleJSON(it));
      }
      this.setRoles(aggregated);
    }
    if (that.getProjectRoles() != null) {
      List<ProjectRoleJSON> aggregated = new ArrayList<ProjectRoleJSON>();
      for (ProjectRole it : that.getProjectRoles()) {
        aggregated.add(new ProjectRoleJSON(it));
      }
      this.setProjectRoles(aggregated);
    }
    this.setKey(that.getKey());
    this.setHomeUrl(that.getHomeUrl());
    this.setUserUriPattern(that.getUserUriPattern());
    this.setGroupUriPattern(that.getGroupUriPattern());
    this.setRedirectUris(that.getRedirectUris());
    this.setApplicationName(that.getApplicationName());
    this.setVendor(that.getVendor());
    this.setVersion(that.getVersion());
    this.setIconUrl(that.getIconUrl());
    if (that.getResources() != null) {
      List<ResourceJSON> aggregated = new ArrayList<ResourceJSON>();
      for (Resource it : that.getResources()) {
        aggregated.add(new ResourceJSON(it));
      }
      this.setResources(aggregated);
    }
    if (that.getPermissions() != null) {
      List<PermissionJSON> aggregated = new ArrayList<PermissionJSON>();
      for (Permission it : that.getPermissions()) {
        aggregated.add(new PermissionJSON(it));
      }
      this.setPermissions(aggregated);
    }
    if (that.getDefaultRoles() != null) {
      List<RoleJSON> aggregated = new ArrayList<RoleJSON>();
      for (Role it : that.getDefaultRoles()) {
        aggregated.add(new RoleJSON(it));
      }
      this.setDefaultRoles(aggregated);
    }
    if (that.getHeaderVisibleGroups() != null) {
      List<UserGroupJSON> references = new ArrayList<UserGroupJSON>();
      for (UserGroup it : that.getHeaderVisibleGroups()) {
        UserGroupJSON ref = new UserGroupJSON();
        ref.setId(it.getId());
        references.add(ref);
      }
      this.setHeaderVisibleGroups(references);
    }
    if (that.getLicenseSettings() != null) {
      // Shallow reference 
      LicenseJSON ref = new LicenseJSON();
      ref.setId(that.getLicenseSettings().getId());
      this.setLicenseSettings(ref);
    }
    if (that.getApis() != null) {
      List<ServiceAPIJSON> references = new ArrayList<ServiceAPIJSON>();
      for (ServiceAPI it : that.getApis()) {
        ServiceAPIJSON ref = new ServiceAPIJSON();
        ref.setId(it.getId());
        references.add(ref);
      }
      this.setApis(references);
    }
    this.setVerified(that.isVerified());
    this.setTrusted(that.isTrusted());
    this.setSecret(that.getSecret());
  }

  @Nullable
  public String getKey() {
    return this.key;
  }

  @Nullable
  public String getHomeUrl() {
    return this.homeUrl;
  }

  @Nullable
  public String getUserUriPattern() {
    return this.userUriPattern;
  }

  @Nullable
  public String getGroupUriPattern() {
    return this.groupUriPattern;
  }

  @Nullable
  public Iterable<String> getRedirectUris() {
    return this.redirectUris;
  }

  @Nullable
  public String getApplicationName() {
    return this.applicationName;
  }

  @Nullable
  public String getVendor() {
    return this.vendor;
  }

  @Nullable
  public String getVersion() {
    return this.version;
  }

  @Nullable
  public String getIconUrl() {
    return this.iconUrl;
  }

  @Nullable
  public Iterable<ResourceJSON> getResources() {
    return this.resources;
  }

  @Nullable
  public Iterable<PermissionJSON> getPermissions() {
    return this.permissions;
  }

  @Nullable
  public Iterable<RoleJSON> getDefaultRoles() {
    return this.defaultRoles;
  }

  @Nullable
  public Iterable<UserGroupJSON> getHeaderVisibleGroups() {
    return this.headerVisibleGroups;
  }

  @Nullable
  public LicenseJSON getLicenseSettings() {
    return this.licenseSettings;
  }

  @Nullable
  public Iterable<ServiceAPIJSON> getApis() {
    return this.apis;
  }

  @Nullable
  @Deprecated
  public Boolean isVerified() {
    return this.verified;
  }

  @Nullable
  public Boolean isTrusted() {
    return this.trusted;
  }

  @Nullable
  public String getSecret() {
    return this.secret;
  }

  @XmlTransient
  public void setKey(@Nullable String key) {
    this.key = key;
  }

  @XmlTransient
  public void setHomeUrl(@Nullable String homeUrl) {
    this.homeUrl = homeUrl;
  }

  @XmlTransient
  public void setUserUriPattern(@Nullable String userUriPattern) {
    this.userUriPattern = userUriPattern;
  }

  @XmlTransient
  public void setGroupUriPattern(@Nullable String groupUriPattern) {
    this.groupUriPattern = groupUriPattern;
  }

  @XmlTransient
  public void setRedirectUris(@Nullable Iterable<String> redirectUris) {
    this.redirectUris = new ArrayList<String>();
    if (redirectUris != null) {
      for (String it : redirectUris) {
        this.redirectUris.add(it);
      }
    }
  }

  @XmlTransient
  public void setApplicationName(@Nullable String applicationName) {
    this.applicationName = applicationName;
  }

  @XmlTransient
  public void setVendor(@Nullable String vendor) {
    this.vendor = vendor;
  }

  @XmlTransient
  public void setVersion(@Nullable String version) {
    this.version = version;
  }

  @XmlTransient
  public void setIconUrl(@Nullable String iconUrl) {
    this.iconUrl = iconUrl;
  }

  @XmlTransient
  public void setResources(@Nullable Iterable<ResourceJSON> resources) {
    this.resources = new ArrayList<ResourceJSON>();
    if (resources != null) {
      for (ResourceJSON it : resources) {
        this.resources.add(it);
      }
    }
  }

  @XmlTransient
  public void setPermissions(@Nullable Iterable<PermissionJSON> permissions) {
    this.permissions = new ArrayList<PermissionJSON>();
    if (permissions != null) {
      for (PermissionJSON it : permissions) {
        this.permissions.add(it);
      }
    }
  }

  @XmlTransient
  public void setDefaultRoles(@Nullable Iterable<RoleJSON> defaultRoles) {
    this.defaultRoles = new ArrayList<RoleJSON>();
    if (defaultRoles != null) {
      for (RoleJSON it : defaultRoles) {
        this.defaultRoles.add(it);
      }
    }
  }

  @XmlTransient
  public void setHeaderVisibleGroups(@Nullable Iterable<UserGroupJSON> headerVisibleGroups) {
    this.headerVisibleGroups = new ArrayList<UserGroupJSON>();
    if (headerVisibleGroups != null) {
      for (UserGroupJSON it : headerVisibleGroups) {
        this.headerVisibleGroups.add(it);
      }
    }
  }

  @XmlTransient
  public void setLicenseSettings(@Nullable LicenseJSON licenseSettings) {
    this.licenseSettings = licenseSettings;
  }

  @XmlTransient
  public void setApis(@Nullable Iterable<ServiceAPIJSON> apis) {
    this.apis = new ArrayList<ServiceAPIJSON>();
    if (apis != null) {
      for (ServiceAPIJSON it : apis) {
        this.apis.add(it);
      }
    }
  }

  @XmlTransient
  @Deprecated
  public void setVerified(@Nullable Boolean verified) {
    this.verified = verified;
  }

  @XmlTransient
  public void setTrusted(@Nullable Boolean trusted) {
    this.trusted = trusted;
  }

  @XmlTransient
  public void setSecret(@Nullable String secret) {
    this.secret = secret;
  }

  @Override
  public String toString() {
    return append(new StringBuilder()).toString();
  }

  public StringBuilder append(StringBuilder builder) {
    builder.append('{');
    appendFields(builder, true);
    builder.append('}');
    return builder;
  }

  protected boolean appendFields(StringBuilder builder, boolean firstProperty) {
    firstProperty = super.appendFields(builder, firstProperty);
    if (this.key != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("key").append("\": ");
      builder.append(this.key);
    }
    if (this.homeUrl != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("homeUrl").append("\": ");
      builder.append(this.homeUrl);
    }
    if (this.userUriPattern != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("userUriPattern").append("\": ");
      builder.append(this.userUriPattern);
    }
    if (this.groupUriPattern != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("groupUriPattern").append("\": ");
      builder.append(this.groupUriPattern);
    }
    if (this.redirectUris != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("redirectUris").append("\": ");
      {
        builder.append('[');
        boolean firstV = true;
        for (String v : this.redirectUris) {
          if (firstV) {
            firstV = false;
          } else {
            builder.append(", ");
          }
          builder.append(v);
        }
        builder.append(']');
      }
    }
    if (this.applicationName != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("applicationName").append("\": ");
      builder.append(this.applicationName);
    }
    if (this.vendor != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("vendor").append("\": ");
      builder.append(this.vendor);
    }
    if (this.version != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("version").append("\": ");
      builder.append(this.version);
    }
    if (this.iconUrl != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("iconUrl").append("\": ");
      builder.append(this.iconUrl);
    }
    if (this.resources != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("resources").append("\": ");
      {
        builder.append('[');
        boolean firstV = true;
        for (ResourceJSON v : this.resources) {
          if (firstV) {
            firstV = false;
          } else {
            builder.append(", ");
          }
          v.append(builder);

        }
        builder.append(']');
      }
    }
    if (this.permissions != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("permissions").append("\": ");
      {
        builder.append('[');
        boolean firstV = true;
        for (PermissionJSON v : this.permissions) {
          if (firstV) {
            firstV = false;
          } else {
            builder.append(", ");
          }
          v.append(builder);

        }
        builder.append(']');
      }
    }
    if (this.defaultRoles != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("defaultRoles").append("\": ");
      {
        builder.append('[');
        boolean firstV = true;
        for (RoleJSON v : this.defaultRoles) {
          if (firstV) {
            firstV = false;
          } else {
            builder.append(", ");
          }
          v.append(builder);

        }
        builder.append(']');
      }
    }
    if (this.headerVisibleGroups != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("headerVisibleGroups").append("\": ");
      {
        builder.append('[');
        boolean firstV = true;
        for (UserGroupJSON v : this.headerVisibleGroups) {
          if (firstV) {
            firstV = false;
          } else {
            builder.append(", ");
          }
          v.append(builder);

        }
        builder.append(']');
      }
    }
    if (this.licenseSettings != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("licenseSettings").append("\": ");
      this.licenseSettings.append(builder);
    }
    if (this.apis != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("apis").append("\": ");
      {
        builder.append('[');
        boolean firstV = true;
        for (ServiceAPIJSON v : this.apis) {
          if (firstV) {
            firstV = false;
          } else {
            builder.append(", ");
          }
          v.append(builder);

        }
        builder.append(']');
      }
    }
    if (this.verified != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("verified").append("\": ");
      builder.append(this.verified);
    }
    if (this.trusted != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("trusted").append("\": ");
      builder.append(this.trusted);
    }
    if (this.secret != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("secret").append("\": ");
      builder.append(this.secret);
    }
    return firstProperty;
  }
}
