package jetbrains.jetpass.rest.dto;

/*Generated by MPS */

import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAccessType;
import com.fasterxml.jackson.annotation.JsonTypeName;
import jetbrains.jetpass.api.settings.SMTPSettings;
import javax.xml.bind.annotation.XmlElement;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;
import javax.xml.bind.annotation.XmlTransient;

@XmlRootElement(name = "smtpSettings")
@XmlAccessorType(value = XmlAccessType.FIELD)
@JsonTypeName(value = "smtp")
public class SmtpSettingsJSON extends SettingsJSON implements SMTPSettings {
  @XmlElement(name = "enabled")
  private Boolean enabled;
  @XmlElement(name = "host")
  private String host;
  @XmlElement(name = "port")
  private Integer port;
  @XmlElement(name = "protocol")
  private String protocol;
  @XmlElement(name = "from")
  private String from;
  @XmlElement(name = "login")
  private String login;
  @XmlElement(name = "password")
  private String password;
  @XmlElement(name = "passwordDefined")
  private Boolean passwordDefined;
  @XmlElement(name = "keyStore")
  private KeyStoreJSON keyStore;

  public SmtpSettingsJSON() {
  }

  public SmtpSettingsJSON(@NotNull SMTPSettings that) {
    this.setId(that.getId());
    this.setAliasIds(that.getAliasIds());
    this.setEnabled(that.isEnabled());
    this.setHost(that.getHost());
    this.setPort(that.getPort());
    this.setProtocol(that.getProtocol());
    this.setFrom(that.getFrom());
    this.setLogin(that.getLogin());
    this.setPassword(that.getPassword());
    if (that.getKeyStore() != null) {
      // Shallow reference 
      KeyStoreJSON ref = new KeyStoreJSON();
      ref.setId(that.getKeyStore().getId());
      this.setKeyStore(ref);
    }
  }

  @Nullable
  public Boolean isEnabled() {
    return this.enabled;
  }

  @Nullable
  public String getHost() {
    return this.host;
  }

  @Nullable
  public Integer getPort() {
    return this.port;
  }

  @Nullable
  public String getProtocol() {
    return this.protocol;
  }

  @Nullable
  public String getFrom() {
    return this.from;
  }

  @Nullable
  public String getLogin() {
    return this.login;
  }

  @Nullable
  public String getPassword() {
    return this.password;
  }

  @Nullable
  public Boolean isPasswordDefined() {
    return this.passwordDefined;
  }

  @Nullable
  public KeyStoreJSON getKeyStore() {
    return this.keyStore;
  }

  @XmlTransient
  public void setEnabled(@Nullable Boolean enabled) {
    this.enabled = enabled;
  }

  @XmlTransient
  public void setHost(@Nullable String host) {
    this.host = host;
  }

  @XmlTransient
  public void setPort(@Nullable Integer port) {
    this.port = port;
  }

  @XmlTransient
  public void setProtocol(@Nullable String protocol) {
    this.protocol = protocol;
  }

  @XmlTransient
  public void setFrom(@Nullable String from) {
    this.from = from;
  }

  @XmlTransient
  public void setLogin(@Nullable String login) {
    this.login = login;
  }

  @XmlTransient
  public void setPassword(@Nullable String password) {
    this.password = password;
  }

  @XmlTransient
  public void setPasswordDefined(@Nullable Boolean passwordDefined) {
    this.passwordDefined = passwordDefined;
  }

  @XmlTransient
  public void setKeyStore(@Nullable KeyStoreJSON keyStore) {
    this.keyStore = keyStore;
  }

  @Override
  public String toString() {
    return append(new StringBuilder()).toString();
  }

  public StringBuilder append(StringBuilder builder) {
    builder.append('{');
    appendFields(builder, true);
    builder.append('}');
    return builder;
  }

  protected boolean appendFields(StringBuilder builder, boolean firstProperty) {
    firstProperty = super.appendFields(builder, firstProperty);
    if (this.enabled != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("enabled").append("\": ");
      builder.append(this.enabled);
    }
    if (this.host != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("host").append("\": ");
      builder.append(this.host);
    }
    if (this.port != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("port").append("\": ");
      builder.append(this.port);
    }
    if (this.protocol != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("protocol").append("\": ");
      builder.append(this.protocol);
    }
    if (this.from != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("from").append("\": ");
      builder.append(this.from);
    }
    if (this.login != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("login").append("\": ");
      builder.append(this.login);
    }
    if (this.password != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("password").append("\": ");
      builder.append(this.password);
    }
    if (this.passwordDefined != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("passwordDefined").append("\": ");
      builder.append(this.passwordDefined);
    }
    if (this.keyStore != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("keyStore").append("\": ");
      this.keyStore.append(builder);
    }
    return firstProperty;
  }
}
