package jetbrains.jetpass.rest.dto;

/*Generated by MPS */

import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAccessType;
import jetbrains.jetpass.api.security.Team;
import javax.xml.bind.annotation.XmlElement;
import java.util.List;
import org.jetbrains.annotations.NotNull;
import java.util.ArrayList;
import jetbrains.jetpass.api.authority.User;
import jetbrains.jetpass.api.authority.UserGroup;
import org.jetbrains.annotations.Nullable;
import javax.xml.bind.annotation.XmlTransient;

@XmlRootElement(name = "team")
@XmlAccessorType(value = XmlAccessType.FIELD)
public class TeamJSON implements Team {
  @XmlElement(name = "role")
  private RoleJSON role;
  @XmlElement(name = "users")
  private List<UserJSON> users;
  @XmlElement(name = "usersTotal")
  private Integer usersTotal;
  @XmlElement(name = "groups")
  private List<UserGroupJSON> groups;
  @XmlElement(name = "groupsTotal")
  private Integer groupsTotal;

  public TeamJSON() {
  }

  public TeamJSON(@NotNull Team that) {
    if (that.getRole() != null) {
      // Shallow reference 
      RoleJSON ref = new RoleJSON();
      ref.setId(that.getRole().getId());
      this.setRole(ref);
    }
    if (that.getUsers() != null) {
      List<UserJSON> references = new ArrayList<UserJSON>();
      for (User it : that.getUsers()) {
        UserJSON ref = new UserJSON();
        ref.setId(it.getId());
        references.add(ref);
      }
      this.setUsers(references);
    }
    if (that.getGroups() != null) {
      List<UserGroupJSON> references = new ArrayList<UserGroupJSON>();
      for (UserGroup it : that.getGroups()) {
        UserGroupJSON ref = new UserGroupJSON();
        ref.setId(it.getId());
        references.add(ref);
      }
      this.setGroups(references);
    }
  }

  @Nullable
  public RoleJSON getRole() {
    return this.role;
  }

  @Nullable
  public Iterable<UserJSON> getUsers() {
    return this.users;
  }

  @Nullable
  public Integer getUsersTotal() {
    return this.usersTotal;
  }

  @Nullable
  public Iterable<UserGroupJSON> getGroups() {
    return this.groups;
  }

  @Nullable
  public Integer getGroupsTotal() {
    return this.groupsTotal;
  }

  @XmlTransient
  public void setRole(@Nullable RoleJSON role) {
    this.role = role;
  }

  @XmlTransient
  public void setUsers(@Nullable Iterable<UserJSON> users) {
    this.users = new ArrayList<UserJSON>();
    if (users != null) {
      for (UserJSON it : users) {
        this.users.add(it);
      }
    }
  }

  @XmlTransient
  public void setUsersTotal(@Nullable Integer usersTotal) {
    this.usersTotal = usersTotal;
  }

  @XmlTransient
  public void setGroups(@Nullable Iterable<UserGroupJSON> groups) {
    this.groups = new ArrayList<UserGroupJSON>();
    if (groups != null) {
      for (UserGroupJSON it : groups) {
        this.groups.add(it);
      }
    }
  }

  @XmlTransient
  public void setGroupsTotal(@Nullable Integer groupsTotal) {
    this.groupsTotal = groupsTotal;
  }

  @Override
  public String toString() {
    return append(new StringBuilder()).toString();
  }

  public StringBuilder append(StringBuilder builder) {
    builder.append('{');
    appendFields(builder, true);
    builder.append('}');
    return builder;
  }

  protected boolean appendFields(StringBuilder builder, boolean firstProperty) {
    firstProperty = firstProperty;
    if (this.role != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("role").append("\": ");
      this.role.append(builder);
    }
    if (this.users != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("users").append("\": ");
      {
        builder.append('[');
        boolean firstV = true;
        for (UserJSON v : this.users) {
          if (firstV) {
            firstV = false;
          } else {
            builder.append(", ");
          }
          v.append(builder);

        }
        builder.append(']');
      }
    }
    if (this.usersTotal != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("usersTotal").append("\": ");
      builder.append(this.usersTotal);
    }
    if (this.groups != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("groups").append("\": ");
      {
        builder.append('[');
        boolean firstV = true;
        for (UserGroupJSON v : this.groups) {
          if (firstV) {
            firstV = false;
          } else {
            builder.append(", ");
          }
          v.append(builder);

        }
        builder.append(']');
      }
    }
    if (this.groupsTotal != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("groupsTotal").append("\": ");
      builder.append(this.groupsTotal);
    }
    return firstProperty;
  }
}
