package jetbrains.jetpass.rest.dto;

/*Generated by MPS */

import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAccessType;
import com.fasterxml.jackson.annotation.JsonTypeInfo;
import com.fasterxml.jackson.annotation.JsonTypeName;
import jetbrains.jetpass.api.authority.UserGroup;
import javax.xml.bind.annotation.XmlElement;
import java.util.List;
import org.jetbrains.annotations.NotNull;
import java.util.ArrayList;
import jetbrains.jetpass.api.security.SpaceRole;
import jetbrains.jetpass.api.security.ProjectRole;
import jetbrains.jetpass.api.authority.User;
import org.jetbrains.annotations.Nullable;
import javax.xml.bind.annotation.XmlTransient;

@XmlRootElement(name = "userGroup")
@XmlAccessorType(value = XmlAccessType.FIELD)
@JsonTypeInfo(use = JsonTypeInfo.Id.NAME, include = JsonTypeInfo.As.PROPERTY, property = "type", defaultImpl = UserGroupJSON.class)
@JsonTypeName(value = "userGroup")
public class UserGroupJSON extends AuthorityHolderJSON implements UserGroup {
  @XmlElement(name = "description")
  private String description;
  @XmlElement(name = "iconUrl")
  private String iconUrl;
  @XmlElement(name = "autoJoin")
  private Boolean autoJoin;
  @XmlElement(name = "users")
  private List<UserJSON> users;
  @XmlElement(name = "ownUsers")
  private List<UserJSON> ownUsers;
  @XmlElement(name = "userCount")
  private Integer userCount;
  @XmlElement(name = "parent")
  private UserGroupJSON parent;
  @XmlElement(name = "subgroups")
  private List<UserGroupJSON> subgroups;
  @XmlElement(name = "space")
  private SpaceJSON space;
  @XmlElement(name = "project")
  private ProjectJSON project;
  @XmlElement(name = "allUsers")
  private Boolean allUsers;
  @XmlElement(name = "implicit")
  private Boolean implicit;
  @XmlElement(name = "queriedSingleton")
  private Boolean queriedSingleton;

  public UserGroupJSON() {
  }

  public UserGroupJSON(@NotNull UserGroup that) {
    this.setId(that.getId());
    this.setAliasIds(that.getAliasIds());
    this.setName(that.getName());
    if (that.getRoles() != null) {
      List<SpaceRoleJSON> aggregated = new ArrayList<SpaceRoleJSON>();
      for (SpaceRole it : that.getRoles()) {
        aggregated.add(new SpaceRoleJSON(it));
      }
      this.setRoles(aggregated);
    }
    if (that.getProjectRoles() != null) {
      List<ProjectRoleJSON> aggregated = new ArrayList<ProjectRoleJSON>();
      for (ProjectRole it : that.getProjectRoles()) {
        aggregated.add(new ProjectRoleJSON(it));
      }
      this.setProjectRoles(aggregated);
    }
    this.setDescription(that.getDescription());
    this.setIconUrl(that.getIconUrl());
    this.setAutoJoin(that.isAutoJoin());
    if (that.getUsers() != null) {
      List<UserJSON> references = new ArrayList<UserJSON>();
      for (User it : that.getUsers()) {
        UserJSON ref = new UserJSON();
        ref.setId(it.getId());
        references.add(ref);
      }
      this.setUsers(references);
    }
    if (that.getOwnUsers() != null) {
      List<UserJSON> references = new ArrayList<UserJSON>();
      for (User it : that.getOwnUsers()) {
        UserJSON ref = new UserJSON();
        ref.setId(it.getId());
        references.add(ref);
      }
      this.setOwnUsers(references);
    }
    this.setUserCount(that.getUserCount());
    if (that.getParent() != null) {
      // Shallow reference 
      UserGroupJSON ref = new UserGroupJSON();
      ref.setId(that.getParent().getId());
      this.setParent(ref);
    }
    if (that.getSubgroups() != null) {
      List<UserGroupJSON> aggregated = new ArrayList<UserGroupJSON>();
      for (UserGroup it : that.getSubgroups()) {
        aggregated.add(new UserGroupJSON(it));
      }
      this.setSubgroups(aggregated);
    }
    if (that.getSpace() != null) {
      // Shallow reference 
      SpaceJSON ref = new SpaceJSON();
      ref.setId(that.getSpace().getId());
      this.setSpace(ref);
    }
    if (that.getProject() != null) {
      // Shallow reference 
      ProjectJSON ref = new ProjectJSON();
      ref.setId(that.getProject().getId());
      this.setProject(ref);
    }
    this.setAllUsers(that.isAllUsers());
  }

  @Nullable
  public String getDescription() {
    return this.description;
  }

  @Nullable
  public String getIconUrl() {
    return this.iconUrl;
  }

  @Nullable
  public Boolean isAutoJoin() {
    return this.autoJoin;
  }

  @Nullable
  public Iterable<UserJSON> getUsers() {
    return this.users;
  }

  @Nullable
  public Iterable<UserJSON> getOwnUsers() {
    return this.ownUsers;
  }

  @Nullable
  public Integer getUserCount() {
    return this.userCount;
  }

  @Nullable
  public UserGroupJSON getParent() {
    return this.parent;
  }

  @Nullable
  public Iterable<UserGroupJSON> getSubgroups() {
    return this.subgroups;
  }

  @Nullable
  @Deprecated
  public SpaceJSON getSpace() {
    return this.space;
  }

  @Nullable
  public ProjectJSON getProject() {
    return this.project;
  }

  @Nullable
  public Boolean isAllUsers() {
    return this.allUsers;
  }

  @Nullable
  public Boolean isImplicit() {
    return this.implicit;
  }

  @Nullable
  public Boolean isQueriedSingleton() {
    return this.queriedSingleton;
  }

  @XmlTransient
  public void setDescription(@Nullable String description) {
    this.description = description;
  }

  @XmlTransient
  public void setIconUrl(@Nullable String iconUrl) {
    this.iconUrl = iconUrl;
  }

  @XmlTransient
  public void setAutoJoin(@Nullable Boolean autoJoin) {
    this.autoJoin = autoJoin;
  }

  @XmlTransient
  public void setUsers(@Nullable Iterable<UserJSON> users) {
    this.users = new ArrayList<UserJSON>();
    if (users != null) {
      for (UserJSON it : users) {
        this.users.add(it);
      }
    }
  }

  @XmlTransient
  public void setOwnUsers(@Nullable Iterable<UserJSON> ownUsers) {
    this.ownUsers = new ArrayList<UserJSON>();
    if (ownUsers != null) {
      for (UserJSON it : ownUsers) {
        this.ownUsers.add(it);
      }
    }
  }

  @XmlTransient
  public void setUserCount(@Nullable Integer userCount) {
    this.userCount = userCount;
  }

  @XmlTransient
  public void setParent(@Nullable UserGroupJSON parent) {
    this.parent = parent;
  }

  @XmlTransient
  public void setSubgroups(@Nullable Iterable<UserGroupJSON> subgroups) {
    this.subgroups = new ArrayList<UserGroupJSON>();
    if (subgroups != null) {
      for (UserGroupJSON it : subgroups) {
        this.subgroups.add(it);
      }
    }
  }

  @XmlTransient
  @Deprecated
  public void setSpace(@Nullable SpaceJSON space) {
    this.space = space;
  }

  @XmlTransient
  public void setProject(@Nullable ProjectJSON project) {
    this.project = project;
  }

  @XmlTransient
  public void setAllUsers(@Nullable Boolean allUsers) {
    this.allUsers = allUsers;
  }

  @XmlTransient
  public void setImplicit(@Nullable Boolean implicit) {
    this.implicit = implicit;
  }

  @XmlTransient
  public void setQueriedSingleton(@Nullable Boolean queriedSingleton) {
    this.queriedSingleton = queriedSingleton;
  }

  @Override
  public String toString() {
    return append(new StringBuilder()).toString();
  }

  public StringBuilder append(StringBuilder builder) {
    builder.append('{');
    appendFields(builder, true);
    builder.append('}');
    return builder;
  }

  protected boolean appendFields(StringBuilder builder, boolean firstProperty) {
    firstProperty = super.appendFields(builder, firstProperty);
    if (this.description != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("description").append("\": ");
      builder.append(this.description);
    }
    if (this.iconUrl != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("iconUrl").append("\": ");
      builder.append(this.iconUrl);
    }
    if (this.autoJoin != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("autoJoin").append("\": ");
      builder.append(this.autoJoin);
    }
    if (this.users != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("users").append("\": ");
      {
        builder.append('[');
        boolean firstV = true;
        for (UserJSON v : this.users) {
          if (firstV) {
            firstV = false;
          } else {
            builder.append(", ");
          }
          v.append(builder);

        }
        builder.append(']');
      }
    }
    if (this.ownUsers != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("ownUsers").append("\": ");
      {
        builder.append('[');
        boolean firstV = true;
        for (UserJSON v : this.ownUsers) {
          if (firstV) {
            firstV = false;
          } else {
            builder.append(", ");
          }
          v.append(builder);

        }
        builder.append(']');
      }
    }
    if (this.userCount != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("userCount").append("\": ");
      builder.append(this.userCount);
    }
    if (this.parent != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("parent").append("\": ");
      this.parent.append(builder);
    }
    if (this.subgroups != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("subgroups").append("\": ");
      {
        builder.append('[');
        boolean firstV = true;
        for (UserGroupJSON v : this.subgroups) {
          if (firstV) {
            firstV = false;
          } else {
            builder.append(", ");
          }
          v.append(builder);

        }
        builder.append(']');
      }
    }
    if (this.space != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("space").append("\": ");
      this.space.append(builder);
    }
    if (this.project != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("project").append("\": ");
      this.project.append(builder);
    }
    if (this.allUsers != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("allUsers").append("\": ");
      builder.append(this.allUsers);
    }
    if (this.implicit != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("implicit").append("\": ");
      builder.append(this.implicit);
    }
    if (this.queriedSingleton != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("queriedSingleton").append("\": ");
      builder.append(this.queriedSingleton);
    }
    return firstProperty;
  }
}
