package jetbrains.jetpass.rest.dto;

/*Generated by MPS */

import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAccessType;
import com.fasterxml.jackson.annotation.JsonTypeInfo;
import com.fasterxml.jackson.annotation.JsonTypeName;
import jetbrains.jetpass.api.authority.User;
import javax.xml.bind.annotation.XmlElement;
import java.util.List;
import java.util.Calendar;
import org.jetbrains.annotations.NotNull;
import java.util.ArrayList;
import jetbrains.jetpass.api.security.SpaceRole;
import jetbrains.jetpass.api.security.ProjectRole;
import jetbrains.jetpass.api.authority.UserGroup;
import jetbrains.jetpass.api.authority.details.UserDetails;
import jetbrains.jetpass.api.authority.VCSUserName;
import org.jetbrains.annotations.Nullable;
import javax.xml.bind.annotation.XmlTransient;

@XmlRootElement(name = "user")
@XmlAccessorType(value = XmlAccessType.FIELD)
@JsonTypeInfo(use = JsonTypeInfo.Id.NAME, include = JsonTypeInfo.As.PROPERTY, property = "type", defaultImpl = UserJSON.class)
@JsonTypeName(value = "user")
public class UserJSON extends AuthorityHolderJSON implements User {
  @XmlElement(name = "login")
  private String login;
  @XmlElement(name = "banned")
  private Boolean banned;
  @XmlElement(name = "guest")
  private Boolean guest;
  @XmlElement(name = "avatar")
  private AvatarJSON avatar;
  @XmlElement(name = "profile")
  private ProfileJSON profile;
  @XmlElement(name = "contacts")
  private List<ContactJSON> contacts;
  @XmlElement(name = "groups")
  private List<UserGroupJSON> groups;
  @XmlElement(name = "details")
  private List<DetailsJSON> details;
  @XmlElement(name = "VCSUserNames")
  private List<VcsUserNameJSON> VCSUserNames;
  @XmlElement(name = "sshPublicKeys")
  private List<SshPublicKeyJSON> sshPublicKeys;
  @XmlElement(name = "creationTime")
  private Calendar creationTime;

  public UserJSON() {
  }

  public UserJSON(@NotNull User that) {
    this.setId(that.getId());
    this.setAliasIds(that.getAliasIds());
    this.setName(that.getName());
    if (that.getRoles() != null) {
      List<SpaceRoleJSON> aggregated = new ArrayList<SpaceRoleJSON>();
      for (SpaceRole it : that.getRoles()) {
        aggregated.add(new SpaceRoleJSON(it));
      }
      this.setRoles(aggregated);
    }
    if (that.getProjectRoles() != null) {
      List<ProjectRoleJSON> aggregated = new ArrayList<ProjectRoleJSON>();
      for (ProjectRole it : that.getProjectRoles()) {
        aggregated.add(new ProjectRoleJSON(it));
      }
      this.setProjectRoles(aggregated);
    }
    this.setLogin(that.getLogin());
    this.setBanned(that.isBanned());
    this.setGuest(that.isGuest());
    if (that.getAvatar() != null) {
      this.setAvatar(new AvatarJSON(that.getAvatar()));
    }
    if (that.getProfile() != null) {
      this.setProfile(new ProfileJSON(that.getProfile()));
    }
    if (that.getGroups() != null) {
      List<UserGroupJSON> references = new ArrayList<UserGroupJSON>();
      for (UserGroup it : that.getGroups()) {
        UserGroupJSON ref = new UserGroupJSON();
        ref.setId(it.getId());
        references.add(ref);
      }
      this.setGroups(references);
    }
    if (that.getDetails() != null) {
      List<DetailsJSON> aggregated = new ArrayList<DetailsJSON>();
      for (UserDetails it : that.getDetails()) {
        aggregated.add(new DetailsJSON(it));
      }
      this.setDetails(aggregated);
    }
    if (that.getVCSUserNames() != null) {
      List<VcsUserNameJSON> aggregated = new ArrayList<VcsUserNameJSON>();
      for (VCSUserName it : that.getVCSUserNames()) {
        aggregated.add(new VcsUserNameJSON(it));
      }
      this.setVCSUserNames(aggregated);
    }
    this.setCreationTime(that.getCreationTime());
  }

  @Nullable
  public String getLogin() {
    return this.login;
  }

  @Nullable
  public Boolean isBanned() {
    return this.banned;
  }

  @Nullable
  public Boolean isGuest() {
    return this.guest;
  }

  @Nullable
  public AvatarJSON getAvatar() {
    return this.avatar;
  }

  @Nullable
  public ProfileJSON getProfile() {
    return this.profile;
  }

  @Nullable
  public Iterable<ContactJSON> getContacts() {
    return this.contacts;
  }

  @Nullable
  public Iterable<UserGroupJSON> getGroups() {
    return this.groups;
  }

  @Nullable
  public Iterable<DetailsJSON> getDetails() {
    return this.details;
  }

  @Nullable
  public Iterable<VcsUserNameJSON> getVCSUserNames() {
    return this.VCSUserNames;
  }

  @Nullable
  public Iterable<SshPublicKeyJSON> getSshPublicKeys() {
    return this.sshPublicKeys;
  }

  @Nullable
  public Calendar getCreationTime() {
    return this.creationTime;
  }

  @XmlTransient
  public void setLogin(@Nullable String login) {
    this.login = login;
  }

  @XmlTransient
  public void setBanned(@Nullable Boolean banned) {
    this.banned = banned;
  }

  @XmlTransient
  public void setGuest(@Nullable Boolean guest) {
    this.guest = guest;
  }

  @XmlTransient
  public void setAvatar(@Nullable AvatarJSON avatar) {
    this.avatar = avatar;
  }

  @XmlTransient
  public void setProfile(@Nullable ProfileJSON profile) {
    this.profile = profile;
  }

  @XmlTransient
  public void setContacts(@Nullable Iterable<ContactJSON> contacts) {
    this.contacts = new ArrayList<ContactJSON>();
    if (contacts != null) {
      for (ContactJSON it : contacts) {
        this.contacts.add(it);
      }
    }
  }

  @XmlTransient
  public void setGroups(@Nullable Iterable<UserGroupJSON> groups) {
    this.groups = new ArrayList<UserGroupJSON>();
    if (groups != null) {
      for (UserGroupJSON it : groups) {
        this.groups.add(it);
      }
    }
  }

  @XmlTransient
  public void setDetails(@Nullable Iterable<DetailsJSON> details) {
    this.details = new ArrayList<DetailsJSON>();
    if (details != null) {
      for (DetailsJSON it : details) {
        this.details.add(it);
      }
    }
  }

  @XmlTransient
  public void setVCSUserNames(@Nullable Iterable<VcsUserNameJSON> VCSUserNames) {
    this.VCSUserNames = new ArrayList<VcsUserNameJSON>();
    if (VCSUserNames != null) {
      for (VcsUserNameJSON it : VCSUserNames) {
        this.VCSUserNames.add(it);
      }
    }
  }

  @XmlTransient
  public void setSshPublicKeys(@Nullable Iterable<SshPublicKeyJSON> sshPublicKeys) {
    this.sshPublicKeys = new ArrayList<SshPublicKeyJSON>();
    if (sshPublicKeys != null) {
      for (SshPublicKeyJSON it : sshPublicKeys) {
        this.sshPublicKeys.add(it);
      }
    }
  }

  @XmlTransient
  public void setCreationTime(@Nullable Calendar creationTime) {
    this.creationTime = creationTime;
  }

  @Override
  public String toString() {
    return append(new StringBuilder()).toString();
  }

  public StringBuilder append(StringBuilder builder) {
    builder.append('{');
    appendFields(builder, true);
    builder.append('}');
    return builder;
  }

  protected boolean appendFields(StringBuilder builder, boolean firstProperty) {
    firstProperty = super.appendFields(builder, firstProperty);
    if (this.login != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("login").append("\": ");
      builder.append(this.login);
    }
    if (this.banned != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("banned").append("\": ");
      builder.append(this.banned);
    }
    if (this.guest != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("guest").append("\": ");
      builder.append(this.guest);
    }
    if (this.avatar != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("avatar").append("\": ");
      this.avatar.append(builder);
    }
    if (this.profile != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("profile").append("\": ");
      this.profile.append(builder);
    }
    if (this.contacts != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("contacts").append("\": ");
      {
        builder.append('[');
        boolean firstV = true;
        for (ContactJSON v : this.contacts) {
          if (firstV) {
            firstV = false;
          } else {
            builder.append(", ");
          }
          v.append(builder);

        }
        builder.append(']');
      }
    }
    if (this.groups != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("groups").append("\": ");
      {
        builder.append('[');
        boolean firstV = true;
        for (UserGroupJSON v : this.groups) {
          if (firstV) {
            firstV = false;
          } else {
            builder.append(", ");
          }
          v.append(builder);

        }
        builder.append(']');
      }
    }
    if (this.details != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("details").append("\": ");
      {
        builder.append('[');
        boolean firstV = true;
        for (DetailsJSON v : this.details) {
          if (firstV) {
            firstV = false;
          } else {
            builder.append(", ");
          }
          v.append(builder);

        }
        builder.append(']');
      }
    }
    if (this.VCSUserNames != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("VCSUserNames").append("\": ");
      {
        builder.append('[');
        boolean firstV = true;
        for (VcsUserNameJSON v : this.VCSUserNames) {
          if (firstV) {
            firstV = false;
          } else {
            builder.append(", ");
          }
          v.append(builder);

        }
        builder.append(']');
      }
    }
    if (this.sshPublicKeys != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("sshPublicKeys").append("\": ");
      {
        builder.append('[');
        boolean firstV = true;
        for (SshPublicKeyJSON v : this.sshPublicKeys) {
          if (firstV) {
            firstV = false;
          } else {
            builder.append(", ");
          }
          v.append(builder);

        }
        builder.append(']');
      }
    }
    if (this.creationTime != null) {
      if (firstProperty) {
        firstProperty = false;
      } else {
        builder.append(", ");
      }
      builder.append('"').append("creationTime").append("\": ");
      builder.append(this.creationTime);
    }
    return firstProperty;
  }
}
