package jetbrains.jetpass.sequence;

/*Generated by MPS */

import jetbrains.jetpass.sequence.impl.SkipSequence;
import jetbrains.jetpass.sequence.impl.TakeSequence;
import jetbrains.jetpass.sequence.impl.TransformFunction;
import jetbrains.jetpass.sequence.impl.TransformSequence;
import jetbrains.jetpass.sequence.impl.FilterFunction;
import jetbrains.jetpass.sequence.impl.FilterSequence;
import jetbrains.jetpass.sequence.impl.ListSequence;
import java.util.Iterator;

public abstract class BaseSequence<T> implements Sequence<T> {
  protected BaseSequence() {
  }

  public Sequence<T> skip(int count) {
    return new SkipSequence<T>(this, count);
  }

  public Sequence<T> take(int count) {
    return new TakeSequence<T>(this, count);
  }

  public Sequence<T> query(String query) {
    throw new UnsupportedOperationException();
  }

  public Sequence<T> orderBy(String fieldName, Boolean asc) {
    throw new UnsupportedOperationException();
  }

  public <P> Sequence<P> select(TransformFunction<T, P> transform) {
    return new TransformSequence<T, P>(this, transform);
  }

  public Sequence<T> where(FilterFunction<T> filter) {
    return new FilterSequence<T>(this, filter);
  }

  public ListSequence<T> toListSequence() {
    return new ListSequence<T>(this);
  }

  public boolean isEmpty() {
    return !(isNotEmpty());
  }

  public T first() {
    Iterator<T> iter = iterator();
    return (iter.hasNext() ?
      iter.next() :
      null
    );
  }

  public boolean isNotEmpty() {
    return iterator().hasNext();
  }

  public boolean isQueriedSingleton() {
    return false;
  }
}
