package jetbrains.jetpass.sequence.impl;

/*Generated by MPS */

import jetbrains.jetpass.sequence.BaseSequence;
import jetbrains.jetpass.sequence.Sequence;
import java.util.Iterator;
import jetbrains.jetpass.sequence.iter.FilterIterator;

public class FilterSequence<T> extends BaseSequence<T> {
  protected final Sequence<T> input;
  protected final FilterFunction<T> filter;

  public FilterSequence(Sequence<T> input, FilterFunction<T> filter) {
    if (filter == null || input == null) {
      throw new IllegalArgumentException();
    }
    this.input = input;
    this.filter = filter;
  }

  public Iterator<T> iterator() {
    return new FilterIterator<T>(input.iterator()) {
      protected boolean matches(T item) {
        return filter.matches(item);
      }
    };
  }

  public int size() {
    int size = 0;
    for (T el : this) {
      size++;
    }
    return size;
  }
}
