package jetbrains.jetpass.sequence.impl;

/*Generated by MPS */

import jetbrains.jetpass.sequence.BaseSequence;
import java.util.Iterator;

public class IterableSequence<T> extends BaseSequence<T> {
  private final Iterable<T> source;
  private volatile int size = -1;

  public IterableSequence(final Iterable<T> source) {
    this.source = source;
  }

  public Iterator<T> iterator() {
    return source.iterator();
  }

  public int size() {
    if (size < 0) {
      // Is not calculated yet 
      int size = 0;
      for (Iterator<T> i = iterator(); i.hasNext(); size++) {
        i.next();
      }
      this.size = size;
    }
    return size;
  }
}
