package jetbrains.jetpass.sequence.impl;

/*Generated by MPS */

import jetbrains.jetpass.sequence.BaseSequence;
import java.util.List;
import java.util.ArrayList;
import java.util.Iterator;
import jetbrains.jetpass.sequence.Sequence;
import java.util.Arrays;

public class ListSequence<T> extends BaseSequence<T> {
  private final List<T> list;

  public ListSequence(final Iterable<T> source) {
    this(new ArrayList<T>());
    for (T el : source) {
      this.list.add(el);
    }
  }

  public ListSequence(final List<T> list) {
    this.list = list;
  }

  public ListSequence<T> toListSequence() {
    return this;
  }

  public Iterator<T> iterator() {
    return list.iterator();
  }

  public List<T> toList() {
    return list;
  }

  public int size() {
    return list.size();
  }

  @Override
  public String toString() {
    return list.toString();
  }

  public static <T> Sequence<T> fromIterable(Iterable<T> iterable) {
    if (iterable == null) {
      return EmptySequence.getInstance();
    } else if (iterable instanceof Sequence) {
      return (Sequence<T>) iterable;
    } else {
      return new ListSequence<T>(iterable);
    }
  }

  public static <T> Sequence<T> fromArray(T... array) {
    if (array == null || array.length == 0) {
      return EmptySequence.getInstance();
    } else {
      return new ListSequence<T>(Arrays.asList(array));
    }
  }
}
