package jetbrains.jetpass.sequence.impl;

/*Generated by MPS */

import jetbrains.jetpass.sequence.BaseSequence;
import jetbrains.jetpass.sequence.Sequence;
import java.util.Iterator;
import jetbrains.jetpass.sequence.iter.TransformIterator;

public class TransformSequence<E, U> extends BaseSequence<U> {
  protected Sequence<E> input;
  protected final TransformFunction<E, U> fun;

  public TransformSequence(Sequence<E> sequence, TransformFunction<E, U> fun) {
    this.input = sequence;
    this.fun = fun;
  }

  public Sequence<U> skip(int count) {
    return wrap(input.skip(count));
  }

  public Sequence<U> take(int count) {
    return wrap(input.take(count));
  }

  public boolean isEmpty() {
    return input.isEmpty();
  }

  public boolean isNotEmpty() {
    return input.isNotEmpty();
  }

  public Sequence<U> query(String query) {
    return wrap(input.query(query));
  }

  public Sequence<U> orderBy(String fieldName, Boolean asc) {
    return wrap(input.orderBy(fieldName, asc));
  }

  public int size() {
    return input.size();
  }

  protected TransformSequence<E, U> wrap(Sequence<E> source) {
    return new TransformSequence<E, U>(source, fun);
  }

  @Override
  public U first() {
    return fun.transform(input.first());
  }

  public Iterator<U> iterator() {
    return new TransformIterator<E, U>(input.iterator()) {
      protected U transform(E item) {
        return fun.transform(item);
      }
    };
  }

  @Override
  public boolean isQueriedSingleton() {
    return input.isQueriedSingleton();
  }
}
