package jetbrains.jetpass.sequence.iter;

/*Generated by MPS */

import java.util.Iterator;
import java.util.NoSuchElementException;

public abstract class FilterIterator<T> implements Iterator<T> {
  private final Iterator<T> source;
  private T bufferedNext;
  private boolean hasBufferedNext = false;

  public FilterIterator(final Iterator<T> source) {
    this.source = source;
  }

  public boolean hasNext() {
    while (!(hasBufferedNext) && source.hasNext()) {
      T next = source.next();
      if (matches(next)) {
        hasBufferedNext = true;
        bufferedNext = next;
      }
    }
    return hasBufferedNext;
  }

  public T next() {
    if (hasNext()) {
      T result = bufferedNext;
      hasBufferedNext = false;
      bufferedNext = null;
      return result;
    }
    throw new NoSuchElementException();
  }

  protected abstract boolean matches(T item);

  public void remove() {
    throw new UnsupportedOperationException();
  }
}
